function nmoldyn2_read, file_in
;+
;******* *************
;** User callable
;**
;** The call is e.g. w1=nmoldyn_read('filename')
;**
;** 27 May 2009
;** original nmoldyn_read for 2D data sets from nMoldyn 2
;-

id = NCDF_OPEN(file_in)
file_inq = NCDF_INQUIRE(id)
dim = file_inq.nvars
print, dim
if (dim ne 3) then print ,'not a 2D data set'

var0 = NCDF_VARINQ(id,0)
dsfid = NCDF_VARID(id,var0.name)
NCDF_VARGET,id,dsfid,x_data

var1 = NCDF_VARINQ(id,1)
dsfid = NCDF_VARID(id,var1.name)
NCDF_VARGET,id,dsfid,y_data

var2 = NCDF_VARINQ(id,2)
dsfid = NCDF_VARID(id,var2.name)
NCDF_VARGET,id,dsfid,data

NCDF_CLOSE,id

datp={x:x_data,y:y_data,w_tit:var0.name,x_tit: var1.name, y_tit:var2.name}

give_datp, datp
return, data

end
