pro msk128_brisp,H
;************************************
;
;	procedure called by brisp_center
;		FF 11/03/2009
;
; pro files creating an array H containing the bad tubes/pixels
; to be used in brisp_center to define the actual mask
;
;       to make the mask
; w2=mask_make(w10,/Stub,excluded=H)
;
; defined with vanadium data at 1 (24 hr) and 2 Ang (18 hr)
;
;     FF ( Apr 2008 )
;
;
; ============================================================
; ======================  CENTRAL DETECTOR BANK ==============
;
H = [       [  0, 16,  3,129] ] ; top strip of 3 pixels
H = [ [H] , [125, 16,  3,129] ] ; bottom strip of 3 pixels
;
H = [ [H] , [  0, 132,256,  2] ] ; tubes 133,134
H = [ [H] , [ 48,  39, 67,  1] ] ; part of tube 40
;
; ============================================================
; ===================  SIDE BANK (short tubes) ==============
;
H = [ [H] , [  0, 157,128,  1] ] ; tube 158
;
H = [ [H] , [  0,  12,128,  1] ] ; tube 13
H = [ [H] , [  0,  14,256,  1] ] ; tube 15
H = [ [H],  [ 72,   6, 25,  1] ] ; tube  7
;
H = [ [H] , [ 97,  0,  2, 16] ] ; left  side: bottom strip of 2 pixels
H = [ [H] , [ 30,  0,  2, 16] ] ; left  side: top    strip of 2 pixels
H = [ [H] , [ 97,144,  2, 16] ] ; right side: bottom strip of 2 pixels
H = [ [H] , [ 30,144,  2, 16] ] ; right side: top    strip of 2 pixels
;
; ============================================================
; =======  A FEW EDGES OF TUBES NOT WELL COUNTING ===========;
;
H = [ [H] , [124, 27,  2,  2] ]

end
