pro msk256,H
;+
;** ******
;**
;**	procedure called by brisp_center
;**		FF 11/03/2009
;**
;** pro files creating an array H containing the bad tubes/pixels
;** to be used in brisp_center to define the actual mask
;**
;**       to make the mask
;** w2=mask_make(w10,/Stub,excluded=H)
;**
;** defined with vanadium data at 1 (24 hr) and 2 Ang (18 hr)
;**
;**     FF ( Apr 2008 )
;**
;-

;
; ============================================================
; ======================  CENTRAL DETECTOR BANK ==============
;
H = [       [  0, 16,  6,129] ] ; top strip of 6 pixels
H = [ [H] , [250, 16,  6,129] ] ; bottom strip of 6 pixels
;
H = [ [H] , [  0, 132,256,  2] ] ; tubes 133,134
H = [ [H] , [ 95,  39,135,  1] ] ; part of tube 40
;
; ============================================================
; ===================  SIDE BANK (short tubes) ==============
;
H = [ [H] , [  0, 157,256,  1] ] ; tube 158
;
H = [ [H] , [  0,  12,256,  1] ] ; tube 13
H = [ [H] , [  0,  14,256,  1] ] ; tube 15
H = [ [H],  [145,   6,50,  1] ] ; tube  7
;
H = [ [H] , [193,  0,  4, 16] ] ; left  side: bottom strip of 4 pixels
H = [ [H] , [ 59,  0,  4, 16] ] ; left  side: top    strip of 4 pixels
H = [ [H] , [193,144,  4, 16] ] ; right side: bottom strip of 4 pixels
H = [ [H] , [ 59,144,  4, 16] ] ; right side: top    strip of 4 pixels
;
; ============================================================
; =======  A FEW EDGES OF TUBES NOT WELL COUNTING ===========;
;
H = [ [H] , [247, 27,  3,  2] ]

end
