pro sumnum2fileD1B,start,stop,step,base,extension=extension,temp=temp,comment=extracomment,logfile=logfile,normal=norma
;+
;** ***********
;** User callable
;** ????
;**
;** Started: Oct-2007 by J. Sanchez-Marcos, ILL-Grenoble
;** updated for new D1B numor format 2012 IPO
;-

;@lamp.cbk

IF not KEYWORD_SET(extracomment) THEN comment='' ELSE comment=string(extracomment)

IF not KEYWORD_SET(temp) THEN BEGIN
      tempfile=base+'.temp'
      OPENW,tempf,tempfile,/get_lun
      PRINTF,tempf,format='(A12,A12,A13,A13,A13)','First Numor','Last Numor','Sample','Regulator','Request'
ENDIF

  IF KEYWORD_SET(norma) THEN BEGIN
     comment=comment+'Norzalize'

  ENDIF



bufferfile=base+'.buf'
OPENW,bufferf,bufferfile,/get_lun

for i=start,stop-step+1 do begin
      print,'w1=rdrun('+string(i)+')'
      xicute,'w1=rdrun('+string(i)+')'
      take_datp,datp, w=1
      time=datp.n[1]
      timet=datp.n[1]
      IF  KEYWORD_SET(logfile) THEN BEGIN
          IF not datp.p[7] THEN BEGIN
              print, 'log,'+strcompress(string(i),/re)+','+strcompress(string(i),/re)+','+"'"+logfile+"',1"
              xicute, 'log,'+strcompress(string(i),/re)+','+strcompress(string(i),/re)+','+"'"+logfile+"',1"
              take_datp,datp, w=1
          ENDIF
      ENDIF

      tempsam=datp.p[7]
      tempreg=datp.p[6]
      tempreq=datp.p[5]
      tempsamm=datp.p[7]
      tempregm=datp.p[6]
      tempreqm=datp.p[5]
      print, tempsamm
      firstnum=i
  for j=1,step-1 do begin
         print,'w2=rdrun('+string(j+i)+')'
         xicute,'w2=rdrun('+string(j+i)+')'
         print,'w1=w1+w2'
         xicute,'w1=w1+w2'
         take_datp,datp, w=2
         IF  KEYWORD_SET(logfile) THEN BEGIN
             IF not datp.p[7] THEN BEGIN
                 print, 'log,'+strcompress(string(j+i),/re)+','+strcompress(string(j+i),/re)+','+"'"+logfile+"',2"
                 xicute, 'log,'+strcompress(string(j+i),/re)+','+strcompress(string(j+i),/re)+','+"'"+logfile+"',2"
                 take_datp,datp, w=2
             ENDIF
         ENDIF
         tempsamm=tempsamm+datp.p[7]
         tempregm=tempregm+datp.p[6]
         tempreqm=tempreqm+datp.p[5]
         timet=timet+datp.n[1]
  endfor
     tempsamm=tempsamm/step
     tempregm=tempregm/step
     tempreqm=tempreqm/step
     take_datp,datp, w=1
     datp.other_tit=datp.other_tit+' >'+strcompress(string(i+step-1))
     datp.p[7]=tempsamm
     print, datp.p[7]
     print, tempsamm
     datp.p[6]=tempregm
     datp.p[5]=tempreqm
     datp.p[11]=timet
     give_datp,datp, w=1
     lastnum=i+step

  IF KEYWORD_SET(norma) THEN BEGIN
     take_datp,datp, w=1

     normalize= float(norma)/float(datp.n[0])
     print, normalize
     xicute,'w1=w1*'+strcompress(string(normalize),/re)

     datp.n[0]=norma

     give_datp,datp, w=1
  ENDIF

  IF KEYWORD_SET(extension) THEN BEGIN
    IF KEYWORD_SET(temp) THEN BEGIN
      print,"d1breg,w1,'"+base+'_'+strcompress(string(i),/re)+'_'+strcompress(string(datp.p[7]),/re)+"','dat',comment='"+comment+"'"
      xicute,"d1breg,w1,'"+base+'_'+strcompress(string(i),/re)+'_'+strcompress(string(datp.p[7]),/re)+"','dat',comment='"+comment+"'"
      PRINTF,bufferf, base+'_'+strcompress(string(i),/re)+'_'+strcompress(string(datp.p[7]),/re)+'.dat'
    ENDIF ELSE BEGIN
      print,"d1breg,w1,'"+base+'_'+strcompress(string(i),/re)+"','dat',comment='"+comment+"'"
      xicute,"d1breg,w1,'"+base+'_'+strcompress(string(i),/re)+"','dat',comment='"+comment+"'"
      PRINTF,tempf,firstnum,lastnum,datp.p[7],datp.p[6],datp.p[5]
      PRINTF,bufferf,base+'_'+strcompress(string(i),/re)+'.dat'
    ENDELSE
  ENDIF ELSE BEGIN
    IF KEYWORD_SET(temp) THEN BEGIN
      print,"d1breg,w1,'"+base+'_'+strcompress(string(i),/re)+'_'+strcompress(string(datp.p[7]),/re)+"',comment='"+comment+"'"
      xicute,"d1breg,w1,'"+base+'_'+strcompress(string(i),/re)+'_'+strcompress(string(datp.p[7]),/re)+"',comment='"+comment+"'"
      PRINTF,bufferf, base+'_'+strcompress(string(i),/re)+'_'+strcompress(string(datp.p[7]),/re)+'.xy'
    ENDIF ELSE BEGIN
      print,"d1breg,w1,'"+base+'_'+strcompress(string(i),/re)+"',comment='"+comment+"'"
      xicute,"d1breg,w1,'"+base+'_'+strcompress(string(i),/re)+"',comment='"+comment+"'"
      PRINTF,tempf,firstnum,lastnum,datp.p[7],datp.p[6],datp.p[5]
      PRINTF,bufferf, base+'_'+strcompress(string(i),/re)+'.xy'
    ENDELSE
  ENDELSE

  i=i+step-1
endfor

IF not KEYWORD_SET(temp) THEN BEGIN
      FREE_LUN,tempf
ENDIF

FREE_LUN, bufferf

end
