FUNCTION read_eff, calib_file
;+
;******* ********
;**
;** User callable
;** routine to read efficiency table from a calibration file
;** call is w2=read_eff('calib_file')
;** w2 contains efficiency table in format as given by calib_eff routines
;-

eff_table=fltarr(128,128)

openr,f_in,calib_file,/get_lun

junk=''
;skip title and zones data
readf,f_in,junk ;skip title
while junk ne 'efficiencies' do begin
   readf,f_in,junk
endwhile
;read efficiencies
readf,f_in,eff_table
;close file
free_lun, f_in

return, eff_table

end


