function d4_q_interp,Win, dQ
;+
;******* ***********
;**
;** User callable
;** return data and Q in a regular grid
;-

TAKE_DATP,datp & Q=datp.X & ein=datp.E  ;Get variables from Win

nq  =n_elements(Q)
sens=-1 &  Qlen=Q[nq-1]-Q[0]
if Qlen lt 0 then Qlen=-Qlen else sens=1

if n_elements(dQ) ne 1 then  dQ=Qlen/nq ;dQ not passed
n   =round(Qlen/dQ)+1
Qreg=sens*findgen(n)*dQ +Q[0]
W=INTERPOL(Win,Q,Qreg,/quad)
if n_elements(ein) eq nq then E=INTERPOL(ein,Q,Qreg,/quad)

MOD_DATP,datp,'E',E & MOD_DATP,datp,'X',Qreg ;Replace E and X values
GIVE_DATP,datp ;Give variables back to Lamp
return, W      ;Return interpolated workspace
end

