FUNCTION tomatlab, w_in0, A, xaxis, yaxis, err
;+
;******* ********
;** User callable
;**
;** The call is w6=tomatlab(...)
;** How to manage workspace associated parameters: see 'INTERNALS'
;**        TAKE_DATP,datp     get W_params in datp as a structure
;**        MOD_DATP ,datp,'E',sqrt(w)      modify datp.e
;**        GIVE_DATP,datp     return datp
;-
 	TAKE_DATP, datp
;	CHECK_D7, w_in0, datp, 'Corr_xyz', stf, nspectra, nphases, nruns, TOF
s = size(w_in0)
mydata = FLTARR(s[1],s[2])
mydata = w_in0
myerrors=datp.e
myx = datp.x
myy = datp.y
OPENW, lun, A, /GET_LUN , WIDTH=10000    
printF, lun, mydata; 
Free_LUN, lun	

OPENW, lun,err, /GET_LUN , WIDTH=10000    
printF, lun, myerrors; 
Free_LUN, lun	

OPENW, lun, xaxis, /GET_LUN , WIDTH=10000    
printF, lun, myx; 
Free_LUN, lun	

OPENW, lun, yaxis, /GET_LUN , WIDTH=10000    
printF, lun, myy; 
Free_LUN, lun	

Wout = mydata

return, Wout
 
end
