PRO GAUSSIAN_FUNCT,X,AA,F,PDER
;+
;** **************
;** DIF stuff (D20)
;-


  ON_ERROR,2                ;Return to caller if an error occurs
	a=aa
    n = n_elements(a)
	ln2=alog(2.)
	sqrt8ln2=sqrt(8.*ln2)
	a[0]=2.*aa[0]/aa[2]*sqrt(ln2/!PI)
    if a[2] ne 0.0 then begin
		a[2]=aa[2]/sqrt8ln2
        Z = (X-A[1])/A[2]   ;GET Z
        EZ = EXP(-Z^2/2.)   ;GAUSSIAN PART
    endif else begin
        z = 100.
        ez = 0.0
    endelse
    case n of
        3:  F = A[0]*EZ
        4:  F = A[0]*EZ + A[3]
        5:  F = A[0]*EZ + A[3] + A[4]*X
        6:  F = A[0]*EZ + A[3] + A[4]*X + A[5]*X^2 ;FUNCTIONS.
    ENDCASE
    IF N_PARAMS(0) LE 3 THEN RETURN ;NEED PARTIAL?
    PDER = FLTARR(N_ELEMENTS(X),n) ;YES, MAKE ARRAY.
    PDER[*,0] = EZ  * a[0]/aa[0]     ;COMPUTE PARTIALS
    if a[2] ne 0. then PDER[*,1] = A[0] * EZ * Z/A[2]
    PDER[*,2] = PDER[*,1] * Z /sqrt8ln2 -a[0]/aa[2] *EZ
    if n gt 3 then PDER[*,3] = 1.
    if n gt 4 then PDER[*,4] = X
    if n gt 5 then PDER[*,5] = X^2
    RETURN
END
