; copied from d17summary by PG
; last changed on 07/11/2013 by PG for date
pro figarosummary,num1,num2
print,'run numbers: ',num1,num2


fil=strtrim(string(num1),2)+'-'+strtrim(string(num2),2)+'.txt'
print,'opening file:  ',fil
openw,unit,fil,/GET_LUN,width=120
printf,unit,'  run         subtitle  time san s2h  s3h str      sht2	date'
print,      '  run         subtitle  time san s2h  s3h str      sht2	date'


for num=num1,num2 do begin
close,3

; *** VITAL PARAMETERS, to be changed after each TOF calibration
openoff = 1.84  ;Opening offset, last changed 25.4.04
poff=279.4  ;POFF, last changed 25.4.04
d0=4.1685   ;First chopper-sample distance, last changed ...

; *** Initialize variables
dpr=180./!pi
par1 = fltarr(128)
par2 = fltarr(256)
txt=sindgen(25)
txt[*]='XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'
txt1=txt[1]

; *** Read in the data
;path='/users/data/'
;path='/Users/newuser/Dropbox/Data/guests/MuellerBuschbaum/201305FIGARO/RawData/'
path=''
if strlen(string(strtrim(num,2))) eq 1 then name=path+'00000'+string(strtrim(num,2))
if strlen(string(strtrim(num,2))) eq 2 then name=path+'0000'+string(strtrim(num,2))
if strlen(string(strtrim(num,2))) eq 3 then name=path+'000'+string(strtrim(num,2))
if strlen(string(strtrim(num,2))) eq 4 then name=path+'00'+string(strtrim(num,2))
if strlen(string(strtrim(num,2))) eq 5 then name=path+'0'+string(strtrim(num,2))
if strlen(string(strtrim(num,2))) eq 6 then name=path+string(strtrim(num,2))

openr,3,name
;print,'opened: ',name
readf,3,txt
readf,3,txt1
titles=txt1
tit='xxxxxxxxxxxxxxxxxxxx'
tit=strmid(titles,57,20)
;print,'sub title= ',tit
readf,3,txt1

dat='xxxxxxxxxxxxxxxxxxxx'
dates=txt1
dat=strmid(dates,0,20)
;print,'dates= ',dat
for i=0,4 do readf,3,txt1
time=txt1	;PG:does not work...
readf,3,txt1
readf,3,txt1
readf,3,par1
readf,3,txt1
readf,3,txt1
readf,3,par2
nx=par1[101]

; inter chopper distance is cht
cht=par2[14]/1000.0
period=60./par2[44]

chopsam=d0-cht/2.

; ***Requested (openr) and actual (opena) chopper angles
openr=45.-(par2[43]-par2[41])
opena=45.-(par2[47]-par2[45])

;opena=opena-openoff
dela=(poff-opena)/2.    ;***delay time
delt=(dela/360.)*period ;***delay angle


tofd=chopsam+(par2[15]/1000.)
chanpa=(tofd/3956.)/(par1[95]*1e-6)
chanpam=(chopsam/3956.)/(par1[95]*1e-6)
r=chopsam/tofd
delchan=delt/(par1[95]*1e-6)
delechan=par1[96]/par1[95]

time=par1[2]
dan=par2[16]
dett=par2[15]
;s2w=par2(93)
;s3w=par2(95)
s2h=par2[7]+par2[8]
s3h=par2[14]+par2[15]
sht2=par2[19]
str=par2[20]
;s3h=par2(98)
;s1h=par2(92)
san=par2[21]
;op=par2(45)
readf,3,txt1
readf,3,txt1
readf,3,txt1
;readf,3,tot
tsize=long(par1[94])
xsize=long(par1[98]-par1[97]+1)
ysize=long(par1[100]-par1[99]+1)
dsize=xsize*ysize
tsam=par1[29]
trsoff=par2[125]
phioff=par2[127]
sanoff=par2[124]

printf,unit,num,tit,time,san,s2h,s3h,str,sht2,dat,format='(i6,2x,a20,2x,a20,2x,a20,2x,a20,2x,a20,2x,a20,2x,f7.2,2x,a20)'
print,num,tit,time,san,s2h,s3h,str,sht2,dat,format=      '(i6,2x,a20,2x,a20,2x,a20,2x,a20,2x,a20,2x,a20,2x,f7.2,2x,a20)'
endfor
close,unit
return
end

