pro model_linearfit , UserModl     ;Start (procedure)
;+
;** ******
;** str_fit model
;-
UserModl=0 ;return "UserModl" as a structure

nfunc=       1 ;number of functions
npar =       2 ;maximum number of parameters
umON =intarr(nfunc) & umNPAR=umON & umNAME=strarr(nfunc) & umFORMULA=umNAME
umPARAMS=fltarr(npar,nfunc) & umFIXP=intarr(npar,nfunc)  & umQEXP=strarr(npar,nfunc)
umBOUNDa=umFIXP & umBOUNDb=umFIXP & umLIMITa=umPARAMS    & umLIMITb=umPARAMS
umFIXP[*]=1
;Functions:
;**********
 umNAME[     0]='Formula' & umON[0]=1  & umNPAR[0]=2
 umFORMULA[  0]='y=p1+p2*x'
 umFIXP[   0,0]=[0 , 0]
 umPARAMS[ 0,0]=[0. , -0.08]
 umBOUNDa[ 0,0]=[0 , 0]
 umLIMITa[ 0,0]=[0. , 0.]
 umBOUNDb[ 0,0]=[0 , 0]
 umLIMITb[ 0,0]=[0. , 0.]
;**********

Resolution=0      ;0=none 1=Wrkspace 2=Gauss 3=Voigt 4=Spectrum
Bose      =0.      ;if >0 -> activate detailed balance factor
Follow    =0      ;2=2d_fit 0=initial params for all  1 or-1=use previous fit and go 1>N or N>1
BkgdMod   =0      ;0=flat 1=linear 2=quadratic
BkgdFix   =1      ;0=unfixed flat background 1=fixed
BkgdValue =0.      ;used if flat background is fixed

;Do not wrap next 3 lines
u1=umON & u2=umNAME & u3=umNPAR & u4=umPARAMS & u5=umFIXP & u6=umBOUNDa & u7=umBOUNDb & u8=umLIMITa & u9=umLIMITb
v1=umFORMULA & v2=umQEXP & v3=Bose & v4=FOLLOW & v5=Resolution & v6=BkgdMod & v7=BkgdFix & v8=BkgdValue
UserModl={ON:u1,NAME:u2,NPAR:u3,PARAMS:u4,FITP:u5,BOUNDA:u6,BOUNDB:u7,LIMITA:u8,LIMITB:u9,FORMULA:v1,QEXP:v2,BOSE:v3,FOLLOW:v4,RESOLUTION:v5,BKGDmod:v6,BKGDfix:v7,BKGDvalue:v8}

end ;(procedure)
