; V = linspace(BASE, LIMIT, N)
;
; Provides a row vector V with N linearly spaced elements 
; between BASE and LIMIT;

function linspace, base,limit,n

v = base + findgen(n)*(limit-base)/(n-1);

return,  v

end

