pro temp_his,firstrun,lastrun,TIME=TIME,T_MEAN=t_mean,T_STD=t_std,W=W
;+
;** ********
;** User callable
;** Time log of a setof runs
;-

    if (n_elements(TIME) NE 0) THEN plot_time=1 ELSE plot_time=0
    nrun=lastrun-firstrun+1 ; nbre de runs
    temp=fltarr(nrun) & duration=temp
    listrun=findgen(nrun)+firstrun
    ind=0
    for ir=firstrun,lastrun do begin
        a = STRCOMPRESS(STRING(ir),/remove_all)
        XICUTE, 'w61 = rdrun('+a+')'
        TAKE_DATP, datp
        ;    help,datp
        ;    help,datp.P
        ;    help,datp.PV
        temp[ind] = datp.p[11]
        duration[ind] = datp.p[0]
        ind=ind+1
    endfor
    weight=temp*duration
    t_mean=total(weight)/total(duration)
    mean_temp2=total(temp*weight)/total(duration)
    t_std=sqrt(mean_temp2-t_mean^2)
    print,'Temperatures:',temp
    print,'mean value of Temp: ',t_mean
    print,'standard deviation: ',t_std
    print,listrun
    if (n_elements(W) NE 0) THEN begin
        print,'Results in W',W
        mod_datp,datp,'PV',[t_mean,t_std]
        mod_datp,datp,'X',listrun
        mod_datp,datp,'X_TIT','Run #'
        mod_datp,datp,'Y_TIT','Temp (K)'
        give_w,temp,w=W
        give_datp,datp,W=W
    endif
    
;   XICUTE, 'w6 = remove_spectra(w2,' + zeroed + ')'
;   XICUTE, 'z6 = y3'
;   XICUTE, 'w7 = TOTAL(w6,2)'
;   XICUTE, 'y7 = w40'
;   XICUTE, 'y_tit(7) = "' + axe + ' ' + unit + '"'
;   XICUTE, 'see, w4'
    
END
