pro export_json, struct ,filename=file, gzip=gzip
;+
;** ***********
;** Writes a structure or Hash or List in a file
;-

fifi = file

if strpos(fifi,'.gz') gt 0  then gzip=1 $
  else if keyword_set(gzip) then fifi=fifi+'.gz' $
                            else gzip=0
on_ioerror,misjson & u=-1
  
openw, u,fifi, /get_lun, compress=gzip

printf,u, json_serialize(struct)

misjson: if u le 0 then lamp_error else free_lun,u
end
