pro inx_event, event,uv
;+
;** *********
;** event handler, call didline to do the work
;-
@lamp.cbk
common c_inx, inx_base,iws,iwv,iwe,iwc,iwr,its,itv,islab,ilo,ith0,ith1,ith2,ialph,ires,ibgmod
common c_in1, itc,ite,ratio,iom0,iom1,iom2,DWt,iwf,ixmu,iRP,Dspc

if uv[2] eq 1 then begin

   on_ioerror,mis
   text='? Bad workspace number... '
   widget_control,bad_id=i,uv[3] ,get_value=str & str=strlowcase( str[0])
          iws   =strmid(str,strpos(str,'w')+1,10)  & nws=fix(strtrim(iws   ,2))
   widget_control,bad_id=i,uv[5] ,get_value=str & str=strlowcase( str[0])
          iwe   =strmid(str,strpos(str,'w')+1,10)  & nwe=fix(strtrim(iwe   ,2))
   widget_control,bad_id=i,uv[6] ,get_value=str & str=strlowcase( str[0])
          iwr   =strmid(str,strpos(str,'w')+1,10)  & nwr=fix(strtrim(iwr   ,2))
   widget_control,bad_id=i,uv[7] ,get_value=str & str=strlowcase( str[0])
          iwv[0]=strmid(str,strpos(str,'w')+1,10)  & nwv=fix(strtrim(iwv[0],2))
   widget_control,bad_id=i,uv[15],get_value=str & str=strlowcase( str[0])
          iwv[1]=strmid(str,strpos(str,'w')+1,10)  & nwd=fix(strtrim(iwv[1],2))
   widget_control,bad_id=i,uv[11],get_value=str & str=strlowcase( str[0])
          iwc   =strmid(str,strpos(str,'w')+1,10)  & nwc=fix(strtrim(iwc   ,2))
   widget_control,bad_id=i,uv[23],get_value=str & str=strlowcase( str[0])
          iwf   =strmid(str,strpos(str,'w')+1,10)  & nwf=fix(strtrim(iwf   ,2))

   text='? Bad transmission value... '
   widget_control,bad_id=i,uv[4] ,get_value=str & str=str[0] & nts =float(str)>0.<1. & its  =str
   widget_control,bad_id=i,uv[8] ,get_value=str & str=str[0] & ntv =float(str)>0.<1. & itv  =str
   widget_control,bad_id=i,uv[16],get_value=str & str=str[0] & ntc =float(str)>0.<1. & itc  =str
   widget_control,bad_id=i,uv[17],get_value=str & str=str[0] & nte =float(str)>0.<1. & ite  =str

   text='? Bad discrimination factor... '
   widget_control,bad_id=i,uv[10],get_value=str & str=str[0] & nlo =float(str)/100   & ilo  =str

   text='? Bad removed spectrum... '
   widget_control,bad_id=i,uv[26],get_value=str  & str=strcompress(str[0],/remove_all)
   if str gt '' then begin & rspc=strsplit(/EXTRACT,str,',') & ids=strpos(rspc,'>')
                           for i=0,n_elements(ids)-1 do if ids[i] gt 0 then begin & p=ids[i]
                                                   tmp1=strmid(rspc[i],0,p)
                                                   tmp2=strmid(rspc[i],p+1,10)
                                                   rspc[i]=tmp1 & rspc=[rspc,tmp2] & endif
                           idx=where(rspc eq '') & if idx[0] ge 0 then rspc[idx]='a'
                           rspc=long(rspc) & Dspc =str
   endif else Dspc=''

   text='? Bad Scattering/Total Xsection incident ratio... '
   widget_control,bad_id=i,uv[21],get_value=str & str=str[0] & nrat=float(str)>0.<1. & ratio=str

   text='? Bad Debye-Waller temperature for sample... '
   widget_control,bad_id=i,uv[22],get_value=str & str=str[0] & ndwt=float(str)>0.    & DWt  =str

   text='? Bad slab angle... ' & nalph=0
   if islab eq 1 then begin & widget_control,bad_id=i,uv[14],get_value=str & str=str[0]
                         nalph=float(str) & ialph=strcompress(str) & endif

   text='? Bad Xmu value... '  & nxmu=0
   if islab eq 2 then begin & widget_control,bad_id=i,uv[24],get_value=str & str=str[0]
                         nxmu =float(str) & ixmu =strcompress(str) & endif

   text='? Bad RP value... '   & nRP=0
   if islab eq 2 then begin & widget_control,bad_id=i,uv[25],get_value=str & str=str[0]
                         nRP  =float(str)>0.<1. & iRP =strcompress(str) & endif

   text=''
   on_ioerror,norange & n=-444 & nth1=n & nth2=n
   widget_control,bad_id=i,uv[12],get_value=str & str=str[0] & nth1=float(str)    & ith1=strcompress(str)
   widget_control,bad_id=i,uv[13],get_value=str & str=str[0] & nth2=float(str)    & ith2=strcompress(str)
   str=''
   norange:if (nth1 eq n) or (nth2 eq n) or (nth1 ge nth2)  then  begin
               if ith0 eq 1 then text='? Bad angle range values...'
               nth1=0 & nth2=0
           endif else   if ith0 eq 0 then begin & nth1=0 & nth2=0 & endif

   text=''
   on_ioerror,norango & n=-444 & nom1=n & nom2=n
   widget_control,bad_id=i,uv[18],get_value=str & str=str[0] & nom1=float(str)    & iom1=strcompress(str)
   widget_control,bad_id=i,uv[19],get_value=str & str=str[0] & nom2=float(str)    & iom2=strcompress(str)
   str=''
   norango:if (nom1 eq n) or (nom2 eq n) or (nom1 ge nom2)  then  begin
               if iom0 eq 1 then text='? Bad energie range values...'
               nom1=0 & nom2=0
           endif else   if iom0 eq 0 then begin & nom1=0 & nom2=0 & endif

   if (nws gt lamp_sys) or (nwe gt lamp_sys) or  (nwr gt lamp_sys) or (nwd gt lamp_sys) or $
                 (nwv gt lamp_sys) or  (nwc gt lamp_sys) then text='? Workspace gt '+strtrim(lamp_sys,2)+'... '
   if (nwr le 0 ) then  text='? Resulting workspace must be specified... '
   if (nws le 0 ) then  text='? Sample workspace must be specified... '
   mis:
   if text ne ''  then  widget_control,bad_id=i,uv[9],set_value=text+str  $
   else begin
        widget_control,bad_id=i,uv[9],set_value='Working ...'
        ibgm=ibgmod[0]+ibgmod[1]*2+ibgmod[2]*4+ibgmod[3]*8
        wk  =[nwr,nws,nwv,nwe,nwc,nwd,nwf] & wks = strtrim(string(wk),2)
        uv9 = strtrim(string(uv[9]),2)+'L' & uv20= strtrim(string(uv[20]),2)+'L'
        rt  =[nts,ntv,islab,nlo,nth1,nth2,ires,ibgm,nalph,ntc,nte,nrat,nom1,nom2,ndwt,nxmu,nrp]
        rtp = strtrim(string(rt,format='(f7.3)'),2)
        taxt='w'+wks[0]+'=didline(samp='+wks[1]+',vana=' +wks[2]+',empty='+wks[3]+',canva='+wks[4]          + $
                  ',cadm='+wks[5]+',resol='+wks[6]+',trans_abs=['+rtp[0]+','+rtp[1]+','+rtp[2]+ $
                  ','+ rtp[3] +','+rtp[4]+',' +rtp[5] +','+rtp[6] +',' +rtp[7] +',' +rtp[8]   + $
                  ','+ rtp[9] +','+rtp[10]+','+rtp[11]+','+rtp[12]+',' +rtp[13]+',' +rtp[14]  + $
                  ','+ rtp[15]+','+rtp[16]+']'
        if n_elements(rspc) gt 0 then taxt=taxt+",remove='"+Dspc+"'"
        text=taxt+',bmess='+uv9+',bflow='+uv20+',/draw)'
        XICUTE,text
        to_don_history,-1,0,taxt+')'
        widget_control,bad_id=i,event.top,/destroy
   endelse

endif
if uv[2] eq 2 then begin & islab  = uv[3] & widget_control,uv[4],get_uvalue=bmap
                         for i=0,n_elements(bmap)-1 do if bmap[i] gt 0 then widget_control,bmap[i],map=0
                         if bmap[islab] gt 0 then widget_control,bmap[islab],map=1
                   endif
if uv[2] eq 3 then ith0   = event.select
if uv[2] eq 4 then if event.select then ires=ires+1 else ires=ires-1
if uv[2] eq 5 then ibgmod[uv[3]] = event.select
if uv[2] eq 6 then iom0   = event.select
if uv[2] eq 7 then if event.select then ires=ires+2 else ires=ires-2

return
end

pro inx ,o,t
;+
;** ***
;** User callable
;** input gui for tof corrections (in middle nineties!)
;-
@lamp.cbk
common c_inx
common c_in1

i=xregistered('Inx')
if i le 0 then begin

if n_elements(iws) eq 0 then begin
   iws=' 0  '  & iwv=[' 0  ',' 0  ']       & iwe=' 0  '  & iwc=' 0  ' & iwr=' 0  ' & ires=0  & ialph='      '
   its=' 0.90' & itv=' 0.85' & itc=' 1.0 ' & ite=' 1.0 ' & islab=0    & ilo='10.'  & ith0=0  & ith1 ='      '
   ith2 ='      ' & ratio=' .0' & iom0=0   & iom1='      ' & iom2='      ' & DWt=' 0  ' & iwf=' 0  '
   ibgmod=intarr(4) & ibgmod[0]=1 & ixmu='     ' & iRP='    ' & Dspc='   '
endif

if n_elements(o) eq 1 then begin & iws=strtrim(string(t),2) & iwr=strtrim(string(o),2) & endif
if lamp_siz ge  900 then p_set_font,1
if sys_dep('MACHINE') eq 'win' then cap=3 else cap=0

inx_base =widget_base(  title='Lamp TOF reduction parameters',/column,resource_name='lamp')

base =widget_base(  inx_base,/column,resource_name='mic')
blab =widget_label( base  ,value='p(2):doppler p(9):ElasPos p(11):Temp p(18):ChnWdth p(21):WaveL p(27):Dist',font=ft_normal)
bsamp=widget_base(  base  ,/row)
blab =widget_label( bsamp ,value='Sample workspace'      ,font=ft_b_bigger)
bsamw=widget_text(  bsamp ,value=iws    ,/editable       ,font=ft_propor  ,xsize=4+cap,ysize=1)
blab =widget_label( bsamp ,value='Transmission'          ,font=ft_b_bigger)
bsamt=widget_text(  bsamp ,value=its    ,/editable       ,font=ft_propor  ,xsize=8,ysize=1)

bempt=widget_base(  base  ,/row)
blab =widget_label( bempt ,value='Empty-C workspace'     ,font=ft_b_bigger)
bempw=widget_text(  bempt ,value=iwe    ,/editable       ,font=ft_propor  ,xsize=4+cap,ysize=1)
blab =widget_label( bempt ,value='Transmission'          ,font=ft_b_bigger)
bcant=widget_text(  bempt ,value=itc    ,/editable       ,font=ft_propor  ,xsize=8,ysize=1)

bvana=widget_base(  base  ,/row)
blab =widget_label( bvana ,value='Vanadium workspace'    ,font=ft_b_bigger)
bvanw=widget_text(  bvana ,value=iwv[0] ,/editable       ,font=ft_propor  ,xsize=4+cap,ysize=1)
blab =widget_label( bvana ,value='Transmission'          ,font=ft_b_bigger)
bvant=widget_text(  bvana ,value=itv    ,/editable       ,font=ft_propor  ,xsize=8,ysize=1)

bvaca=widget_base(  base  ,/row)
blab =widget_label( bvaca ,value='Empty-Van workspace'   ,font=ft_b_bigger)
bvanc=widget_text(  bvaca ,value=iwc    ,/editable       ,font=ft_propor  ,xsize=4+cap,ysize=1)
blab =widget_label( bvaca ,value='Transmission'          ,font=ft_b_bigger)
bcavt=widget_text(  bvaca ,value=ite    ,/editable       ,font=ft_propor  ,xsize=8,ysize=1)

bcadi=widget_base(  base  ,/row)
blab =widget_label( bcadi ,value='Cadmium input worksp'  ,font=ft_b_bigger)
bcadm=widget_text(  bcadi ,value=iwv[1] ,/editable       ,font=ft_propor  ,xsize=4+cap,ysize=1)

bresu=widget_base(  base  ,/row)
blab =widget_label( bresu ,value='RESULTING Sample wksp' ,font=ft_b_bigger)
bresw=widget_text(  bresu ,value=iwr    ,/editable       ,font=ft_propor  ,xsize=4+cap,ysize=1)
blab =widget_label( bresu ,value=', Resolution'          ,font=ft_b_bigger)
bresf=widget_text(  bresu ,value=iwf    ,/editable       ,font=ft_propor  ,xsize=4+cap,ysize=1)

blab =widget_label( base  ,value=' ')

base =widget_base(  inx_base,/column,resource_name='did')
bratt=widget_base(  base  ,/row)
blab =widget_label( bratt ,value='Scattering/Total cross-section Ratio',font=ft_b_bigger)
brato=widget_text(  bratt ,value=ratio ,/editable         ,font=ft_propor  ,xsize=4+cap,ysize=1)

bdwts=widget_base(  base  ,/row)
blab =widget_label( bdwts ,value='Debye-Waller temperature  for sample',font=ft_b_bigger)
bdwt =widget_text(  bdwts ,value=DWt  ,/editable          ,font=ft_propor  ,xsize=4+cap,ysize=1)

bslab=widget_base(  base  ,/row)
blab =widget_label( bslab ,value='Absorption'             ,font=ft_b_bigger)
btog =widget_base(  bslab ,/column,/exclusive)
ntog =3
btg  =lonarr(ntog)
blab =['None','Slab','Cylinder']
for i=0,ntog-1 do btg[i]=widget_button(btog ,value=blab[i],font=ft_propor,/no_release,$
                                   uvalue=[-88L,341,2,i,btog])
bform=widget_base(  bslab)
bslab=widget_base(  bform ,/column,map=0)
blab =widget_label( bslab ,value='Angle:',font=ft_b_bigger)
balph=widget_text(  bslab ,value= ialph  ,/editable       ,font=ft_propor  ,xsize=6,ysize=1)

bcyl =widget_base(  bform ,/column,map=0)
blab =widget_label( bcyl  ,value='Linear Absorption Rext* mu',font=ft_b_bigger)
blab =widget_label( bcyl  ,value='Radius ratio (Rint/ext) Rp',font=ft_b_bigger)
rcyl =widget_base(  bcyl  ,/row)
blab =widget_label( rcyl  ,value='muR'                       ,font=ft_b_bigger)
bxmu =widget_text(  rcyl  ,value= ixmu  ,/editable           ,font=ft_propor  ,xsize=5,ysize=1)
blab =widget_label( rcyl  ,value=' Rp[0:1]'                  ,font=ft_b_bigger)
birp =widget_text(  rcyl  ,value= irp   ,/editable           ,font=ft_propor  ,xsize=4,ysize=1)
uslab=[0L,bslab,bcyl] & widget_control, btog, set_uvalue=uslab

;blab =widget_label (base  ,value='...............'       ,font=ft_propor)

base =widget_base(  inx_base,/column,resource_name='don')
btlow=widget_base(  base  ,/row)
blab =widget_label( btlow ,value='Discrimination factor for bad spectrum (%)' ,font=ft_b_bigger)
bdisc=widget_text(  btlow ,value=ilo    ,/editable        ,font=ft_propor  ,xsize=4+cap,ysize=1)
btlow=widget_base(  base  ,/row)
blab =widget_label( btlow ,value='Other bad spectra "1>3,5,8>9"',font=ft_b_bigger)
bdspc=widget_text(  btlow ,value=Dspc   ,/editable        ,font=ft_propor  ,xsize=17+cap,ysize=1)

bteta=widget_base(  base  ,/row)
btete=widget_base(  bteta ,/nonexclusive)
btetb=widget_button(btete ,value='Use 2*Theta range from' ,font=ft_b_bigger,uvalue=[-88,341,3])
btet1=widget_text(  bteta ,value=ith1,/editable           ,font=ft_propor  ,xsize=6+cap,ysize=1)
blab =widget_label( bteta ,value='to'                     ,font=ft_b_bigger)
btet2=widget_text(  bteta ,value=ith2,/editable           ,font=ft_propor  ,xsize=6+cap,ysize=1)
;blab =widget_label (base  ,value='You should get regular bin width from minima dE,dQ',font=ft_b_bigger)
bomeg=widget_base(  base  ,/row)
bomex=widget_base(  bomeg ,/nonexclusive)
bomeb=widget_button(bomex ,value='Use Energy  range from' ,font=ft_b_bigger,uvalue=[-88,341,6])
bome1=widget_text(  bomeg ,value=iom1,/editable           ,font=ft_propor  ,xsize=6+cap,ysize=1)
blab =widget_label( bomeg ,value='to'                     ,font=ft_b_bigger)
bome2=widget_text(  bomeg ,value=iom2,/editable           ,font=ft_propor  ,xsize=6+cap,ysize=1)

;blab =widget_label (base  ,value='.....................'            ,font=ft_propor)

base =widget_base(  inx_base,/column,resource_name='did')
baso =widget_base(  base    ,/row)
bid  =widget_label( baso    ,value="Align from: ",font=ft_b_bigger)
bbgmo=widget_base(  baso    ,/row,/nonexclusive)
bbgm1=widget_button(bbgmo   ,value='vana'        ,font=ft_b_normal,uvalue=[-88,341,5,0])
bbgm2=widget_button(bbgmo   ,value='sample'      ,font=ft_b_normal,uvalue=[-88,341,5,1])
bbgm3=widget_button(bbgmo   ,value='empty!'      ,font=ft_b_normal,uvalue=[-88,341,5,2])
bbgm4=widget_button(bbgmo   ,value='empty_v!'    ,font=ft_b_normal,uvalue=[-88,341,5,3])

breso=widget_base(  base  ,/row,/nonexclusive)
bresb=widget_button(breso ,value='Symmetrical (bose)' ,uvalue=[-88,341,4],font=ft_b_bigger)
bress=widget_button(breso ,value='Smooth background'  ,uvalue=[-88,341,7],font=ft_b_bigger)

berr =widget_label( base  ,value='_____________________________________________________',font=ft_propor)
bflow=widget_label( base  ,value='_____________________________________________________',font=ft_propor)

uv   =[-88,341,1,bsamw,bsamt,bempw,bresw,bvanw,bvant,berr,bdisc,bvanc,btet1,btet2,balph,bcadm]
uv   =[uv ,bcant,bcavt,bome1,bome2,bflow,brato,bdwt,bresf,bxmu,birp,bdspc]
bgo  =widget_button(base  ,value='NEXT STEP' ,uvalue=uv,font=ft_b_bigger)
bexit=widget_button(base  ,value='CANCEL'    ,uvalue=[-88,399])

widget_control , btg[islab],set_button=1 & if islab gt 0 then widget_control,uslab[islab],map=1
widget_control , btg[2]    ,sensitive =1
widget_control , btetb     ,set_button=ith0
widget_control , bomeb     ,set_button=iom0
widget_control , bbgm1     ,set_button=ibgmod[0]
widget_control , bbgm2     ,set_button=ibgmod[1]
widget_control , bbgm3     ,set_button=ibgmod[2]
widget_control , bbgm4     ,set_button=ibgmod[3]
if (ires eq 1) or (ires eq 3) then widget_control , bresb,set_button=1
if (ires eq 2) or (ires eq 3) then widget_control , bress,set_button=1
widget_control , inx_base  ,group_leader=lamp_b1,/realize
if lamp_siz ge 900 then p_set_font,0

XMANAGER, 'Inx', inx_base  ,event_handler='LAMP_EVENT_PARSER',/just_reg

endif else widget_control,bad_id=i,inx_base,map=1

return
end
