function read_nexus, INST , PATH , FILENAME , STATUS , DATP , datp=rdp
;+
;******* **********
;** call READ_HDF
;**	Standard call for a data-read function interfacing LAMP.
;** or
;** W1=read_nexus('fileName' ,datp=rdp) ;2nd call
;-

if not arg_present(DATP) then begin & FILENAME=INST & INST='' & endif ;2nd call
if n_elements(PATH) ne 1 then       PATH=''

if  strpos(FILENAME[0],'.')  lt 0 then ext='.nxs' else ext=''

rdset,GetNodata=nodata & if nodata then DATA =-88 else DATA = 0 ; -88 means return only parameters

if n_elements(STATUS) eq 1  then if STATUS le -77 then ext=''   ; Comming from rdid ('.nxs' in filename)
if n_elements(STATUS) eq 1  then if STATUS eq -88 then DATA=-88 ; Comming from rdid (NODATA)
STATUS=24
if !version.release lt '4.0' then begin & print,"IDL version is too low !!!",string(7b) & return,DATA & endif
FileN=PATH+FILENAME[0]+ext
if n_elements(FILENAME) gt 1 then img=FILENAME[1] else img=1

i=strpos(FileN,'{') & if i gt 1 then begin & j=strpos(FileN,'}')
                         if j gt i+1  then img=strmid(FileN,i+1,j-i-1)
                         FileN=strmid(FileN,0,i) & endif
src=INST
read_hdf, FileN    , Data, XC=x, YC=y , ZC=z , E=e  , N=n        $
                         , PR=p, PV=pv, PAR_TXT=p_txt            $
                         , W_tit=wt   , X_tit=xt , Y_TIT=yt      $
                         , Z_tit=zt   , OTHER_TIT=ot , SNAP=snap $
                         , SOURCE=src , Img=img

if n_elements(Data) gt 1 then STATUS=0

DATP={X:      x   , Y:y , Z:z , E:e , N:n   ,$
      W_TIT:  wt  , X_TIT:xt  , Y_TIT:yt    ,$
      Z_TIT:  zt  , OTHER_TIT:ot            ,$
      P:      p   ,    $
      PAR_TXT:p_txt,   $
      PV:     pv       }
;     **********************
if INST[0] eq '' then GIVE_DATP,datp ;2nd call
if arg_present(rdp) then rdp=datp

 RETURN, temporary(DATA)
;************
 END

