FUNCTION READ_PAR , inst ,path, filename, status, datp
;-----------------------------------------------------

CASE inst OF 

'demo'	: RETURN,read_tmp	(['demo',' ']	,path,filename,status,datp)
'IN4'	: RETURN,rdid		(['IN4','TOF']	,path,filename,status,datp)
'IN5'	: RETURN,rdid		(['IN5','TOF']	,path,filename,status,datp)
'IN6'	: RETURN,rdid		(['IN6','TOF']	,path,filename,status,datp)
'IN10'	: RETURN,rdid		(['IN10','TOF']	,path,filename,status,datp)
'IN13'	: RETURN,rdid		(['IN13','TOF']	,path,filename,status,datp)
'IN16'	: RETURN,rdid		(['IN16','TOF']	,path,filename,status,datp)
'D7'	: RETURN,rdid		(['D7','TOF']	,path,filename,status,datp)
'BRISP'	: RETURN,read_nexus	(['BRISP','TOF'],path,filename,status,datp)
'D11'	: RETURN,rdid		(['D11','LSS']	,path,filename,status,datp)
'D17'	: RETURN,rdid		(['D17','LSS']	,path,filename,status,datp)
'D22'	: RETURN,rdid		(['D22','LSS']	,path,filename,status,datp)
'PN1'	: RETURN,pn1		(['PN1','NFP']	,path,filename,status,datp)
'INX'	: RETURN,inx_in		(['INX','TOF']	,path,filename,status,datp)
'D1B'	: RETURN,rdid		(['D1B','DIF']	,path,filename,status,datp)
'IN8'	: RETURN,rdid		(['IN8','3Axes'],path,filename,status,datp)
'D19'	: RETURN,rdid		(['D19','DIF']	,path,filename,status,datp)
'D9'	: RETURN,rdid		(['D9','DIF']	,path,filename,status,datp)
'D1A'	: RETURN,rdid		(['D1A','DIF']	,path,filename,status,datp)
'D16'	: RETURN,rdid		(['D16','LSS']	,path,filename,status,datp)
'DB21'	: RETURN,rdid		(['DB21','LSS']	,path,filename,status,datp)
'IN1'	: RETURN,rdid		(['IN1','3Axes'],path,filename,status,datp)
'Column'	: RETURN,read_column	(['Column',' ']	,path,filename,status,datp)
'lamp'	: RETURN,rlamp		(['lamp',' ']	,path,filename,status,datp)
'IN14'	: RETURN,rdid		(['IN14','3Axes'],path,filename,status,datp)
'IN20'	: RETURN,rdid		(['IN20','3Axes'],path,filename,status,datp)
'D2B'	: RETURN,rdid		(['D2B','DIF']	,path,filename,status,datp)
'D20'	: RETURN,rdid		(['D20','DIF']	,path,filename,status,datp)
'D11tof'	: RETURN,rdid		(['D11tof','LSS'],path,filename,status,datp)
'XRAY'	: RETURN,rdspe		(['XRAY','LON']	,path,filename,status,datp)
't13a'	: RETURN,rdid		(['t13a','LON']	,path,filename,status,datp)
't13c'	: RETURN,rdid		(['t13c','LON']	,path,filename,status,datp)
'NeXus'	: RETURN,read_nexus	(['NeXus',' ']	,path,filename,status,datp)
'D10'	: RETURN,rdid		(['D10','DIF']	,path,filename,status,datp)
'D15'	: RETURN,rdid		(['D15','DIF']	,path,filename,status,datp)
'SALSA'	: RETURN,rdid		(['SALSA','DIF'],path,filename,status,datp)
'D3'	: RETURN,rdid		(['D3','DIF']	,path,filename,status,datp)
'D4'	: RETURN,rdid		(['D4','DIF']	,path,filename,status,datp)
'Spec'	: RETURN,read_spec	(['Spec',' ']	,path,filename,status,datp)
'EDF'	: RETURN,rdedf		(['EDF','ESRF']	,path,filename,status,datp)
'gsas'	: RETURN,rd_d2b		(['gsas','DIF']	,path,filename,status,datp)
'FPdat'	: RETURN,rdinstr		(['FPdat','DIF'],path,filename,status,datp)
'd20cal'	: RETURN,rddat		(['d20cal','DIF'],path,filename,status,datp)
'prf'	: RETURN,rddat		(['prf','DIF']	,path,filename,status,datp)
't3'	: RETURN,rdid		(['t3','LON']	,path,filename,status,datp)
'qens'	: RETURN,read_qens	(['qens','TOF']	,path,filename,status,datp)
'mibemol'	: RETURN,read_nexus	(['mibemol','TOF'],path,filename,status,datp)
'gaussian(g94)'	: RETURN,read_mag	(['gaussian(g94)','ATOMS'],path,filename,status,datp)
'phonon(d07,d23)'	: RETURN,read_mag	(['phonon(d07,d23)','ATOMS'],path,filename,status,datp)
'vasp(CONTCAR)'	: RETURN,read_mag	(['vasp(CONTCAR)','ATOMS'],path,filename,status,datp)
'vasp(XDATCAR)'	: RETURN,read_mag	(['vasp(XDATCAR)','ATOMS'],path,filename,status,datp)
'vasp(CHGCAR)'	: RETURN,read_mag	(['vasp(CHGCAR)','ATOMS'],path,filename,status,datp)
'fullprof(atm,fst)'	: RETURN,read_mag	(['fullprof(atm,fst)','ATOMS'],path,filename,status,datp)
'gulp(gout)'	: RETURN,read_mag	(['gulp(gout)','ATOMS'],path,filename,status,datp)
'cif (basic)'	: RETURN,read_mag	(['cif (basic)','ATOMS'],path,filename,status,datp)
'PDB (basic)'	: RETURN,read_mag	(['PDB (basic)','ATOMS'],path,filename,status,datp)
'NEAT'	: RETURN,read_neat	(['NEAT','TOF']	,path,filename,status,datp)
'MARI'	: RETURN,rd_mari		(['MARI','TOF']	,path,filename,status,datp)
'X_cnrs'	: RETURN,rd_x		(['X_cnrs','LON'],path,filename,status,datp)
'focus'	: RETURN,read_nexus	(['focus','TOF'],path,filename,status,datp)
'SPE'	: RETURN,rdspe		(['SPE','ESRF']	,path,filename,status,datp)
'FIGARO'	: RETURN,rdid		(['FIGARO','LSS'],path,filename,status,datp)
'toftof'	: RETURN,read_toftof	(['toftof','TOF'],path,filename,status,datp)
'E4nxs'	: RETURN,read_nexus	(['E4nxs','BENSC'],path,filename,status,datp)
'Modeling'	: RETURN,read_mag	(['Modeling',' '],path,filename,status,datp)
'ADAM'	: RETURN,read_adam	(['ADAM','LSS']	,path,filename,status,datp)
'D33'	: RETURN,read_nexus	(['D33','LSS']	,path,filename,status,datp)
'IN1bef'	: RETURN,rdid		(['IN1bef','3Axes'],path,filename,status,datp)
'IN1tas'	: RETURN,rdid		(['IN1tas','3Axes'],path,filename,status,datp)
'PAXY'	: RETURN,read_paxy	(['PAXY','LSS']	,path,filename,status,datp)
'V1'	: RETURN,read_v1		(['V1','BENSC']	,path,filename,status,datp)
'Pelican'	: RETURN,read_nexus	(['Pelican','TOF'],path,filename,status,datp)
'IN16B'	: RETURN,read_nexus	(['IN16B','TOF'],path,filename,status,datp)
'init'	: BEGIN &  Status=0

  ttinst   = ['demo']		;exec
  ttinst   = [ttinst,'IN4']	;exec
  ttinst   = [ttinst,'IN5']	;exec
  ttinst   = [ttinst,'IN6']	;exec
  ttinst   = [ttinst,'IN10']	;exec
  ttinst   = [ttinst,'IN13']	;exec
  ttinst   = [ttinst,'IN16']	;exec
  ttinst   = [ttinst,'D7']	;exec
  ttinst   = [ttinst,'BRISP']	;exec
  ttinst   = [ttinst,'D11']	;exec
  ttinst   = [ttinst,'D17']	;exec
  ttinst   = [ttinst,'D22']	;exec
  ttinst   = [ttinst,'PN1']	;exec
  ttinst   = [ttinst,'INX']	;exec
  ttinst   = [ttinst,'D1B']	;exec
  ttinst   = [ttinst,'IN8']	;exec
  ttinst   = [ttinst,'D19']	;exec
  ttinst   = [ttinst,'D9']	;exec
  ttinst   = [ttinst,'D1A']	;exec
  ttinst   = [ttinst,'D16']	;exec
  ttinst   = [ttinst,'DB21']	;exec
  ttinst   = [ttinst,'IN1']	;exec
  ttinst   = [ttinst,'Column']	;exec
  ttinst   = [ttinst,'lamp']	;exec
  ttinst   = [ttinst,'IN14']	;exec
  ttinst   = [ttinst,'IN20']	;exec
  ttinst   = [ttinst,'D2B']	;exec
  ttinst   = [ttinst,'D20']	;exec
  ttinst   = [ttinst,'D11tof']	;exec
  ttinst   = [ttinst,'XRAY']	;exec
  ttinst   = [ttinst,'column.']	;exec
  ttinst   = [ttinst,'inx.']	;exec
  ttinst   = [ttinst,'t13a']	;exec
  ttinst   = [ttinst,'t13c']	;exec
  ttinst   = [ttinst,'NeXus']	;exec
  ttinst   = [ttinst,'D10']	;exec
  ttinst   = [ttinst,'D15']	;exec
  ttinst   = [ttinst,'SALSA']	;exec
  ttinst   = [ttinst,'D3']	;exec
  ttinst   = [ttinst,'D4']	;exec
  ttinst   = [ttinst,'Spec']	;exec
  ttinst   = [ttinst,'EDF']	;exec
  ttinst   = [ttinst,'dat.']	;exec
  ttinst   = [ttinst,'gsas.']	;exec
  ttinst   = [ttinst,'xy.']	;exec
  ttinst   = [ttinst,'prn.']	;exec
  ttinst   = [ttinst,'gsas']	;exec
  ttinst   = [ttinst,'FPdat']	;exec
  ttinst   = [ttinst,'d20cal']	;exec
  ttinst   = [ttinst,'prf']	;exec
  ttinst   = [ttinst,'t3']	;exec
  ttinst   = [ttinst,'qens']	;exec
  ttinst   = [ttinst,'mibemol']	;exec
  ttinst   = [ttinst,'gaussian(g94)']	;exec
  ttinst   = [ttinst,'phonon(d07,d23)']	;exec
  ttinst   = [ttinst,'cerius(_4.car)']	;exec
  ttinst   = [ttinst,'vasp(CONTCAR)']	;exec
  ttinst   = [ttinst,'vasp(XDATCAR)']	;exec
  ttinst   = [ttinst,'vasp(CHGCAR)']	;exec
  ttinst   = [ttinst,'fullprof(atm,fst)']	;exec
  ttinst   = [ttinst,'gulp(gout)']	;exec
  ttinst   = [ttinst,'cif (basic)']	;exec
  ttinst   = [ttinst,'PDB (basic)']	;exec
  ttinst   = [ttinst,'NEAT']	;exec
  ttinst   = [ttinst,'MARI']	;exec
  ttinst   = [ttinst,'X_cnrs']	;exec
  ttinst   = [ttinst,'focus']	;exec
  ttinst   = [ttinst,'SPE']	;exec
  ttinst   = [ttinst,'FIGARO']	;exec
  ttinst   = [ttinst,'toftof']	;exec
  ttinst   = [ttinst,'eth(D20).']	;exec
  ttinst   = [ttinst,'E4nxs']	;exec
  ttinst   = [ttinst,'Modeling']	;exec
  ttinst   = [ttinst,'ADAM']	;exec
  ttinst   = [ttinst,'D33']	;exec
  ttinst   = [ttinst,'IN1bef']	;exec
  ttinst   = [ttinst,'IN1tas']	;exec
  ttinst   = [ttinst,'PAXY']	;exec
  ttinst   = [ttinst,'V1']	;exec
  ttinst   = [ttinst,'Pelican']	;exec
  ttinst   = [ttinst,'IN16B']	;exec

  ttproc   = ['read_tmp']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'read_nexus']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'pn1']	;exec
  ttproc   = [ttproc,'inx_in']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'read_column']	;exec
  ttproc   = [ttproc,'rlamp']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdspe']	;exec
  ttproc   = [ttproc,'write_org']	;exec
  ttproc   = [ttproc,'write_inx']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'read_nexus']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'read_spec']	;exec
  ttproc   = [ttproc,'rdedf']	;exec
  ttproc   = [ttproc,'export_dat']	;exec
  ttproc   = [ttproc,'export_gsa']	;exec
  ttproc   = [ttproc,'export_xy']	;exec
  ttproc   = [ttproc,'export_prn']	;exec
  ttproc   = [ttproc,'rd_d2b']	;exec
  ttproc   = [ttproc,'rdinstr']	;exec
  ttproc   = [ttproc,'rddat']	;exec
  ttproc   = [ttproc,'rddat']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'read_qens']	;exec
  ttproc   = [ttproc,'read_nexus']	;exec
  ttproc   = [ttproc,'read_mag']	;exec
  ttproc   = [ttproc,'read_mag']	;exec
  ttproc   = [ttproc,'read_mag']	;exec
  ttproc   = [ttproc,'read_mag']	;exec
  ttproc   = [ttproc,'read_mag']	;exec
  ttproc   = [ttproc,'read_mag']	;exec
  ttproc   = [ttproc,'read_mag']	;exec
  ttproc   = [ttproc,'read_mag']	;exec
  ttproc   = [ttproc,'read_mag']	;exec
  ttproc   = [ttproc,'read_mag']	;exec
  ttproc   = [ttproc,'read_neat']	;exec
  ttproc   = [ttproc,'rd_mari']	;exec
  ttproc   = [ttproc,'rd_x']	;exec
  ttproc   = [ttproc,'read_nexus']	;exec
  ttproc   = [ttproc,'rdspe']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'read_toftof']	;exec
  ttproc   = [ttproc,'export_eth']	;exec
  ttproc   = [ttproc,'read_nexus']	;exec
  ttproc   = [ttproc,'read_mag']	;exec
  ttproc   = [ttproc,'read_adam']	;exec
  ttproc   = [ttproc,'read_nexus']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'rdid']	;exec
  ttproc   = [ttproc,'read_paxy']	;exec
  ttproc   = [ttproc,'read_v1']	;exec
  ttproc   = [ttproc,'read_nexus']	;exec
  ttproc   = [ttproc,'read_nexus']	;exec

  ttgroup  = [' ']		;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'LSS']	;exec
  ttgroup  = [ttgroup,'LSS']	;exec
  ttgroup  = [ttgroup,'LSS']	;exec
  ttgroup  = [ttgroup,'NFP']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'3Axes']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'LSS']	;exec
  ttgroup  = [ttgroup,'LSS']	;exec
  ttgroup  = [ttgroup,'3Axes']	;exec
  ttgroup  = [ttgroup,' ']	;exec
  ttgroup  = [ttgroup,' ']	;exec
  ttgroup  = [ttgroup,'3Axes']	;exec
  ttgroup  = [ttgroup,'3Axes']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'LSS']	;exec
  ttgroup  = [ttgroup,'LON']	;exec
  ttgroup  = [ttgroup,' ']	;exec
  ttgroup  = [ttgroup,' ']	;exec
  ttgroup  = [ttgroup,'LON']	;exec
  ttgroup  = [ttgroup,'LON']	;exec
  ttgroup  = [ttgroup,' ']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,' ']	;exec
  ttgroup  = [ttgroup,'ESRF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'LON']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'ATOMS']	;exec
  ttgroup  = [ttgroup,'ATOMS']	;exec
  ttgroup  = [ttgroup,'ATOMS']	;exec
  ttgroup  = [ttgroup,'ATOMS']	;exec
  ttgroup  = [ttgroup,'ATOMS']	;exec
  ttgroup  = [ttgroup,'ATOMS']	;exec
  ttgroup  = [ttgroup,'ATOMS']	;exec
  ttgroup  = [ttgroup,'ATOMS']	;exec
  ttgroup  = [ttgroup,'ATOMS']	;exec
  ttgroup  = [ttgroup,'ATOMS']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'LON']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'ESRF']	;exec
  ttgroup  = [ttgroup,'LSS']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'DIF']	;exec
  ttgroup  = [ttgroup,'BENSC']	;exec
  ttgroup  = [ttgroup,' ']	;exec
  ttgroup  = [ttgroup,'LSS']	;exec
  ttgroup  = [ttgroup,'LSS']	;exec
  ttgroup  = [ttgroup,'3Axes']	;exec
  ttgroup  = [ttgroup,'3Axes']	;exec
  ttgroup  = [ttgroup,'LSS']	;exec
  ttgroup  = [ttgroup,'BENSC']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec
  ttgroup  = [ttgroup,'TOF']	;exec

  ttsymbol = ['Current Path']			;exec
  ttsymbol = [ttsymbol,'Current Cycle']		;exec
  ttsymbol = [ttsymbol,'Previous Cycle']	;exec
  ttsymbol = [ttsymbol,'On_Line']		;exec
  ttsymbol = [ttsymbol,'...BROWSE...']		;exec
  ttsymbol = [ttsymbol,'My Proposal']		;exec
  ttsymbol = [ttsymbol,'C_Year 2019']   ;exec
  ttsymbol = [ttsymbol,'C_Year 2018']   ;exec
  ttsymbol = [ttsymbol,'C_Year 2017']		;exec
  ttsymbol = [ttsymbol,'C_Year 2016']		;exec
  ttsymbol = [ttsymbol,'C_Year 2015']		;exec
  ttsymbol = [ttsymbol,'C_Year 2014']		;exec
  ttsymbol = [ttsymbol,'C_Year 2013']		;exec
  ttsymbol = [ttsymbol,'C_Year 2012']		;exec
  ttsymbol = [ttsymbol,'C_Year 2011']		;exec
  ttsymbol = [ttsymbol,'C_Year 2010']		;exec
  ttsymbol = [ttsymbol,'C_Year 2009']		;exec
  ttsymbol = [ttsymbol,'C_Year 2008']		;exec
  ttsymbol = [ttsymbol,'C_Year 2007']		;exec
  ttsymbol = [ttsymbol,'C_Year 2006']		;exec
  ttsymbol = [ttsymbol,'C_Year 2005']		;exec
  ttsymbol = [ttsymbol,'C_Year 2004']		;exec
  ttsymbol = [ttsymbol,'C_Year 2003']		;exec
  ttsymbol = [ttsymbol,'C_Year 2002']		;exec
  ttsymbol = [ttsymbol,'C_Year 2001']		;exec
  ttsymbol = [ttsymbol,'C_Year 2000']		;exec
  ttsymbol = [ttsymbol,'C_Year 1999']		;exec
  ttsymbol = [ttsymbol,'C_Year 1998']		;exec
  ttsymbol = [ttsymbol,'C_Year 1997']		;exec
  ttsymbol = [ttsymbol,'C_Year 1996']		;exec
  ttsymbol = [ttsymbol,'C_Year 1995']		;exec
  ttsymbol = [ttsymbol,'xray']		;exec
  ttsymbol = [ttsymbol,'N scat lengths']	;exec
  ttsymbol = [ttsymbol,'Atomic weights']	;exec
  ttsymbol = [ttsymbol,'Scat L.Density']	;exec
  ttsymbol = [ttsymbol,'ILL data <2013']	;exec
  ttsymbol = [ttsymbol,'ILL explorer']		;exec
  ttsymbol = [ttsymbol,'Web-Lamp']		;exec
  ttsymbol = [ttsymbol,'Web-elements']		;exec
  ttsymbol = [ttsymbol,'Repository']		;exec
  ttsymbol = [ttsymbol,'Lamp News']		;exec

  ttpath   = ['.']				;exec
  ttpath   = [ttpath,'/net/serdon/illdata/data , \\serdon\illdata\data']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata/data-1, \\serdon\illdata\data-1']		;exec
  ttpath   = [ttpath,'/net/(inst)/users/data, \\(inst)\users\data']		;exec
  ttpath   = [ttpath,'To_Browse_For_a_DataPath']		;exec
  ttpath   = [ttpath,'~/MyData/byInstrument/(inst), \\serdon\illdata\MyData\(user)\byInstrument\(inst)']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata, \\serdon\illdata']		;exec
  ttpath   = [ttpath,'/net/serdon/illdata/xray/xraydur, \\serdon\illdata\xray\xraydur']		;exec
  ttpath   = [ttpath,'http://www.ncnr.nist.gov/resources/n-lengths/list.html']		;exec
  ttpath   = [ttpath,'http://physics.nist.gov/PhysRefData/Compositions']		;exec
  ttpath   = [ttpath,'http://www.ncnr.nist.gov/resources/activation/']		;exec
  ttpath   = [ttpath,'http://barns.ill.eu/cgi-bin/barns/nph-barns.pl?StartBarns=Ida;User=EVERY_bod']		;exec
  ttpath   = [ttpath,'http://explorer.ill.eu']		;exec
  ttpath   = [ttpath,'http://barns.ill.eu/cgi-bin/barns/nph-barns.pl?StartBarns=WebLamp;User=GUEST']		;exec
  ttpath   = [ttpath,'http://webelements.com']		;exec
  ttpath   = [ttpath,'http://forge.epn-campus.eu/projects/lamp']		;exec
  ttpath   = [ttpath,'http://ftp.ill.eu/pub/cs/lampnews.txt']		;exec

  ttouch   = '/home/cs/TOUCH_BASE' ;exec

  ttmacro  = '/home/cs/lambda/macros, \\serhom\home\cs\lambda\macros' ;exec

  ttaccess = 'rdfilter'				;exec

  ttsite   = 'magnet_win'				;exec

  ttmagi   = '6' ;exec

  ttwall   = '' ;exec

  ttpars   = '300' ;exec

  datp     = {a:ttinst,  b:ttproc,  c:ttgroup,  $
              d:ttsymbol,e:ttpath,  f:ttouch,   $
              g:ttmacro, h:ttaccess,i:ttsite,j:ttmagi,k:ttwall,l:ttpars}

  return,0

         END

ELSE :

ENDCASE

Status = 14

return,0

END

