function read_bss, fifi
;+
;******* ********
;** reads a back scattering file, don't know which!
;-

on_ioerror,misopen & u=-1 & Wout=0 & p_txt=['']
openr,u,fifi,/get_lun

on_ioerror,misread
line='' & En=0L & Qn=0L
readf,u,line & readf,u,En      ; read dimensions
readf,u,line & readf,u,Qn

Wout=dblarr(En,Qn) & Xout=fltarr(En) & Yout=fltarr(Qn)
Eout=Wout & tmp=dblarr(2 ,En)  ; create arrays

readf,u,line & readf,u,Xout    ; read E and Q
readf,u,line & readf,u,Yout

for i=0,Qn-1 do begin & readf,u,line & readf,u,tmp
    Wout[*,i]=reform(tmp[0,*]) ; split counts and errors
    Eout[*,i]=reform(tmp[1,*])
endfor

while not eof(u) do begin     ; read tailing comments
    readf,u,line & p_txt=[p_txt,line]
endwhile
free_lun,u
Pout=fltarr(n_elements(p_txt))
idx =strpos(p_txt,'data Title:') & k=where(idx gt 0) & k=k[0]
if k ge 0 then Wtit=strmid(p_txt[k],idx[k]+12,80) else Wtit=''
idx =strpos(p_txt,'data Run Number:') & k=where(idx gt 0) & k=k[0]
if k ge 0 then Ot=strmid(p_txt[k],idx[k]+4,80)    else Ot=''

P_txt=[strarr(28),p_txt] & Pout=fltarr(n_elements(p_txt))
P_txt[ 2]='Doppler'
p_txt[ 9]='Elastic peak position'
p_txt[11]='Temperature'
p_txt[18]='Channel width'
p_txt[21]='Wave lenght'
p_txt[27]='Sample distance'

datp={X:Xout,Y:Yout,E:Eout,X_tit:'energy transfer (ueV)'   ,$
      P:Pout,Par_txt:p_txt,Y_tit:'Q transfer (A-1)',$
      Other_tit:fifi+Ot   ,W_tit:Wtit}
give_datp,datp

return,Wout

misread:
misopen: if u gt 0 then free_lun,u
return,Wout
end
