	subroutine deepff(nn,jj,ii,ez,ny,nx,sz,si,sj,dx,dy,fdx,fdy,fdz,
	1		  px1,py1,px2,py2,tv_nc,typ,rvl,rvm,stc,are,erey)
c...	---------- ------
c...
	if (typ.eq.4) then
		call deepi2(nn,jj,ii,ez,ny,nx,sz,si,sj,dx,dy,fdx,fdy,fdz,
	1		    px1,py1,px2,py2,tv_nc,rvl,rvm,stc,are,erey)
	else if (typ.eq.8)  then
		call deepf4(nn,jj,ii,ez,ny,nx,sz,si,sj,dx,dy,fdx,fdy,fdz,
	1		    px1,py1,px2,py2,tv_nc,rvl,rvm,stc,are,erey)
	else if (typ.eq.16) then
		call deepi4(nn,jj,ii,ez,ny,nx,sz,si,sj,dx,dy,fdx,fdy,fdz,
	1		    px1,py1,px2,py2,tv_nc,rvl,rvm,stc,are,erey)
	endif
	return
	end

	integer function integr4(val)
c...	------  -------- -------
	integer val(1)
	integr4=val(1)
	return
	end

	subroutine fordeep(p1 ,p2)
c...	---------- -------
	integer p1,p2(*)

c...	Fordeep variables.
c...	------- ---------
c	parameter (n1=22, n2=25)
	integer	   ad(25),n1,n2
	n1=22
	n2=25
	
	do i=1 ,n2
	   ad(i)=integr4(%val(p2(i)))
	end do    

	do i=n1+1,n2                                               
	   ad(i)= p2(i)
	end do

	if (ad(n1-2).eq.4) then
	   call deepi2(ad( 1),ad( 2),ad( 3),ad( 4),ad( 5),ad( 6),ad( 7),ad( 8),
	1	       ad( 9),ad(10),ad(11),ad(12),ad(13),ad(14),ad(15),ad(16),
	1	       ad(17),ad(18),ad(19),ad(21),ad(22),
	1	       %val(ad(23)),%val(ad(24)),%val(ad(25)))
	else if (ad(n1-2).eq.8)  then
	   call deepf4(ad( 1),ad( 2),ad( 3),ad( 4),ad( 5),ad( 6),ad( 7),ad( 8),
	1	       ad( 9),ad(10),ad(11),ad(12),ad(13),ad(14),ad(15),ad(16),
	1	       ad(17),ad(18),ad(19),ad(21),ad(22),
	1	       %val(ad(23)),%val(ad(24)),%val(ad(25)))
	else if (ad(n1-2).eq.16) then
	   call deepi4(ad( 1),ad( 2),ad( 3),ad( 4),ad( 5),ad( 6),ad( 7),ad( 8),
	1	       ad( 9),ad(10),ad(11),ad(12),ad(13),ad(14),ad(15),ad(16),
	1	       ad(17),ad(18),ad(19),ad(21),ad(22),
	1	       %val(ad(23)),%val(ad(24)),%val(ad(25)))
	endif
	return
	end

	subroutine deepi2(nn,jj,ii,ez,ny,nx,sz,si,sj,dx,dy,fdx,fdy,fdz,
	1		  px1,py1,px2,py2,tv_nc,rvl,rvm,stc,are,erey)
c...	---------- ------
c...
	implicit  integer (a-z)
	integer	  stc (0:*)
c	integer*2 nf,nv,nvl,nz
	integer*2 are (0:si-1,0:sj-1,0:*)
	integer*2 erey(0:nx-1,0:ny-1,0:*)

	stc0  = stc(0)
	stc1  = stc(1)
	stc2  = stc(2)
	vlm   = rvm-rvl
	do  n = 0 ,nn
	    nt= n/fdz
	    xt= nt*px2 + dx
	    yv= nt*py2 + dy
	    ns= n +stc2
	    pz= sj-nt-1
	    pw= si-nt-1
	    do  j = 0 , jj
		yt= yv+ j/fdy
		js= j + stc1
		do  i = 0  , ii
		   xi = xt + i/fdx*px1
		   yi = yt + i/fdx*py1
		   is = i  + stc0
		   vl = erey(is,js,ns)
		   if  (vl.gt.rvm) then
					vl=0
				   else
		   			vl = vl-rvl
					if ( vl.le.0) then
						      vl=0
						      else
						      vl=vl*tv_nc/vlm
						      endif
				   endif
		   if  (are(xi,yi,0).le.vl) then
			      are(xi,yi,0)  = vl
			      are(xi,yi,1)  = n
			      endif
		   if  (sz.gt.1) then
		   if (px1.ne.0) then
		   	if   (vl.gt.are(xi,pz,0)) then
				    are(xi,pz,0) =  vl
				    are(xi,pz,1) =-j-2
				    endif
		   	if   (vl.gt.are(pw,yi,0)) then
				    are(pw,yi,0) =  vl
				    are(pw,yi,1) =-i-2
				    endif
			endif
		   endif
	end do
	    end do
		end do
c...
c...	deep colors adjustment.
c...
c	if (nn.lt.tv_nc/4) then
c	nz=nn+1
c	nv=tv_nc/nz
c
c	do  j = 0 , sj-1
c	  do  i = 0  , si-1
c		nf=are(i,j,1)
c		if (nf.ge.0) then 
c			nvl = are(i,j,0)
c			if (nvl.gt.0) nvl=nvl/nz + nv*(nn-nf)
c			are(i,j,0) =  nvl
c			endif
c	  end do
c	end do
c	endif

	return
	end

	subroutine deepf4(nn,jj,ii,ez,ny,nx,sz,si,sj,dx,dy,fdx,fdy,fdz,
	1		  px1,py1,px2,py2,tv_nc,rvl,rvm,stc,are,erey)
c...	---------- ------
c...
	implicit  integer (a-z)
	integer	  stc (0:*)
c	integer*2 nf,nv,nvl,nz
	integer*2 are (0:si-1,0:sj-1,0:*)
	real*4	  erey(0:nx-1,0:ny-1,0:*)
	real*4	  rvl,rvm,vlm,vl

	stc0  = stc(0)
	stc1  = stc(1)
	stc2  = stc(2)
	vlm   = rvm-rvl
	do  n = 0 ,nn
	    nt= n/fdz
	    xt= nt*px2 + dx
	    yv= nt*py2 + dy
	    ns= n +stc2
	    pz= sj-nt-1
	    pw= si-nt-1
	    do  j = 0 , jj
		yt= yv+ j/fdy
		js= j + stc1
		do  i = 0  , ii
		   xi = xt + i/fdx*px1
		   yi = yt + i/fdx*py1
		   is = i  + stc0
		   vl = erey(is,js,ns)
		   if  (vl.gt.rvm) then
					vl=0
				   else
		   			vl = vl-rvl
					if ( vl.le.0) then
						      vl=0
						      else
						      vl=vl*tv_nc/vlm
						      endif
				   endif
		   if  (are(xi,yi,0).le.vl) then
			      are(xi,yi,0)  = vl
			      are(xi,yi,1)  = n
			      endif
		   if  (sz.gt.1) then
		   if (px1.ne.0) then
		   	if   (vl.gt.are(xi,pz,0)) then
				    are(xi,pz,0) =  vl
				    are(xi,pz,1) =-j-2
				    endif
		   	if   (vl.gt.are(pw,yi,0)) then
				    are(pw,yi,0) =  vl
				    are(pw,yi,1) =-i-2
				    endif
			endif
		   endif
	end do
	    end do
		end do
c...
c...	deep colors adjustment.
c...
c	if (nn.lt.tv_nc/4) then
c	nz=nn+1
c	nv=tv_nc/nz
c
c	do  j = 0 , sj-1
c	  do  i = 0  , si-1
c		nf=are(i,j,1)
c		if (nf.ge.0) then 
c			nvl = are(i,j,0)
c			if (nvl.gt.0) nvl=nvl/nz + nv*(nn-nf)
c			are(i,j,0) =  nvl
c			endif
c	  end do
c	end do
c	endif

	return
	end

	subroutine deepi4(nn,jj,ii,ez,ny,nx,sz,si,sj,dx,dy,fdx,fdy,fdz,
	1		  px1,py1,px2,py2,tv_nc,rvl,rvm,stc,are,erey)
c...	---------- ------
c...
	implicit  integer (a-z)
	integer	  stc (0:*)
c	integer*2 nf,nv,nvl,nz
	integer*2 are (0:si-1,0:sj-1,0:*)
	integer*4 erey(0:nx-1,0:ny-1,0:*)

	stc0  = stc(0)
	stc1  = stc(1)
	stc2  = stc(2)
	vlm   = rvm-rvl
	do  n = 0 ,nn
	    nt= n/fdz
	    xt= nt*px2 + dx
	    yv= nt*py2 + dy
	    ns= n +stc2
	    pz= sj-nt-1
	    pw= si-nt-1
	    do  j = 0 , jj
		yt= yv+ j/fdy
		js= j + stc1
		do  i = 0  , ii
		   xi = xt + i/fdx*px1
		   yi = yt + i/fdx*py1
		   is = i  + stc0
		   vl = erey(is,js,ns)
		   if  (vl.gt.rvm) then
					vl=0
				   else
		   			vl = vl-rvl
					if ( vl.le.0) then
						      vl=0
						      else
						      vl=vl*tv_nc/vlm
						      endif
				   endif
		   if  (are(xi,yi,0).le.vl) then
			      are(xi,yi,0)  = vl
			      are(xi,yi,1)  = n
			      endif
		   if  (sz.gt.1) then
		   if (px1.ne.0) then
		   	if   (vl.gt.are(xi,pz,0)) then
				    are(xi,pz,0) =  vl
				    are(xi,pz,1) =-j-2
				    endif
		   	if   (vl.gt.are(pw,yi,0)) then
				    are(pw,yi,0) =  vl
				    are(pw,yi,1) =-i-2
				    endif
			endif
		   endif
	end do
	    end do
		end do
c...
c...	deep colors adjustment.
c...
c	if (nn.lt.tv_nc/4) then
c	nz=nn+1
c	nv=tv_nc/nz
c
c	do  j = 0 , sj-1
c	  do  i = 0  , si-1
c		nf=are(i,j,1)
c		if (nf.ge.0) then 
c			nvl = are(i,j,0)
c			if (nvl.gt.0) nvl=nvl/nz + nv*(nn-nf)
c			are(i,j,0) =  nvl
c			endif
c	  end do
c	end do
c	endif

	return
	end
