;update for embedded version 6.0
;*******************************

!quiet=1
if sys_dep('MACHINE') eq 'unix' then !path=!path+':lamp_mac/'

;print, "Compiling kernel ..."
.run lamprt60.pro
.run sys_dep.pro
.run piec6s.pro ;read_spec, georgeo)
.run dids.pro
.run dons.pro
.run bens.pro

 print, "Compiling macros ..."
.run liv_lamp.pro
.run livc_lamp.pro
.run liv_objet.pro
.run make_volume.pro
.run magnet_win.pro
.run magdraw.pro
.run dial_xbu.pro
.run radial_at.pro
.run write_xml.pro
.run write_hdf.pro
.run write_org.pro
.run write_pdb.pro
.run dial_tornade.pro
.run prox_sheet.pro
.run read_neat.pro
.run read_hdf.pro
.run read_mag.pro
.run read_org.pro
.run read_bss.pro
.run read_nexus.pro
.run read_toftof.pro
.run suprplot.pro
.run rdfilter.pro
.run ligend.pro
.run customiz.pro
.run regular.pro
.run str_fit.pro
.run didline.pro
.run cylindcor.pro
.run rd_mari.pro
.run groupy.pro
.run lineup.pro
.run gfit.pro
.run bin_as.pro
.run rdspe.pro
.run rdedf.pro
.run rdid.pro
.run rd_x.pro
.run tee.pro
.run inx.pro
.run tripx.pro

.run update_lamp_out.pro

.run linfit
.run igamma
.run regress

.run mpeg_open
.run mpeg_close
.run mpeg_put
.run mpeg_save
.run path_sep

.run xobjview
.run idlexviewmanip__define
.run idlexobjviewwid__define
.run idlexobjview__define
.run idlexwidget__define
.run idlexviewgroup__define.pro
.run idlexmodelmanip__define.pro
.run idlexinscribingview__define
.run idlexvolview__define.pro
.run idlexvolviewwid__define.pro

.run dialog_write_image
.run query_image
.run cw_filesel
.run cw_field

.run cw_fslider           ;.. FITS...
.run lamp_mac/mpfit
.run lamp_mac/mpfitfun
.run lamp_mac/tnmin
.run lamp_mac/rmd_ga

.run lamp_mac/STEF/qens_fit
.run lamp_mac/STEF/fit_basegl
.run lamp_mac/STEF/fit_ba_gumbel.pro
.run lamp_mac/STEF/fit_ba_unirot.pro
.run lamp_mac/STEF/fit_ba_isorot.pro
.run lamp_mac/STEF/fit_ba_rwtrans.pro
.run lamp_mac/STEF/fit_ba_rotctran.pro
.run lamp_mac/STEF/fit_ba_rotctran_iso.pro
.run lamp_mac/STEF/fit_ba_userfunction.pro

.run lamp_mac/ATOMS/myinit_atoms.pro
.run lamp_mac/ATOMS/nmoldyn_read.pro
.run lamp_mac/ATOMS/read_doscar.pro
.run lamp_mac/ATOMS/doscar_read.pro
.run lamp_mac/ATOMS/discover_read.pro
.run lamp_mac/ATOMS/xdatcar.pro
.run lamp_mac/ATOMS/xdat2cont.pro
.run lamp_mac/ATOMS/cont2xdat.pro
.run lamp_mac/ATOMS/pdb2contcar.pro
.run lamp_mac/ATOMS/gdos_q.pro
.run lamp_mac/ATOMS/build_q_w.pro
.run lamp_mac/ATOMS/rotate_q_w.pro
.run lamp_mac/ATOMS/ebands.pro
.run lamp_mac/ATOMS/conv_ins.pro
.run lamp_mac/ATOMS/gr_angle_n.pro
.run lamp_mac/ATOMS/gr_angle_r.pro
.run lamp_mac/ATOMS/gr_big.pro
.run lamp_mac/ATOMS/gr_coord.pro
.run lamp_mac/ATOMS/gr_coord_loop.pro
.run lamp_mac/ATOMS/gr_partial.pro
.run lamp_mac/ATOMS/gr_stats.pro
.run lamp_mac/ATOMS/nmoldyn3_read.pro
.run lamp_mac/ATOMS/nmoldyn3_preread.pro

.run lamp_mac/ATOMS/atom_dist.pro
.run lamp_mac/ATOMS/xdatcar5.pro
.run lamp_mac/ATOMS/write_xdatcar5.pro
.run lamp_mac/ATOMS/global_motion.pro
.run lamp_mac/ATOMS/sqw_tosca

;.run lamp_mac/ATOMS/read_phon.pro
;.run lamp_mac/ATOMS/sum_phon.pro
;.run lamp_mac/ATOMS/phon_q_w.pro
;.run lamp_mac/ATOMS/sum_q_w.pro
;.run lamp_mac/ATOMS/iqt2sqw.pro

.run lamp_mac/D2B/straight_1d.pro
.run lamp_mac/D2B/straight_2d.pro

;;;;.run lamp_mac/SANS/sans_sector.pro    ;before settings
;;;;.run lamp_mac/SANS/sans_center.pro
;;;;.run lamp_mac/SANS/sans_transm.pro
;;;;.run lamp_mac/SANS/sans_mask.pro
;;;;.run lamp_mac/SANS/sans_cor.pro
;;;;.run lamp_mac/SANS/sans_radial.pro
;;;;.run lamp_mac/SANS/sans_reform_series.pro
;;;;.run lamp_mac/SANS/sans_read_settings.pro
;;;;.run lamp_mac/SANS/sans_write_settings.pro
;;;;.run lamp_mac/SANS/sans_read_gt.pro
;;;;.run lamp_mac/SANS/sans_read_graspr.pro
;;;;.run lamp_mac/SANS/sans_save_gt.pro
;;;;.run lamp_mac/SANS/sans_read_mask.pro
.run lamp_mac/SANS/sans_settings.pro
.run lamp_mac/SANS/sans_sheet.pro

.run lamp_mac/FIGARO/figaro_grav.pro

 print, ""
 print, "Saving update60a.rt ..."

 save,/routines,filename="update60a.rt"
 print, "end"
