//
//  exploreForDoc.h
//  idl2xref
//
//  Created by Yannick Raoul on 5/13/13.
//  Copyright 2013 ILL/ADHOC. All rights reserved.
//
//  C interface for old idl2matlab like
//  but C++ inside
//

#ifndef EXPLOREFORDOC_H
#define EXPLOREFORDOC_H

#include <stdbool.h>

#ifdef __cplusplus
extern "C" {
#endif
    
    // Initialize internal variable before parse
    void startIDLXRef(int nbFiles);

    // Parse an idl file and collect data
    void collectIDL_Def_and_Ref (char * baseFileName, char * sourceDirName);

    // Print current internal state on standard output 
    void printIDLXRef(bool full_list);
    
    // Write a report in a file
    void outputFormattedXref(char * destFileName);


#ifdef __cplusplus
}
#endif


#endif