PRO Build_MacFileListFromArray ,file_array ,macFile_List
;+
;** **************************
;** legacy
;** Entree :  ['toto', 'tata', 'titi']                  (IDL Array)
;** Sortie : "{file toto, file tata, file titi}  String
;-

        macFile_List = ''
        FOR Index=0,n_elements(file_array)-1 DO BEGIN

               IF (INDEX EQ 0) THEN $
                     macFile_List = 'file "' + file_array[Index] + '"' $
               ELSE $
                     macFile_List = macFile_List + ', file "' + file_array[Index] + '"'

        ENDFOR

        macFile_List = '{' + macFile_List + '}'

        return

END ; Build_MacFileListFromArray


PRO Build_MacFileListFromString ,file_list ,macFile_List
;+
;** ***************************
;** legacy
;** Entree : "toto tata titi"                         String
;** Sortie : "{file toto, file tata, file titi}  String
;-

        fileArray = strsplit(/EXTRACT,file_list, ' ')       ; Found in IDL Lib

        Build_MacFileListFromArray, fileArray ,macFile_List
        return

END ; Build_MacFileListFromString

PRO Build_ToolServerFileListFromString, sourceFolder, file_list, toolServer_List
;+
;** **********************************
;** legacy
;*** Entree : 'sourceFolder' 'toto tata titi'                                             String
;** Sortie : '\"sourceFolder:toto\" \"sourceFolder:tata\" \"sourceFolder:titi\"' String
;-

        fileArray = strsplit(/EXTRACT,file_list, ' ')       ; Found in IDL Lib

        toolServer_List = ''
        FOR Index=0,n_elements(fileArray)-1 DO BEGIN

               toolServer_List = toolServer_List + '\"' + sourceFolder + fileArray[Index] + '\" '

        ENDFOR

        return

END ; Build_ToolServerFileListFromString

PRO lamp_resource, txts
  ;+
  ;** *************
  ;** set colors in windows for unix
  ;-
  if !version.release le '6.0' then begin
    txts=[$
      "idl.retain:  2",$
      "idl.gr_visual:  PseudoColor",$
      "idl.visual:  PseudoColor",$
      "idl.colors:  -18"]
  endif else if !version.release ge '6.3' then begin
    txts=[""]
    ;   txts=[$
    ;   "idl_gr_x_retain:  2",$
    ;   "idl_gr_x_visual:  PseudoColor",$
    ;   "idl_gr_x_colors:  -18"]
  endif else if !version.release lt '6.3' then begin
    txts="idl.visual:  PseudoColor"
  endif
  
txts=[txts,$

"idl.noBorder:True",$
"*clientAutoPlace: off"]

txts=[txts,$

"Idl*Background:                  lightsteelblue1",$
"Idl*Foreground:                  black",$
"Idl*XmPushButton*background:     lightsteelblue2",$
"Idl*XmPushButton*foreground:     steelblue4",$
"Idl*XmCascadeButton*background:  lightsteelblue2",$
"Idl*XmCascadeButton*foreground:  steelblue4",$
"Idl*XmToggleButton*selectColor:  lightsteelblue",$
"Idl*XmLabel*foreground:          steelblue4",$
"Idl*XmText*background:           lightsteelblue1",$
"Idl*XmText*foreground:           black",$
"Idl*XmList*background:           lightsteelblue2",$
"Idl*XmList*foreground:           steelblue4"]

txts=[txts,$

"Idl*XmCascadeButton*shadowThickness:    1",$
"Idl*XmPushButton*shadowThickness:       1",$
"Idl*XmScrollBar*shadowThickness:        1",$
"Idl*XmText*shadowThickness:             1",$
"Idl*XmScale*shadowThickness:            1",$
"Idl*XmCascadeButton*highlightThickness: 0",$
"Idl*highlightThickness:                 2",$
"Idl*XmText*highlightThickness:          1"]

txts=[txts,$

"Idl*Annotate*Background:             lightsteelblue",$
"Idl*IDL*Background:                  lightsteelblue",$
"Idl*Xloadct*Background:              lightsteelblue"]

txts=[txts,$

"Idl*scan*discret*background:         lightsteelblue",$
"Idl*scan*discret*foreground:         steelblue4",$
"Idl*scan*XmPushButton*background:    lightsteelblue2",$
"Idl*scan*XmPushButton*foreground:    steelblue4",$
"Idl*scan*XmCascadeButton*background: lightsteelblue2",$
"Idl*scan*XmCascadeButton*foreground: steelblue4",$
"Idl*scan*XmToggleButton*selectColor: lightsteelblue2",$
"Idl*scan*XmLabel*foreground:         steelblue4",$
"Idl*scan*XmText*background:          lightsteelblue1",$
"Idl*scan*XmText*foreground:          black",$
"Idl*scan*XmList*background:          lightsteelblue2",$
"Idl*scan*XmList*foreground:          steelblue4"]

txts=[txts,$

"Idl*lamp*Background:                lightsteelblue",$
"Idl*lamp*XmPushButton*background:    lightsteelblue2",$
"Idl*lamp*XmPushButton*foreground:    steelblue4",$
"Idl*lamp*XmCascadeButton*background: lightsteelblue2",$
"Idl*lamp*XmCascadeButton*foreground: steelblue4",$
"Idl*lamp*XmToggleButton*selectColor: lightsteelblue2",$
"Idl*lamp*XmLabel*foreground:         steelblue4",$
"Idl*lamp*XmText*background:          lightsteelblue1",$
"Idl*lamp*XmText*foreground:          black",$
"Idl*lamp*XmList*background:          lightsteelblue2",$
"Idl*lamp*XmList*foreground:          steelblue4"]

txts=[txts,$

"Idl*lamp*spelab1*foreground:        grey",$
"Idl*lamp*spelab2*foreground:        lightsteelblue",$
"Idl*lamp*spelab3*foreground:        lightsteelblue1",$
"Idl*lamp*spelab4*foreground:        lightsteelblue2",$
"Idl*lamp*spelab5*foreground:        lightsteelblue3",$
"Idl*lamp*spelab6*foreground:        steelblue1",$
"Idl*lamp*spelab7*foreground:        steelblue2",$
"Idl*lamp*spelab8*foreground:        steelblue3",$
"Idl*lamp*spelab9*foreground:        lightblue4",$
"Idl*lamp*discret*Background:        lightblue1",$
"Idl*lamp*discret*Foreground:        black"]

txts=[txts,$

"Idl*scan*Background:      lightsteelblue",$
"Idl*lamp*mic*Background:  lightsteelblue1",$
"Idl*lampmic*Background:   lightsteelblue1",$
"Idl*lamp*did*Background:  lightsteelblue2",$
"Idl*lampdid*Background:   lightsteelblue2",$
"Idl*lamp*don*Background:  lightsteelblue3",$
"Idl*lampdon*Background:   lightsteelblue3",$
"Idl*lamp*ben*Background:  lightsteelblue3",$
"Idl*lampben*Background:   lightsteelblue3",$
"Idl*lamptouch*Background: lightsteelblue"]

txts=[txts,$

"Idl*lamp*mic*geo*Background:              lightblue1",$
"Idl*lamp*mic*geo*XmPushButton*background: lightblue1",$
"Idl*lamp*mic*geo*XmPushButton*foreground: steelblue4",$
"Idl*lamp*mic*geo*XmLabel*foreground:      steelblue4",$
"Idl*lamp*mic*geo*XmText*background:       lightblue1",$
"Idl*lamp*mic*geo*XmText*foreground:       steelblue4",$
"Idl*lamp*geo*Background:                  lightblue1",$
"Idl*lamp*geo*foreground:                  steelblue4",$
"Idl*lamp*geo*XmPushButton*background:     lightblue1",$
"Idl*lamp*geo*XmPushButton*foreground:     steelblue4",$
"Idl*lamp*geo*XmCascadeButton*Background:  lightblue1",$
"Idl*lamp*geo*XmCascadeButton*foreground:  steelblue4",$
"Idl*lamp*did*geo*Background:              lightblue1",$
"Idl*lamp*did*geo*foreground:              steelblue4",$
"Idl*lamp*did*geo*XmText*background:       lightblue1",$
"Idl*lamp*did*geo*XmText*foreground:       steelblue4",$
"Idl*lamp*don*geo*Background:              lightblue1",$
"Idl*lamp*don*geo*foreground:              steelblue4",$
"Idl*lamp*don*geo*XmText*background:       lightblue1",$
"Idl*lamp*don*geo*XmText*foreground:       steelblue4"]

txts=[txts,$

"Idl*lamp*mic*discret*background:          lightsteelblue1",$
"Idl*lamp*mic*discret*foreground:          steelblue4",$
"Idl*lamp*mic*XmPushButton*background:     lightsteelblue2",$
"Idl*lamp*mic*XmPushButton*foreground:     steelblue4",$
"Idl*lamp*mic*XmCascadeButton*background:  lightsteelblue2",$
"Idl*lamp*mic*XmCascadeButton*foreground:  steelblue4",$
"Idl*lamp*mic*XmToggleButton*selectColor:  lightsteelblue",$
"Idl*lamp*mic*XmLabel*foreground:          steelblue4",$
"Idl*lamp*mic*XmText*background:           lightsteelblue1",$
"Idl*lamp*mic*XmText*foreground:           black",$
"Idl*lamp*mic*XmList*background:           lightsteelblue2",$
"Idl*lamp*mic*XmList*foreground:           steelblue4",$
"Idl*lampmic*discret*background:           lightsteelblue1",$
"Idl*lampmic*discret*foreground:           steelblue4",$
"Idl*lampmic*XmPushButton*background:      lightsteelblue2",$
"Idl*lampmic*XmPushButton*foreground:      steelblue4",$
"Idl*lampmic*XmCascadeButton*background:   lightsteelblue2",$
"Idl*lampmic*XmCascadeButton*foreground:   steelblue4",$
"Idl*lampmic*XmToggleButton*selectColor:   lightsteelblue",$
"Idl*lampmic*XmLabel*foreground:           steelblue4",$
"Idl*lampmic*XmText*background:            lightsteelblue1",$
"Idl*lampmic*XmText*foreground:            black",$
"Idl*lampmic*XmList*background:            lightsteelblue2",$
"Idl*lampmic*XmList*foreground:            steelblue4",$
"Idl*lampmic*red*background:               lightsteelblue2",$
"Idl*lampmic*red*foreground:               red"]

txts=[txts,$

"Idl*lamp*did*discret*background:          lightsteelblue2",$
"Idl*lamp*did*discret*foreground:          steelblue4",$
"Idl*lamp*did*XmPushButton*background:     lightsteelblue",$
"Idl*lamp*did*XmPushButton*foreground:     steelblue4",$
"Idl*lamp*did*XmCascadeButton*background:  lightsteelblue",$
"Idl*lamp*did*XmCascadeButton*foreground:  steelblue4",$
"Idl*lamp*did*XmToggleButton*selectColor:  lightsteelblue",$
"Idl*lamp*did*XmLabel*foreground:          steelblue4",$
"Idl*lamp*did*XmText*background:           lightsteelblue2",$
"Idl*lamp*did*XmText*foreground:           black",$
"Idl*lamp*did*XmList*background:           lightsteelblue1",$
"Idl*lamp*did*XmList*foreground:           steelblue4",$
"Idl*lampdid*discret*background:           lightsteelblue2",$
"Idl*lampdid*discret*foreground:           steelblue4",$
"Idl*lampdid*XmPushButton*background:      lightsteelblue",$
"Idl*lampdid*XmPushButton*foreground:      steelblue4",$
"Idl*lampdid*XmCascadeButton*background:   lightsteelblue",$
"Idl*lampdid*XmCascadeButton*foreground:   steelblue4",$
"Idl*lampdid*XmToggleButton*selectColor:   lightsteelblue",$
"Idl*lampdid*XmLabel*foreground:           steelblue4",$
"Idl*lampdid*XmText*background:            lightsteelblue2",$
"Idl*lampdid*XmText*foreground:            black",$
"Idl*lampdid*XmList*background:            lightsteelblue1",$
"Idl*lampdid*XmList*foreground:            steelblue4"]

txts=[txts,$

"Idl*lamp*don*discret*background:          lightsteelblue3",$
"Idl*lamp*don*discret*foreground:          steelblue4",$
"Idl*lamp*don*XmPushButton*background:     lightsteelblue",$
"Idl*lamp*don*XmPushButton*foreground:     steelblue4",$
"Idl*lamp*don*XmCascadeButton*background:  lightsteelblue",$
"Idl*lamp*don*XmCascadeButton*foreground:  steelblue4",$
"Idl*lamp*don*XmToggleButton*selectColor:  lightsteelblue",$
"Idl*lamp*don*XmLabel*foreground:          steelblue4",$
"Idl*lamp*don*XmText*background:           lightsteelblue3",$
"Idl*lamp*don*XmText*foreground:           black",$
"Idl*lamp*don*XmList*background:           lightsteelblue2",$
"Idl*lamp*don*XmList*foreground:           steelblue4",$
"Idl*lampdon*discret*background:           lightsteelblue3",$
"Idl*lampdon*discret*foreground:           steelblue4",$
"Idl*lampdon*XmPushButton*background:      lightsteelblue",$
"Idl*lampdon*XmPushButton*foreground:      steelblue4",$
"Idl*lampdon*XmCascadeButton*background:   lightsteelblue",$
"Idl*lampdon*XmCascadeButton*foreground:   steelblue4",$
"Idl*lampdon*XmToggleButton*selectColor:   lightsteelblue",$
"Idl*lampdon*XmLabel*foreground:           steelblue4",$
"Idl*lampdon*XmText*background:            lightsteelblue3",$
"Idl*lampdon*XmText*foreground:            black",$
"Idl*lampdon*XmList*background:            lightsteelblue2",$
"Idl*lampdon*XmList*foreground:            steelblue4"]

txts=[txts,$

"Idl*lamp*ben*discret*background:          lightsteelblue3",$
"Idl*lamp*ben*discret*foreground:          steelblue4",$
"Idl*lamp*ben*XmPushButton*background:     lightsteelblue",$
"Idl*lamp*ben*XmPushButton*foreground:     steelblue4",$
"Idl*lamp*ben*XmCascadeButton*background:  lightsteelblue",$
"Idl*lamp*ben*XmCascadeButton*foreground:  steelblue4",$
"Idl*lamp*ben*XmToggleButton*selectColor:  lightsteelblue",$
"Idl*lamp*ben*XmLabel*foreground:          steelblue4",$
"Idl*lamp*ben*XmText*background:           lightsteelblue3",$
"Idl*lamp*ben*XmText*foreground:           black",$
"Idl*lamp*ben*XmList*background:           lightsteelblue2",$
"Idl*lamp*ben*XmList*foreground:           steelblue4",$
"Idl*lampben*discret*background:           lightsteelblue3",$
"Idl*lampben*discret*foreground:           steelblue4",$
"Idl*lampben*XmPushButton*background:      lightsteelblue",$
"Idl*lampben*XmPushButton*foreground:      steelblue4",$
"Idl*lampben*XmCascadeButton*background:   lightsteelblue",$
"Idl*lampben*XmCascadeButton*foreground:   steelblue4",$
"Idl*lampben*XmToggleButton*selectColor:   lightsteelblue",$
"Idl*lampben*XmLabel*foreground:           steelblue4",$
"Idl*lampben*XmText*background:            lightsteelblue3",$
"Idl*lampben*XmText*foreground:            black",$
"Idl*lampben*XmList*background:            lightsteelblue2",$
"Idl*lampben*XmList*foreground:            steelblue4"]

txts=[txts,$

"Idl*lamptouch*discret*background:         lightsteelblue",$
"Idl*lamptouch*discret*foreground:         steelblue4",$
"Idl*lamptouch*XmPushButton*background:    lightsteelblue2",$
"Idl*lamptouch*XmPushButton*foreground:    steelblue4",$
"Idl*lamptouch*XmCascadeButton*background: lightsteelblue2",$
"Idl*lamptouch*XmCascadeButton*foreground: steelblue4",$
"Idl*lamptouch*XmToggleButton*selectColor: lightsteelblue2",$
"Idl*lamptouch*XmLabel*foreground:         steelblue4",$
"Idl*lamptouch*XmText*background:          lightsteelblue1",$
"Idl*lamptouch*XmText*foreground:          black",$
"Idl*lamptouch*XmList*background:          lightsteelblue2",$
"Idl*lamptouch*XmList*foreground:          steelblue4"]
END

function finefile, pth, count=nn
;+
;*******
;** Pb MacosX (duplicated!)
;-
if !version.release gt '5.5' then return,call_function('file_search',pth,count=nn) $
                             else return,call_function('findfile'   ,pth,count=nn)
end

PRO chk_kernel, cnt,wnt, fromlamp=fromlamp
;+
;** **********
;** check if lamp should be re_compiled when it starts
;-
forward_function sys_dep

ii=finefile('.must.upd',count=mnt)
ii=finefile('lamp.exe' ,count=cnt)
ii=finefile('lamp.sav' ,count=wnt)
if (mnt gt 0) or (cnt+wnt eq 0) then begin ;must compile the kernel
   CATCH,stat & if stat eq 0 then begin
     if not sys_dep('DEMO') then $
     if mnt gt 0 then begin & openr,u,'.must.upd',/delete,/get_lun & free_lun,u & endif
     print,'Re-compiling lamp kernel ...' & wait,.1
     if keyword_set(fromlamp) then RESOLVE_ROUTINE,['dids','dons','bens','lampico','scan'] $
                              else RESOLVE_ROUTINE,['lamp','dids','dons','bens','lampico','scan']
     save,/routines,filename="lamp.sav" & wnt=1
     print,'Lamp has been re-compiled'
   endif else print, 'Warning: Lamp should be re-compiled !!! (see AA_README.txt)'
endif

end

FUNCTION sys_dep, flag, p1,p2,p3,p4
;+
;******* *******
;** system commands legacy for old IDL versions
;-

common c_def,c_init,Lamp_Dir,LF,viewer,ziper,giftrans

os =!VERSION.OS
Vs =fix(strmid(string(!version.release),0,1))
res=0
if (!prompt eq 'I2M>') or (strpos(!path,'matlablib') ge 0) then matlab=1 else matlab=0
if (!prompt eq 'I2S>') or (strpos(!path,'scilablib') ge 0) then scilab=1 else scilab=0

IF (n_elements(c_init) eq 0) or (flag eq 'PSEUDO') THEN BEGIN ; Allow new colors in runtime (prevent having core.rt)
        if n_elements(c_init) eq 0 then begin & viewer='' & Lamp_Dir='' & endif
        c_init=1

        if  float(!version.release) ge 5.1 then demo=CALL_FUNCTION('lmgr',/DEMO) else demo=0
        CASE os of
               'MacOS': begin &  LF = STRING(13B) & end
               'Win32': begin  & end
               'vms':   begin &  ad='sys$login:lamp.resourc6' & a=finefile(ad,count=cnt)
                               if not demo then $
                               if cnt eq 0 then begin & lamp_resource,txts  & u=0 & n=n_elements(txts)-1
                                  ON_ioerror,misrsv & openw,u,ad,/get_lun & for i=0,n do printf,u,txts[i]
                                  free_lun,u & spawn, 'copy/noconf '+ad+' sys$login:decw$xdefaults.dat' & misrsv:
                               endif
                        end
               ELSE:    begin & ;if os ne 'darwin' then spawn, 'unalias rm ; unalias cp ; unalias mv'
                               ad=expand_path('~')+'/.lamp.resourc85c' & a=finefile(ad,count=cnt)
                               if not demo then $
                               if cnt eq 0 then begin & lamp_resource,txts  & u=0 & n=n_elements(txts)-1
                                    ON_ioerror,misrsu  & openw,u,ad,/get_lun & for i=0,n do printf,u,txts[i]
                                    free_lun,u & cnt=1 & misrsu:
                               endif
                               if (cnt ge 1) and ((!D.flags and 65536) gt 0) then begin
                                 scd='/usr/bin/X11/xrdb'     & bid=finefile(scd,count=cnt)
                                 if cnt lt 1 then begin
                                 scd='/usr/X11/bin/xrdb'     & bid=finefile(scd,count=cnt) & endif
                                 if cnt lt 1 then begin
                                 scd='/opt/X11/bin/xrdb'     & bid=finefile(scd,count=cnt) & endif
                                 if cnt lt 1 then begin
                                 scd='/usr/X11R6/bin/xrdb'   & bid=finefile(scd,count=cnt) & endif
                                 if cnt lt 1 then begin
                                 scd='/usr/openwin/bin/xrdb' & bid=finefile(scd,count=cnt) & endif

                                 if  cnt ge 1 then spawn,  scd + ' -merge '+ad
                               endif
                        end
        ENDCASE
ENDIF
; or (flag eq 'PSEUDO') should be omited for next embeded version (8)
if (n_elements(ziper) ne 4) or (flag eq 'PSEUDO') then begin & ziper=['-','-','-','-'] ;Zip,UnZip,GZip,GunZip
        CASE os of
         'vms':   begin
                      end
         'MacOS': begin
                  end
         'Win32': begin & bid= finefile(!Dir+'\gzip.exe',count=nn)
                              if nn eq 0 then zipd='gzip' else $
                              if strpos(!Dir,' ') gt 0  then zipd='"'+!Dir+'\gzip"' $
                                                        else zipd=!Dir+'\gzip'
                              ziper[0]=zipd+' -fq '  &  ziper[2]=zipd+' -fq '
                              ziper[1]=zipd+' -dfq ' &  ziper[3]=zipd+' -dfq '
                  end
          ELSE:   begin & spawn,'whereis gzip',str
                            cnt=strpos(str,'/gzip')  &  cnt=where([cnt] ge 0)
                            if cnt[0] ge 0 then begin & ziper[2]='gzip -fq '  ;
                                                        ziper[3]='gzip -dfq ' & endif
                            spawn,'whereis zip',str
                            cnt=strpos(str,'/zip')   &  cnt=where([cnt] ge 0)
                            if cnt[0] ge 0 then begin & ziper[0]='zip -mq '   ;
                                                        ziper[1]='unzip -qqux '
                            endif          else begin & ziper[0]=ziper[2]
                                                        ziper[1]=ziper[3]     & endelse
                            if ziper[2] eq '-'  then    ziper[2]='compress -f '
                            if ziper[3] eq '-'  then    ziper[3]='uncompress -f '
                        end
        ENDCASE
ENDIF

CASE flag of

           ;Add p1 to idl path
           ; -----------------
'ADDPATH': IF strpos(!path,p1) lt 0 then BEGIN
              CASE os of
              'vms':   !path=p1+ ',' +!path
              'MacOS': !path=p1+':,' +!path
              'Win32': !path=p1+ ';' +!path
               ELSE:   !path=p1+ ':' +!path
              ENDCASE
           ENDIF

           ;After Desktop is realized or Stop
           ; --------------------------------
'AFTER' : BEGIN & CASE os of
           'Win32': if Vs eq 4 then DEVICE,main_window=0
            ELSE:
            ENDCASE
          END
'AFTES' : BEGIN & CASE os of
           'Win32': if Vs eq 4 then DEVICE,main_window=1
            ELSE:
            ENDCASE
          END

         ;return 1 if we are at ILL
'AT_ILL': BEGIN & res=0
           host      =strlowcase(GETENV('HOST'))
           domain    =strlowcase(GETENV('USERDNSDOMAIN')) ;-> ill.fr
           ftp_proxy =strlowcase(GETENV('ftp_proxy'))
           http_proxy=strlowcase(GETENV('http_proxy'))
           remote    =strlowcase(GETENV('REMOTEHOST'))
           hostname  =[''] & call_procedure,'spawn','hostname',hostname,/noshell
           dnsdomain =[''] & if os eq 'linux' then call_procedure,'spawn','dnsdomainname',dnsdomain,/noshell
           if (strpos(host       ,'ill.') ge 0) or (strpos(domain   ,'ill.')  ge 0) $
           or (strpos(hostname[0],'ill.') ge 0) or (strpos(ftp_proxy,'ill.')  ge 0) $
           or (strpos(http_proxy ,'ill.') ge 0) or (strpos(remote    ,'ill.') ge 0) $
           or (strpos(dnsdomain  ,'ill.') ge 0) then res=1
          END
          
           ;Remove all blanks from a string exept for Mac dossiers
           ; -----------------------------------------------------
'BLANKS' : BEGIN & CASE os of
            'MacOS' : res=strtrim(    p1,2)
            'Win32' : res=strtrim(    p1,2)
            'darwin': res=strtrim(    p1,2)
             ELSE:    res=strcompress(p1,/remove_all)
             ENDCASE
           END

           ;Call a browser
           ; -------------
'BROWSE' : BEGIN & CASE os of
            'vms':   begin &  spawn,'netscape '+p1,/NOWAIT
                     end
            'Win32': begin &  IF !version.release ge '5.4' THEN $
                          if strpos(p1,'://') lt 0 then spawn,/nowait,/hide,p1 $
                          else begin &  dv=getenv("SystemDrive")
                                Fexpl=dv+'\Program Files\internet explorer\iexplore.exe'
                                a=finefile(Fexpl,count=cnt)
                                if cnt gt 0 then ic='"'+Fexpl+'" '  +p1 else ic='start '+p1
                                spawn,/nowait,/hide,ic
                          endelse
                      end
            'MacOS': begin &  spawn, MACCREATOR='MOSS',  p1
                     end
            'darwin':begin &  spawn,'open "'+p1+'"'
                     end
              ELSE:  begin & ic="netscape -install -remote 'openURL  (" +p1 +",new-window)'" +" &"
                               spawn,  'whereis firefox'  ,ret
                               cnt=strpos(ret,'/firefox')
                               cnt=where([cnt] ge 0)
                               if cnt[0] ge 0 then ic ='firefox   "'+p1 +'" &'
                           if cnt[0] lt 0 then begin
                               spawn,  'whereis mozilla'  ,ret
                               cnt=strpos(ret,'/mozilla')
                               cnt=where([cnt] ge 0)
                               if cnt[0] ge 0 then ic ='mozilla   "'+p1 +'" &' & endif
                           if cnt[0] lt 0 then begin
                               spawn,  'whereis konqueror',ret
                               cnt=strpos(ret,'/konqueror')
                               cnt=where([cnt] ge 0)
                               if cnt[0] ge 0 then ic ='konqueror "'+p1 +'" &' & endif
                           if cnt[0] lt 0 then begin
                               spawn,  'whereis opera'    ,ret
                               cnt=strpos(ret,'/opera')
                               cnt=where([cnt] ge 0)
                               if cnt[0] ge 0 then ic ='opera     "'+p1 +'" &' & endif

                           spawn,ic
                     end
              ENDCASE
           END

           ;Copy files in string p1 (separ. by blancs) from directory p2 to current directory
           ; ---------------------- ------------------ ----------------- --------------------
'COPY':    BEGIN & CASE os of
            'vms':  begin
                      tmp=byte(strcompress(strtrim(p1,2)))
                      idx=where(tmp eq 32)
                      if idx[0] gt 0 then tmp[idx]=byte(',')
                      tmp=string(tmp)
                      cd,current=mee
                      if n_elements(p3) gt 0 then mee=mee+p3
                      spawn ,'copy/noconf '+p2+tmp+' '+mee+'*'
                    end
            'Win32':begin
                      cd,current=mee
                      if n_elements(p3) gt 0 then mei=mee+'\'+p3 else mei=mee
                      IF !version.release ge '5.2' THEN BEGIN
                        files=strsplit(/EXTRACT,p1,' ') & mei=mei+'\'
                        for ip1 = 0, n_elements( files)-1 do begin
                          if files[ip1] gt ' ' then begin
                             binin =    read_binary(p2 + files[ip1])
                             on_ioerror,free
                             openw   , u, mei+files[ip1], /get_lun
                             writeu  , u, binin
                             free:free_lun, u
                          endif
                        endfor
                      ENDIF ELSE BEGIN
                        cd,p2
                        command_line='cp '+p1+' '+mei
                        spawn, command_line
                        cd,mee
                      ENDELSE
                     end
             'MacOS':begin
                    ; Get the current dir
                      cd, CURRENT=toFolder
                    ; We need to use ToolServer because of the unix WildCard character (*)
                      Print, "SD :Copy From " + p2 + " " + p1 + " to folder " + toFolder

                    ; NOTE : WildCard can be very very slow (2 to 5 minutes) on NFS volume mount by "MacNFS" : Don't use it !

                    ; Translate unix WildCard (*) to ToolServer WildCard (�)
                      t1=strcompress(strtrim(p1,2))
                      WHILE (STRPOS(t1, '*') NE -1) DO STRPUT, t1, '�', Index

                      Build_ToolServerFileListFromString, p2, t1, toolServerFileList
                      toolServerScript = "directory  " + toFolder + " ; " + $
                                         "duplicate -y " + toolServerFileList + " : ; " + $
                                         "setfile -t 'ZIVU' -c 'Gzip' �.Z"

                      script = [  'tell application "' + Lamp_Dir + 'Helpers:ToolServer:ToolServer"', $
                                    '      DoScript "' + toolServerScript + '"', $
                                  'end tell' ]

                      DO_APPLE_SCRIPT, script
                    ; ToolServer ne renvoit pas de r�sultat pour cette commande ?!?
                      res = 1
                  end
          ELSE:   begin
                      cd,current=mee
                      if n_elements(p3) gt 0 then mee=mee+'/'+p3
                      spawn, 'cd '+p2 + '; cp '   + p1 + ' "'+mee+'"'
                  end
           ENDCASE
           END

           ;Delete file p1
           ; -------------
'DELET':   BEGIN & ON_IOERROR,mis_opd
           CASE os of
            'vms':   begin & OPENR ,out1,p1,/get_lun,/DELETE & FREE_LUN,out1 & end
            'MacOS': begin & OPENR ,out1,p1,/get_lun,/DELETE & FREE_LUN,out1 & end
            'Win32': begin & OPENR ,out1,p1,/get_lun,/DELETE & FREE_LUN,out1 & end
            'Other': spawn,'rm -f '   +p1
             ELSE:   begin & OPENR ,out1,p1,/get_lun,/DELETE & FREE_LUN,out1 & end
           ENDCASE
           mis_opd:
           END

           ;Delete a file list p1
           ; ----------------- --
'DELIST':  BEGIN & ON_IOERROR,mis_opdl
           CASE os of
            'vms':   for i=0,n_elements(p1)-1 do begin
                         OPENR ,out1,p1[i]    ,/get_lun,/DELETE & FREE_LUN,out1 & endfor
            'MacOS': for i=0,n_elements(p1)-1 do begin
                         OPENR ,out1,p1[i]    ,/get_lun,/DELETE & FREE_LUN,out1 & endfor
            'Win32': for i=0,n_elements(p1)-1 do begin
                         OPENR ,out1,p1[i]    ,/get_lun,/DELETE & FREE_LUN,out1 & endfor
             ELSE:   spawn, ['rm' ,'-f' , p1] ,/noshell
           ENDCASE
           mis_opdl:
           END

           ;List current directory, return a file ascending list
           ; ---------------------  ----------------------------
'DIR':     BEGIN & CASE os of
             'vms':   p1=finefile(count=p2)
             'Win32': begin
                 ;CAG - due to the redirection problem in Win32 I am using IDL
                  cd,current=mee
                  p1=finefile(mee+'\*',count=p2)
                  end
             'MacOS': begin
                 ; NOTE : if we pass a non existent reference to the finder,
                 ; we will end up in a "dialog with OK button" at the finder level
                   script = [  'tell application "Finder"',$
                               '   if  (exists folder "' + p1 + '") then',$
                               '      name of items in container "' + p1 + '"' + LF,$
                               '   else',$
                               '      set result to ""' + LF,$
                               '   end if' + LF,$
                               'end tell' ]
                   DO_APPLE_SCRIPT, script, RESULT=p1
                   res = p1
                   p2 = n_elements(p1)
                  end
              ELSE:  spawn, ['ls'] ,p1 ,count=p2 ,/NOSHELL
           ENDCASE
           END

           ;List directories of current directory with modified date
           ; --------------- -- ----------------- ---- -------- ----
'DIRD':    BEGIN & CASE os of
            'vms':   spawn,'dir/date' +p1+ '*.dir' ,res
            'Win32': p3=0 ; CAG need to be implemented
            'MacOS':
             ELSE:   spawn,'ls -ld '  +p1+ '*'     ,res
           ENDCASE
           END

           ;Return the path divider
           ; ----------------------
'DIVIDER': BEGIN & CASE os of
            'vms':   res = ""
            'Win32': res = "\"
            'MacOS': res = ":"
             ELSE:   res = "/"
           ENDCASE
           END

           ; For IDL versions 4.0.1 and newer, find all label widgets
           ; rooted and the specified top level widget and set their
           ; DYNAMIC_RESIZE property.
           ; -----------------------
'DYNLAB':  IF (Vs GE 4) THEN BEGIN

            IF p2 gt 0 THEN IF !version.release ne '4.0' THEN $
            CASE os of
            'Win32':
             ELSE:         CALL_PROCEDURE,'dynlabel_call', p1
            ENDCASE

            CASE os of
            'MacOS': begin & if n_elements(p3) ne 1 then p3=-15
                           CALL_PROCEDURE,'resizeButton_call', p1, p3
                     end
             ELSE:
            ENDCASE
           ENDIF

           ;RPC modules entries (ILL use only)
           ; ------------------
'ENTRY':   BEGIN & CASE os of
           'vms':   res='r_mic'
           'sunos': res='r_micc_'
           'IRIX':  res='r_micc_'
           'hp-ux': res='r_micc'
            ELSE:   res='r_micc'
            ENDCASE
           END

           ;RPC modules (ILL use only)
           ; ----------
'EXEC':    BEGIN & CASE os of
           'sunos': res=p1+'/lamp_mac/r_mic_SUN.so'
           'IRIX':  res=p1+'/lamp_mac/r_mic_SGI.so'
           'hp-ux': res=p1+'/lamp_mac/r_mic_HP.so'
            ELSE:   res=''
            ENDCASE
           END

           ;EXIT from Lamp application
           ; -------------------------
'EXIT':    BEGIN & CASE os of
               'MacOS': EXIT
               'Win32': EXIT
                ELSE:   EXIT
           ENDCASE
           END

           ;Font for drawing area
           ; --------------------
'FONTD':   BEGIN & CASE os of
               'vms':   res='6x13bold'
               'MacOS': res='geneva*9'
               'darwin':res='-adobe-helvetica-medium-r-normal--10-100-75-75-p-56-iso8859-10'
               'Win32': res='arial*bold*12'
               'linux': res='fixed'
                ELSE:   res='-adobe-courier-medium-r-normal--12-120-*-*-*-*-*-*'
           ENDCASE
           END

           ;Fonts for large(0) middle(1) and small(2) UIs
           ; --------------------------------------------
'FONTS':   BEGIN
;          Large UI
           propor0   = '-adobe-courier-bold-r-normal--14-140-*-*-*-*-*-*'
          ;biggest0  = '-bitstream-charter-bold-r-normal--19-180-75-75-p-119-*-*'
          ;bigger0   = '-bitstream-charter-medium-r-normal--17-120-100-100-p-95-*-*'
          ;b_bigger0 = '-bitstream-charter-bold-r-normal--17-120-*-*-*-*-*-*'
          ;normal0   = '-bitstream-charter-medium-r-normal--15-140-75-75-p-84-*-*'
          ;b_normal0 = '-bitstream-charter-bold-i-normal--15-140-75-75-p-93-*-*'
          ;smaller0  = '-bitstream-charter-medium-r-normal--12-120-75-75-p-67-*-*'
          ;smallest0 = '-bitstream-charter-medium-r-normal--10-100-75-75-p-56-*-*'
           biggest0  = '-adobe-times-bold-r-normal--18-180-75-75-p-*-*-*'
           bigger0   = '-adobe-courier-medium-r-normal--14-140-75-75-*-*-*-*'
           b_bigger0 = '-adobe-courier-bold-r-normal--14-140-75-75-*-*-*-*'
           normal0   = '-adobe-times-medium-r-normal--14-140-75-75-p-*-*-*'
           b_normal0 = '-adobe-times-bold-i-normal--14-140-75-75-p-*-*-*'
           smaller0  = '-adobe-times-medium-r-normal--12-120-75-75-p-*-*-*'
           smallest0 = '-adobe-times-medium-r-normal--10-100-75-75-p-*-*-*'

;          Middle UI
           propor1   = '-adobe-courier-bold-r-normal--14-140-*-*-*-*-*-*'
           biggest1  = '-adobe-courier-bold-r-normal--14-140-*-*-*-*-*-*'
           bigger1   = '-adobe-courier-medium-r-normal--14-140-*-*-*-*-*-*'
           b_bigger1 = '-adobe-courier-bold-r-normal--14-140-*-*-*-*-*-*'
          ;normal1   = '-adobe-times-medium-i-normal--14-140-*-*-*-*-*-*'
          ;b_normal1 = '-adobe-times-bold-i-normal--14-140-*-*-*-*-*-*'
           normal1   = '-adobe-times-medium-r-normal--12-120-*-*-*-*-*-*'
           b_normal1 = '-adobe-times-bold-r-normal--12-120-*-*-*-*-*-*'
           smaller1  = '-adobe-times-medium-r-normal--12-120-*-*-*-*-*-*'
           smallest1 = '-adobe-times-medium-r-normal--10-100-*-*-*-*-*-*'

;          Small UI
           propor2   = '-adobe-courier-bold-r-normal--10-100-*-*-*-*-*-*'
           biggest2  = propor2
           bigger2   = '-adobe-courier-medium-r-normal--10-100-*-*-*-*-*-*'
           b_bigger2 = propor2
           normal2   = bigger2
           b_normal2 = propor2
           smaller2  = propor2
           smallest2 = bigger2

           res=[[propor0,biggest0,bigger0,b_bigger0,normal0,b_normal0,smaller0,smallest0],$
                [propor1,biggest1,bigger1,b_bigger1,normal1,b_normal1,smaller1,smallest1],$
                [propor2,biggest2,bigger2,b_bigger2,normal2,b_normal2,smaller2,smallest2]]

           CASE os of
               'vms':  begin & res[*,0]=res[*,1]
                             res[1,0]='-adobe-times-bold-r-normal--18-180-*-*-*-*-*-*' & end
               'sunos':begin & res[*,0]=res[*,1]
                             res[1,0]='-adobe-times-bold-r-normal--18-180-*-*-*-*-*-*' & end
               'Win32':begin
                        propor0   = 'courier new*bold*14'
                        biggest0  = 'arial*bold*19'
                        bigger0   = 'arial *17'
                        b_bigger0 = 'arial*bold*17'
                        normal0   = 'arial *15'
                        b_normal0 = 'arial*bold*italic*15'
                        smaller0  = 'arial *12'
                        smallest0 = 'courier new*12'

                        biggest1  = 'arial*bold*15'
                        b_bigger1 = 'courier new*bold*16'
                        bigger1   = 'arial*bold*14'
                        propor1   = 'courier new*bold*14'
                        normal1   = 'arial*bold*11'
                        b_normal1 = 'arial*bold*14'
                        smaller1  = 'courier new*12'
                        smallest1 =  smaller1

                        biggest2  = 'courier new*bold*16'
                        b_bigger2 = 'courier new*bold*16'
                        bigger2   = 'arial*bold*14'
                        propor2   = 'arial*bold*14'
                        normal2   = 'arial*bold*11'
                        b_normal2 = 'arial*bold*14'
                        smaller2  = 'courier new*12'
                        smallest2 =  smaller2

                        res=[[propor0,biggest0,bigger0,b_bigger0,normal0,b_normal0,smaller0,smallest0],$
                             [propor1,biggest1,bigger1,b_bigger1,normal1,b_normal1,smaller1,smallest1],$
                             [propor2,biggest2,bigger2,b_bigger2,normal2,b_normal2,smaller2,smallest2]]
                       end
               'MacOS':begin
                        biggest0  = 'geneva*bold*12'
                        b_bigger0 = 'geneva*bold*11'
                        bigger0   = 'geneva*11'
                        propor0   = 'monaco*10'
                        normal0   = 'geneva*10'
                        b_normal0 = 'geneva*bold*10'
                        smaller0  = 'geneva*9'
                        smallest0 = 'geneva*7'

                        biggest1  = 'geneva*bold*12'
                        b_bigger1 = 'geneva*bold*11'
                        bigger1   = 'geneva*11'
                        propor1   = 'monaco*9'
                        normal1   = 'geneva*10'
                        b_normal1 = 'geneva*bold*10'
                        smaller1  = 'geneva*8'
                        smallest1 = 'geneva*7'

                        biggest2  = 'geneva*bold*11'
                        b_bigger2 = 'geneva*bold*10'
                        bigger2   = 'geneva*10'
                        propor2   = 'monaco*9'
                        normal2   = 'monaco*9'
                        b_normal2 = 'geneva*10'
                        smaller2  = 'geneva*8'
                        smallest2 = 'geneva*7'

                        res=[[propor0,biggest0,bigger0,b_bigger0,normal0,b_normal0,smaller0,smallest0],$
                             [propor1,biggest1,bigger1,b_bigger1,normal1,b_normal1,smaller1,smallest1],$
                             [propor2,biggest2,bigger2,b_bigger2,normal2,b_normal2,smaller2,smallest2]]
                       end
               'darwin':begin ; Large UI
                        propor0   = '-schumacher-clean-bold-r-normal--14-140-75-75-c-80-iso646.1991-irv'
                        biggest0  = '-adobe-helvetica-bold-r-normal--18-180-75-75-p-103-iso8859-15'
                        bigger0   = '-adobe-helvetica-medium-r-normal--18-180-75-75-p-98-iso8859-15'
                        b_bigger0 = '-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-14'
                        normal0   = '-adobe-helvetica-medium-r-normal--14-140-75-75-p-77-iso8859-14'
                        b_normal0 = '-adobe-helvetica-bold-o-normal--14-140-75-75-p-82-iso8859-14'
                        smaller0  = '-adobe-helvetica-medium-r-normal--12-120-75-75-p-67-iso8859-13'
                        smallest0 = '-adobe-helvetica-medium-r-normal--10-100-75-75-p-56-iso8859-10'
                             ; Middle UI
                        propor1   = '-adobe-courier-bold-r-normal--12-120-75-75-m-70-iso8859-1'
                       ;propor1   = '-misc-fixed-bold-r-normal--13-120-75-75-c-70-iso8859-1' ;Thomas
                        biggest1  = '-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-14'
                        bigger1   = '-adobe-helvetica-medium-r-normal--14-140-75-75-p-77-iso8859-14'
                        b_bigger1 = '-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-14'
                        normal1   = '-adobe-helvetica-medium-r-normal--12-120-75-75-p-67-iso8859-13'
                        b_normal1 = '-adobe-helvetica-bold-r-normal--12-120-75-75-*-*-*-*'
                        smaller1  = '-adobe-helvetica-medium-r-normal--10-100-75-75-p-56-iso8859-10'
                        smallest1 = '-adobe-helvetica-medium-r-normal--8-*-*-*-*-*-*-*'
                       ;biggest1  = '-adobe-helvetica-medium-r-normal--10-*-*-*-*-*-*-*'
                       ;bigger1   = '-adobe-helvetica-medium-r-normal--10-*-*-*-*-*-*-*'
                       ;b_bigger1 = '-adobe-helvetica-bold-r-normal--10-*-*-*-*-*-*-*'
                       ;normal1   = '-adobe-helvetica-medium-r-normal--9-*-*-*-*-*-*-*'
                       ;b_normal1 = '-adobe-helvetica-bold-r-normal--9-*-*-*-*-*-*-*'
                       ;smaller1  = '-adobe-helvetica-medium-r-normal--8-*-*-*-*-*-*-*'
                       ;smallest1 = '-adobe-helvetica-medium-r-normal--8-*-*-*-*-*-*-*'
                             ; Small UI
                        propor2   = '-schumacher-clean-bold-r-normal--10-100-75-75-c-60-iso646.1991-irv'
                        biggest2  = propor2
                        bigger2   = '-schumacher-clean-medium-r-normal--10-100-75-75-c-50-iso646.1991-irv'
                        b_bigger2 = propor2
                        normal2   = bigger2
                        b_normal2 = propor2
                        smaller2  = propor2
                        smallest2 = bigger2

                        res=[[propor0,biggest0,bigger0,b_bigger0,normal0,b_normal0,smaller0,smallest0],$
                             [propor1,biggest1,bigger1,b_bigger1,normal1,b_normal1,smaller1,smallest1],$
                             [propor2,biggest2,bigger2,b_bigger2,normal2,b_normal2,smaller2,smallest2]]
                        end
                 ELSE:  begin ; Large UI
                          propor0   = '-schumacher-clean-bold-r-normal--14-140-*-*-c-80-iso646.1991-irv'
                          biggest0  = '-adobe-helvetica-bold-r-normal--18-180-*-*-p-103-iso8859-15'
                          bigger0   = '-adobe-helvetica-medium-r-normal--18-180-*-*-p-98-iso8859-15'
                          b_bigger0 = '-adobe-helvetica-bold-r-normal--14-140-*-*-p-82-iso8859-14'
                          normal0   = '-adobe-helvetica-medium-r-normal--14-140-*-*-p-77-iso8859-14'
                          b_normal0 = '-adobe-helvetica-bold-o-normal--14-140-*-*-p-82-iso8859-14'
                          smaller0  = '-adobe-helvetica-medium-r-normal--12-120-*-*-p-67-iso8859-13'
                          smallest0 = '-adobe-helvetica-medium-r-normal--10-100-*-*-p-56-iso8859-10'
                          ; Middle UI
                          propor1   = '-adobe-courier-bold-r-normal--12-120-*-*-m-70-iso8859-1'
                          ;propor1   = '-misc-fixed-bold-r-normal--13-120-75-75-c-70-iso8859-1' ;Thomas
                          biggest1  = '-adobe-helvetica-bold-r-normal--14-140-*-*-p-82-iso8859-14'
                          bigger1   = '-adobe-helvetica-medium-r-normal--14-140-*-*-p-77-iso8859-14'
                          b_bigger1 = '-adobe-helvetica-bold-r-normal--14-140-*-*-p-82-iso8859-14'
                          normal1   = '-adobe-helvetica-medium-r-normal--12-120-*-*-p-67-iso8859-13'
                          b_normal1 = '-adobe-helvetica-bold-r-normal--12-120-*-*-*-*-*-*'
                          smaller1  = '-adobe-helvetica-medium-r-normal--10-100-*-*-p-56-iso8859-10'
                          smallest1 = '-adobe-helvetica-medium-r-normal--8-*-*-*-*-*-*-*'
                          ;biggest1  = '-adobe-helvetica-medium-r-normal--10-*-*-*-*-*-*-*'
                          ;bigger1   = '-adobe-helvetica-medium-r-normal--10-*-*-*-*-*-*-*'
                          ;b_bigger1 = '-adobe-helvetica-bold-r-normal--10-*-*-*-*-*-*-*'
                          ;normal1   = '-adobe-helvetica-medium-r-normal--9-*-*-*-*-*-*-*'
                          ;b_normal1 = '-adobe-helvetica-bold-r-normal--9-*-*-*-*-*-*-*'
                          ;smaller1  = '-adobe-helvetica-medium-r-normal--8-*-*-*-*-*-*-*'
                          ;smallest1 = '-adobe-helvetica-medium-r-normal--8-*-*-*-*-*-*-*'
                          ; Small UI
                          propor2   = '-schumacher-clean-bold-r-normal--10-100-*-*-c-60-iso646.1991-irv'
                          biggest2  = propor2
                          bigger2   = '-schumacher-clean-medium-r-normal--10-100-*-*-c-50-iso646.1991-irv'
                          b_bigger2 = propor2
                          normal2   = bigger2
                          b_normal2 = propor2
                          smaller2  = propor2
                          smallest2 = bigger2

                          res=[[propor0,biggest0,bigger0,b_bigger0,normal0,b_normal0,smaller0,smallest0],$
                            [propor1,biggest1,bigger1,b_bigger1,normal1,b_normal1,smaller1,smallest1],$
                            [propor2,biggest2,bigger2,b_bigger2,normal2,b_normal2,smaller2,smallest2]]
                        end

           ENDCASE
           if matlab then begin
                        res=[['ft_propor','ft_biggest','ft_bigger','ft_b_bigger','ft_normal','ft_b_normal','ft_smaller','ft_smallest'],$
                             ['ft_propor','ft_biggest','ft_bigger','ft_b_bigger','ft_normal','ft_b_normal','ft_smaller','ft_smallest'],$
                             ['ft_propor','ft_biggest','ft_bigger','ft_b_bigger','ft_normal','ft_b_normal','ft_smaller','ft_smallest']]
           endif
           END

           ;Environment variable p1: 'LAMP_DIR','USER','HOST','DISPLAY'
           ; ---------------------------------------------------------
'GETENV':  BEGIN & res='' & dvd='/' & sep=':' & if os eq 'Win32' then begin & dvd='\' & sep=';' & endif
           CASE os of
               'MacOS': begin
                           if (p1 eq 'LAMP_DIR') then begin & i = strpos (strlowcase(!path),"lamp_mac")
                              if i le 0       then         i =strpos( strlowcase(!path),"lamp",/reverse_search)+5
                              if i eq 4       then begin & i =finefile('lamp_mac',count=nn)
                                   if nn gt 0 then begin & cd,current=res
                                                        !path=res+':,'+res+':lamp_mac:,' +!path
                                   endif else begin
                                                         i =finefile(!Dir+ ':lamp_mac',count=nn)
                                                         if nn gt 0 then res = !Dir
                                   endelse
                              endif else begin & res=strmid( !path,0,i-1)
                                   i  = strpos( res ,",",/reverse_search)
                                   if i ge 0 then  res=strmid(  res ,i+1,80)
                                   i  = strpos(    strlowcase(!path),  "lamp_mac")
                                   if i lt 0 then !path=res+ ':,'+res+':lamp_mac:,' +!path
                              endelse
                           endif else if (p1 eq 'USER') then begin & res=""

                          ;   script =['tell application "' + Lamp_Dir + 'Helpers:ToolServer:ToolServer"'+LF,$
                          ;            'DoScript "echo -n {user}"' + LF, $
                          ;            'end tell' ]
                          ;   DO_APPLE_SCRIPT, script, RESULT=res

                           endif else if p1 eq 'HOST' then res = "" $
                                 else if p1 eq 'LAMP_EXEC' then res = "" $
                                 else if p1 eq 'DISPLAY'   then res = ":0"
                        end

               'vms':  res = getenv(p1)

                ELSE:  begin & res = getenv(p1)
                        if (p1 eq 'LAMP_DIR') and (res le ' ') then begin
                                                       i  = strpos(  strlowcase(!path),"lamp_mac")
                                 if i le 0  then       i  = strpos(  strlowcase(!path),"lamp",/reverse_search)+5
                                 if i eq 4  then begin & i  =finefile( '..'+dvd+'lamp_mac',count=nn)
                                    CD,current=mee & res=dvd+'lamp'
                                    if nn gt 0 then cd,'..' $
                                    else       i  = finefile('lamp_mac',count=nn)
                                    if nn gt 0 then cd,current=res $
                                    else begin
                                               i  = finefile(!Dir+   dvd+'lamp_mac',count=nn)
                                               if nn gt 0 then res = !Dir $
                                               else begin
                                                    i  = finefile(!Dir+dvd+'..'+dvd+'lamp_mac',count=nn)
                                                    if nn gt 0 then begin
                                                       cd,!Dir+dvd+'..'  &   cd,current=res
                                                    endif else begin
                                                       i= finefile(!Dir+dvd+'..'+dvd+'..'+dvd+'lamp',count=nn)
                                                       if nn gt 0 then begin
                                                          cd,!Dir+dvd+'..'+dvd+'..'+dvd+'lamp' & cd,current=res
                                                       endif
                                                    endelse
                                               endelse
                                    endelse
                                    CD,mee
                                    !path=res+sep+res+dvd+'lamp_mac'+sep +!path
                                 endif else begin & res= strmid( !path,0,i-1)
                                            i  = strpos( res ,sep,/reverse_search)
                                            if i ge 0  then res=strmid(  res ,i+1,80)
                                            i  = strpos(   strlowcase(!path),'lamp_mac')
                                            if i lt 0 then !path=!path+sep+res+sep+res+dvd+'lamp_mac'
                                 endelse
                         endif
                        end
           ENDCASE
           if p1 eq 'LAMP_DIR' then Lamp_Dir = res
           END

           ;Make transparent gif
           ; -------------------
'GIFTRANS':BEGIN & CASE os of
            'vms':
            'Win32':
            'MacOS':
             ELSE: begin & if n_elements(giftrans) eq 0 then begin
                          spawn,'whereis giftrans',ret
                          cnt=strpos(ret,'/giftrans') & cnt=where([cnt] ge 0)
                          if cnt[0] lt 0 then giftrans=0 else giftrans=1
                         endif
                         if giftrans then $
                         spawn,'giftrans -t 0 '+P1+' > '+P1+'t; mv '+P1+'t '+P1
                   end
             ENDCASE
           END


           ;Used for cd,res for home directory
           ; ---------------------------------
'HOME':    BEGIN & CASE os of
            'vms':   res='sys$login:'
            'Win32': cd , current=res
            'MacOS': cd , current=res
             ELSE:   begin & res=expand_path('~') & if res eq '' then res='.' & end
           ENDCASE
           END


           ;Add LAMP_DIR and LAMP_DIR/lamp_mac to idl path
           ; ------------------------------------------------
'IDLPATH': IF strpos(!path,p1) lt 0 then BEGIN
              CASE os of
               'vms':   expa=expand_path('+'+strmid(p1,0,p2-1)+'.lamp_mac]')
               'MacOS': expa=expand_path('+'+p1+':lamp_mac:')
               'Win32': expa=expand_path('+'+p1+'\lamp_mac' )
                ELSE:   expa=expand_path('+'+p1+'/lamp_mac' )
              ENDCASE
              CASE os of
               'vms':   !path=!path+','     +p1+',' +strmid(p1,0,p2-1)+'.lamp_mac]'+',sys$login:'+','+expa
               'MacOS':;!path=!path+','     +p1+':,'+p1+':lamp_mac:'     +','+expa
               'Win32':;!path=!path+';'     +p1+';' +p1+'\lamp_mac'      +';'+expa
                ELSE:   !path=!path+':'     +p1+':' +p1+'/lamp_mac' +':~'+':'+expa
              ENDCASE
           ENDIF

           ;Insert a sub_dir p2 in path p1
           ; -----------------------------
'INSUB':   BEGIN & CASE os of
            'vms':   res =strmid(p1,0,strlen(p1)-1)+ '.' +p2 +']'
            'Win32': res =       p1       +p2 +'\'
            'MacOS': res =       p1       +p2 +':'
             ELSE:   res =       p1       +p2 +'/'
           ENDCASE
           END

           ;Get graphic function number for GXinvert
           ; ---------------------------------------
'INVERT':  BEGIN & CASE os of
            'vms':   res=10
            'Win32': res=10
            'MacOS': res= 6
             ELSE:   res=10
           ENDCASE
           END

           ;Return machine type
           ; ------------------
'MACHINE': BEGIN & CASE os of
            'vms':   res='vms'
            'Win32': res='win'
            'MacOS': res='mac'
             ELSE:   res='unix'
           ENDCASE
           END

           ;Show manual with a browser
           ; -------------------------
'MANUAL' : BEGIN & CASE os of
         'vms':   begin &  res='netscape [lamp.manual]front.htm'
                         cdd=strmid(p1,0,strlen(p1)-1)+'.manual]'
                         id=finefile(cdd+'front.htm',count=cnt)
                         if (cnt eq 0) and (n_elements(p2) eq 1) then  begin
                                     cdd=strmid(p2,0,strlen(p1)-1)+'.manual]'
                                     id =finefile(cdd+'front.htm',count=cnt) & endif
                         if  cnt gt 0 then begin & res='netscape '+cdd+'front.htm'
                                     spawn,res,/NOWAIT
                         endif else  res='http://www.ill.fr/data_treat/lamp/front.html'
                  end
         'Win32': begin &  res=p1+'\manual\front.htm'
                         cdd=p1+'\manual\'
                         id=finefile(cdd+'front.htm',count=cnt)
                         if (cnt eq 0) and (n_elements(p2) eq 1) then  begin
                                     cdd=p2+'\manual\'
                                     id =finefile(cdd+'front.htm',count=cnt) & endif
                         if  cnt gt 0 then begin & res=cdd+'front.htm'
                         endif else res='http://www.ill.fr/data_treat/lamp/front.html'
                         dv=getenv("SystemDrive")
                         Fexpl=dv+'\Program Files\internet explorer\iexplore.exe'
                         a=finefile(Fexpl,count=cnt)
                         if cnt gt 0 then ic='"'+Fexpl+'" '  +res else ic='start '+res
                         IF !version.release ge '5.4' THEN $
                            if strpos(res,'://') lt 0 then spawn,/nowait,/hide,res $
                            else spawn,/nowait,/hide, ic
                  end
         'MacOS': begin
                         res='MOSS'        ; signature de l'application "NetScape"
                         cdd = p1+':manual:'
                         id=finefile(cdd+'front.htm',count=cnt)
                         if (cnt eq 0) and (n_elements(p2) eq 1) then  begin
                                     cdd=p2+':manual:'
                                     id =finefile(cdd+'front.htm',count=cnt) & endif
                         if  cnt gt 0 then begin & res=cdd+'front.htm'
                                     spawn, MACCREATOR='MOSS', res
                         endif else  res='http://www.ill.fr/data_treat/lamp/front.html'
                  end
          ELSE:   begin &  res='http://www.ill.fr/data_treat/lamp/front.htm'
                         ic ='netscape'
                            spawn,'whereis   firefox'  ,ret
                            cnt=strpos(ret,'/firefox')
                            cnt=where([cnt] ge 0)
                            if cnt[0] ge 0 then ic ='firefox'
                         if cnt[0] lt 0 then begin
                            spawn,'whereis   mozilla'  ,ret
                            cnt=strpos(ret,'/mozilla')
                            cnt=where([cnt] ge 0)
                            if cnt[0] ge 0 then ic ='mozilla'   & endif
                         if cnt[0] lt 0 then begin
                            spawn,'whereis   konqueror',ret
                            cnt=strpos(ret,'/konqueror')
                            cnt=where([cnt] ge 0)
                            if cnt[0] ge 0 then ic ='konqueror' & endif
                         if cnt[0] lt 0 then begin
                            spawn,'whereis   opera'    ,ret
                            cnt=strpos(ret,'/opera')
                            cnt=where([cnt] ge 0)
                            if cnt[0] ge 0 then ic ='opera'     & endif
                         if cnt[0] lt 0 then begin
                            spawn,'whereis   netscape' ,ret
                            cnt=where([cnt] ge 0)
                            cnt=strpos(ret,'/netscape')         & endif
                         if cnt[0] lt 0 then begin
                            spawn,'whereis   mosaic'   ,ret
                            cnt=strpos(ret,'/mosaic')
                            cnt=where([cnt] ge 0)
                            if cnt[0] ge 0 then ic ='mosaic'    & endif
                         if os eq 'darwin' then ic ='open'
                         cnt=[0]
                         if cnt[0] ge 0 then begin
                            if strpos(ic,'netscape') ge 0 then ic=ic+" -install -remote 'openURL ("
                            if strpos(ic,'netscape') ge 0 then il=",new-window)'" else il=""
                            cdd   =p1+'/manual/'
                            id=finefile(cdd+'front.htm',count=cnt)
                            if (cnt eq 0) and (n_elements(p2) eq 1) then begin
                                    cdd  =p2+'/manual/'
                                    id   =finefile(cdd+'front.htm',count=cnt) & endif
                            if (cnt gt 0) then res=cdd+'front.htm'
                            spawn ,ic + ' ' + res + il +' &'
                         endif
                  end
           ENDCASE
           END

           ;MAP or not MAP (some devices have problems to add widgets after realizing-> res=1)
           ; -------------
'MAP':     BEGIN & CASE os of
            'MacOS': res=1
            'Win32': IF !version.release lt '5.1' THEN res=1
             ELSE:   res=0
           ENDCASE
           IF !version.release lt '3.6' THEN res=-1
           IF res eq 0 THEN $
              IF (Vs GE 4) THEN $
                  IF !version.release ne '4.0' THEN res=2
           END

           ;Create a directory
           ; -----------------
'MKDIR':   BEGIN & CASE os of
            'vms':   spawn,'create/dir ' +p1
            'MacOS': begin
                 ; D'abord, verifier si c'est possible
                   ii=finefile(p1,count=cnt)

                 ; Si le dossier existe deja, on sort
                   if (cnt gt 0) then return, res

                   FileStart = STRPOS(p1, ':',/reverse_search)+1
                   container = STRMID(p1,0,FileStart)
                   folderName= STRMID(p1,  FileStart, 1000)

                   script = [  'tell application "Finder"', $
                               '   if not (exists folder "' + p1 + '") then', $
                               '           make new folder at container "' + container + '" with properties {name:"' + folderName + '"}' + LF, $
                               '   end if' + LF, $
                               'end tell' ]
                   DO_APPLE_SCRIPT, script
                   res=1
                  end
            'Win32': begin & res=1
                  command_line='mkdir '+p1
                  if !version.release ge '5.4' then CALL_PROCEDURE,'spawn',command_line,/hide $
                                               else CALL_PROCEDURE,'spawn',command_line
                  end
             ELSE: spawn,['mkdir',expand_path(p1)] ,/NOSHELL

           ENDCASE
           END

           ;Return /home/sub_dir
           ; -------------------
'NEWDIR':  BEGIN & CASE os of
            'vms':   res = '[' +p1+ '.'  +p2 +']'
            'Win32': begin & cd,current=mee & res = mee +    '\'  +p2 & end
            'MacOS': res =      p1+ ':'  +p2
             ELSE:   res = '~' +p1+ '/'  +p2
           ENDCASE
           END

           ;Return  path/sub_dir/
           ; --------------------
'NEWSUB':  BEGIN & CASE os of
            'vms':   res =strmid(p1,0,strlen(p1)-1)+ '.' +p2 +']'
            'Win32': res =       p1+ '\'  +p2 +'\'
            'MacOS': res =       p1+ ':'  +p2 +':'
             ELSE:   res =       p1+ '/'  +p2 +'/'
           ENDCASE
           END

           ;Start player p1 file_path is p2/p3
           ; ---------------------------------
'PLAY_ON': BEGIN & CASE os of
            'vms':   begin & p4=0 & spawn, 'playaifc '+p2+p3,/NOWAIT & end
            'Win32': p4=0 ;CAG I haven't got a sound card
            'MacOS': begin
                     script = [  'tell application "' + Lamp_Dir + 'Helpers:SoundMachine 2.1"', $
                                 '    open file "' + p2 + ':' + p3 + '"' + LF, $
                                 'end tell' ]
                     DO_APPLE_SCRIPT, script
                     p4=0
                     res=1
                     end
             ELSE:   spawn, p1+p2+'/'+p3+' &' ,PID=p4
           ENDCASE
           END

           ;Kill player
           ; ----------
'PLAY_OF': BEGIN & CASE os of
            'vms':
            'Win32':
            'MacOS': begin
                   script = [  'tell application "' + Lamp_Dir + 'Helpers:SoundMachine 2.1"', $
                               '    quit', $
                               'end tell' ]
                   DO_APPLE_SCRIPT, script
                   res=1
                   end
             ELSE: spawn, ['kill' , string(p4)] ,/noshell
           ENDCASE
           END

           ;return "path_for_player"
           ; -----------------------
'PLAYER':  BEGIN & CASE os of
            'vms':   res=getenv('playaifc')
            'Win32': res=''
            'MacOS': res='' ;res='SoundMachine 2.1'
            'IRIX':  begin &   res=''
                          spawn,'whereis playaifc',str
                          str=str[n_elements(str)-1]
                          if strpos(str[0],'/playaifc') gt 0 then res='playaifc -rq '
                     end
             ELSE:   res=getenv('playaifc')
           ENDCASE
           END


           ;File extension fs problems (vms)
           ; -------------------------
'POT':     BEGIN & CASE os of
            'vms':   p1=p1+'.'
             ELSE:
           ENDCASE
           END
'POT+':    BEGIN & CASE os of
               'vms':begin
                          j = STRPOS(p1, '.;')
                          if j gt 0 then   p1=STRMID(p1,0,j)+p2+'.' $
                          else     begin
                               if p3 eq 1 then begin
                                  j =STRPOS(p1, ';')
                                  if j gt 0 then p1=STRMID(p1,0,j)+p2 else p1=p1+p2
                               endif else begin
                                  j =STRPOS(p1, '.')
                                  if j gt 0 then p1=STRMID(p1,0,j+1)+p2
                               endelse
                          endelse
                     end
                ELSE:p1=p1+p2
           ENDCASE
           END


           ;Print a PS file p2 to a specified printer_name p1
           ; ------------------------------------------------
'PRINT':   BEGIN & CASE os of
         'vms':  spawn,'print/notify/queue='+p1+' '+p2
         'Win32':begin & kp=!D.name & set_plot,"WIN"
                           DEVICE,print_file=p2 & set_plot,kp & end
         'MacOS':begin
                 ;Do you really want to choose a printer ???
                 ;script = [  'tell application "Finder"',$
                 ;            'print file "' + p2 + '"'  ,$
                 ;            'end tell' ]
                 ;DO_APPLE_SCRIPT, script, RESULT=res
                 ;HANSEN!!
                  lf=STRING(13B)
                  CD,CURRENT=current_directory
                  if strpos(p2,':') lt 0 then p3=current_directory+p2 else p3=p2
                  PRINT,'print ',p3,' on ', p1
                  script=['tell application "Finder"'+lf+'copy file "'+p3+'" to item "'+p1+'"'+lf+'end tell']
                  PRINT,script
                  DO_APPLE_SCRIPT, script;, RESULT=res
                 end
         'linux':begin
                     print, 'lpr -P'+p1+' '+p2
                     spawn,['lpr', '-P'+p1, p2] ,/NOSHELL
                 end
           ELSE: begin
                     if strpos(p2,'_s.') gt 0 then print, 'lp -c -d'+p1+' '+p2 $
                                              else print, 'lp -d'   +p1+' '+p2
                     if strpos(p2,'_s.') gt 0 then spawn,['lp','-c','-d'+p1, p2] ,/NOSHELL $
                                              else spawn,['lp',     '-d'+p1, p2] ,/NOSHELL
                 end
           ENDCASE
           END

           ;Print a file p1 to the default printer
           ; -------------------------------------
'PRT_DEF': BEGIN & CASE os of
         'vms':  spawn,'print '+p1
         'Win32':begin & kp=!D.name & set_plot,"WIN"
                           DEVICE,print_file=p1 & set_plot,kp & end
         'MacOS':begin
                 ;script = [  'tell application "Finder"', $
                 ;            'print file "' + p1 +'"'   , $
                 ;            'end tell' ]
                 ;DO_APPLE_SCRIPT, script, RESULT=res
                 ;HANSEN!!
                  lf=STRING(13B)
                  CD,CURRENT=current_directory
                  if strpos(p1,':') lt 0 then p3=current_directory+p1 else p3=p1
                  PRINT,'print ', p3
                  script = ['tell application "Finder"'+lf+'print file "'+p3+'"'+lf+'end tell']
                  PRINT,script
                  DO_APPLE_SCRIPT, script, RESULT=res
                 end
        'linux': spawn,['lpr', p1] ,/NOSHELL
           ELSE: spawn,['lp' , p1] ,/NOSHELL
           ENDCASE
           END

           ;Color: type of visual
           ; --------------------
'PSEUDO':  BEGIN
           catch,stat
           if stat eq 0 then begin
             CASE os of
            'Win32':
            'linux': ;if (!D.name ne 'Z') and (!D.name ne 'NULL') then device, pseudo_color = 8
            'darwin':;if (!D.name ne 'Z') and (!D.name ne 'NULL') then device, pseudo_color = 8
             ELSE:    if (!D.name ne 'Z') and (!D.name ne 'NULL') then device, pseudo_color = 8
             ENDCASE
            ;if  !D.N_colors lt 256 then begin
               if (!D.flags and 65536) gt 0 then begin
                 window,/free,/pixmap,xsize=50,ysize=50,colors=-30 & wdelete,!d.window & endif
            ;endif
             if (!D.name ne 'Z') and (!D.name ne 'NULL') then device, decomposed = 0
           endif
           catch,/cancel
           END

'SHOWMEM': BEGIN
           fval =0. ;will be in Mega Bytes
           res  = {free:0. , active:0. , inactive:0. , speculative:0. , wired:0.} ;freeMem = free + speculative
                                                                                  ;totFree = free + speculative + inactive
                                                                                  ;totMem  = free + speculative + inactive + active +wired
           catch,stat & if stat eq 0 then begin
           on_ioerror,misMem
           CASE os of
           'Win32':  begin
                      spawn,'wmic os get FreePhysicalMemory | more',mfree,/hide
                      spawn,'wmic ComputerSystem get TotalPhysicalMemory | more',mtotm,/hide
                      mfree = float(mfree[2])/1024.    & res.free   = mfree
                      mtotm = float(mtotm[2])/1024000. & res.active = mtotm - mfree
                     end
           'linux':  begin
                       spawn,['vmstat','-s','-Sm'],out,/noshell
                       if n_elements(out) gt 5 then begin
                        mfree = out[4] & reads,mfree,fval & res.free     = fval
                        mwire = '0.'
                        macti = out[2] & reads,macti,fval & res.active   = fval
                        minac = out[3] & reads,minac,fval & res.inactive = fval
                        mspec = '0.'
                       endif
                     end
           'darwin': begin
                       spawn,['vm_stat'],out,/noshell
                       if n_elements(out) gt 6 then begin
                        mfree = out[1] & idx = strpos(mfree,':')+1 & reads,strmid(mfree,idx)+' 0.',fval & res.free = fval *4096./1024/1024
                        mwire = out[6] & idx = strpos(mwire,':')+1 & reads,strmid(mwire,idx)+' 0.',fval & res.wired = fval *4096./1024/1024
                        macti = out[2] & idx = strpos(macti,':')+1 & reads,strmid(macti,idx)+' 0.',fval & res.active = fval *4096./1024/1024
                        minac = out[3] & idx = strpos(minac,':')+1 & reads,strmid(minac,idx)+' 0.',fval & res.inactive = fval *4096./1024/1024
                        mspec = out[4] & idx = strpos(mspec,':')+1 & reads,strmid(mspec,idx)+' 0.',fval & res.speculative = fval *4096./1024/1024
                       endif
                     end
           ELSE:
           ENDCASE
           endif ;stat eq 0
           misMem: catch,/cancel
           END

           ;Byte Order compatibility
           ; -----------------------
'SWAPER':  BEGIN & CASE os of
         'vms':   if (p1 eq 'uni') or (p1 eq 'mac') then res=1
         'Win32': if (p1 eq 'uni') or (p1 eq 'mac') then res=1
         'linux': if (p1 eq 'uni') or (p1 eq 'mac') then res=1
         'MacOS': if (p1 eq 'vms') or (p1 eq 'win') or (p1 eq 'lin') then res=1
           ELSE:  if (p1 eq 'vms') or (p1 eq 'win') or (p1 eq 'lin') then res=1
           ENDCASE
           END

           ;Zip file p1
           ; ------- --
'ZIP':     BEGIN & CASE os of
         'vms':   res=0
         'Win32': begin & command_line=ziper[0]+' '+p1+' ' ;relies on gzip.exe being in the path
                      if !version.release ge '5.4' then CALL_PROCEDURE,'spawn',command_line,/hide $
                                                   else CALL_PROCEDURE,'spawn',command_line
                  end
         'MacOS': res=0
           ELSE:  begin &  res=1
                      if ziper[0] ne '-' then begin
                            fzip=strmid(p1,0,strpos(p1,'.'))
                            if p2 ne '' then spawn, 'cd '+p2+' ; '+ziper[0]+fzip+' ' +p1
                            if p2 eq '' then spawn, [strsplit(/EXTRACT,strtrim(ziper[0],2),' '), fzip, p1] ,/NOSHELL
                      endif else res=0
                  end
           ENDCASE
           END

           ;UnZip file p1
           ; --------- --
'UNZIP':  BEGIN & CASE os of
         'vms':   res=0
         'Win32': begin & command_line=ziper[1]+' '+p1+' ' ;relies on gzip.exe being in the path
                      if !version.release ge '5.4' then CALL_PROCEDURE,'spawn',command_line,/hide $
                                                   else CALL_PROCEDURE,'spawn',command_line
                  end
         'MacOS': res=0
           ELSE:  begin &  res=1
                      if ziper[0] ne '-' then begin
                            fzip=strmid(p1,0,strpos(p1,'.'))
                            if p2 ne '' then spawn, 'cd '+p2+' ; '+ziper[1]+fzip+' ' +p1
                            if p2 eq '' then spawn, [strsplit(/EXTRACT,strtrim(ziper[1],2),' '), fzip, p1] ,/NOSHELL
                      endif else res=0
                  end
           ENDCASE
           END

           ;Compress file p1
           ; ------- ---- --
'DO_Z':    BEGIN & CASE os of
         'vms':   begin
                      spawn, 'compress -f '+p1
                      spawn, 'rename '+p1+'_Z '+p1+'Z' ,/NOWAIT
                  end
         'Win32': begin & command_line=ziper[2]+' '+p1+' ' ;relies on gzip.exe being in the path
                      if !version.release ge '5.4' then CALL_PROCEDURE,'spawn',command_line,/hide $
                                                   else CALL_PROCEDURE,'spawn',command_line
                  end
         'MacOS':
           ELSE:  spawn, [strsplit(/EXTRACT,strtrim(ziper[2],2),' '), p1] ,/NOSHELL
           ENDCASE
           END

           ;UnCompress file p1
           ; --------- -------
'UN_Z':    BEGIN & CASE os of
         'vms':   spawn, 'gunzip -dfq '+p1
         'Win32': begin & command_line=ziper[3]+' '+p1+' ' ;relies on gzip.exe being in the path
                      if !version.release ge '5.4' then CALL_PROCEDURE,'spawn',command_line,/hide $
                                                   else CALL_PROCEDURE,'spawn',command_line
                  end
         'MacOS': begin
                 ; 'LZIV' = signature de l'application "MacCompress3.2"
                 ; spawn, MACCREATOR='LZIV', p1

                   script = [  'tell application "' + Lamp_Dir + 'Helpers:MacGzip�PPC"',$
                               '    open file "' + p1 + '"',$
                               'end tell' ]

                   DO_APPLE_SCRIPT, script

                 ; MacGzip works in the background
                 ; so we need to wait for the uncompressed files
                   uncompressedFile = STRMID(p1, 0, STRLEN(p1)-2) ; Strip ".Z" suffixe
                   dummy = finefile(uncompressedFile, Count=AreYouThere)
                   WHILE (AreYouThere EQ 0) DO BEGIN
                              Print, "Waiting..."
                              Wait, 0.5
                              dummy = finefile(uncompressedFile, Count=AreYouThere)
                   ENDWHILE

                   res=1
                  end
           ELSE:  spawn, [strsplit(/EXTRACT,strtrim(ziper[3],2),' '), p1] ,/NOSHELL
           ENDCASE
           END

           ;UnCompress file list p1
           ; --------- ------------
'UN_ZLIS': BEGIN & CASE os of
         'vms':   BEGIN
                      ch=p1[0] & n=n_elements(p1)-1
                      if n gt 0 then for i=1,n do ch=ch+' '+p1[i]
                      spawn, 'gunzip -dfq '+ch
                  END
         'Win32': begin ;relies on gzip.exe being in the path
                  for i=0,n_elements(p1)-1 do begin & com_line=ziper[3]+' '+p1[i]+' '
                       if !version.release ge '5.4' then CALL_PROCEDURE,'spawn',com_line,/hide $
                                                    else CALL_PROCEDURE,'spawn',com_line
                  endfor
                  end
         'MacOS':begin
                 ; Get the current dir
                   cd, CURRENT=homeFolder

                 ; Add path
                   fileArray = homeFolder + p1

                   lastFile  = fileArray[n_elements(fileArray)-1]

                 ; Prepare the file list in AppleScript format
                   Build_MacFileListFromArray, fileArray ,macFileList

                 ; Print, "SD :UN_ZLIS :" + macFileList

                   script = [  'tell application "' + Lamp_Dir + 'Helpers:MacGzip�PPC"',$
                               '    open ' + macFileList + LF,$
                               'end tell' ]

                 ; Print, "Quitting idl..."

                   DO_APPLE_SCRIPT, script

                  ; Print, "Returning..."

                  ; MacGzip works in the background
                  ; so we need to wait for the last uncompressed file
                    lastFile = STRMID(lastFile, 0, STRLEN(lastFile)-2) ; Strip ".Z" suffixe
                    dummy = finefile(lastFile, Count=AreYouThere)
                    WHILE (AreYouThere EQ 0) DO BEGIN
                              Print, "Waiting..."
                              Wait, 0.5
                              dummy = finefile(lastFile, Count=AreYouThere)
                    ENDWHILE

                  ; Print, "OK"
                    res=1

                  end
           ELSE:  begin & spli=strsplit(/EXTRACT,ziper[3],' ') & spawn,[spli[0],spli[1],p1],/noshell & end
           ENDCASE
           END

'DEMO':     if  float(!version.release) ge 5.1 then       res=CALL_FUNCTION('lmgr',/DEMO)<1     else res=0
'STUDENT':  if  float(!version.release) ge 5.1 then       res=CALL_FUNCTION('lmgr',/STUDENT)<1  else res=0
'RUNTIME':  if  float(!version.release) ge 5.1 then begin & res=CALL_FUNCTION('lmgr',/RUNTIME)<1     & rus=0
            if  float(!version.release) ge 6.0 then       rus=CALL_FUNCTION('lmgr',/VM)<1  & if rus eq 1 then res=1 & endif else res=0
'EMBEDDED': if  float(!version.release) ge 5.1 then begin & res=CALL_FUNCTION('lmgr',/EMBEDDED)<1    & rus=0
            if  float(!version.release) ge 6.0 then       rus=CALL_FUNCTION('lmgr',/VM)<1  & if rus eq 1 then res=1 & endif else res=0
'VM':       if  float(!version.release) ge 6.0 then       res=CALL_FUNCTION('lmgr',/VM)<1       else res=0
'VERSION':  res=float(!version.release)
'MATLAB':   res=matlab
'SCILAB':   res=scilab

           ;Start a VIEWER (vrml file is lamp.wrl)
           ; -------------------------------------
'VIEWER':  BEGIN & CASE os of
         'vms':  begin & if viewer eq ''  then begin
                           viewer=getenv('VrmlViewer')
                           if viewer eq '' then begin & viewer='-'
                              print,string(7b)+'(no logical VrmlViewer) !!!' & endif
                       endif
                       res=1
                       if viewer ne '-' then begin
                           if n_elements(p1) eq 1 then spawn,'VrmlViewer '+p1,/NOWAIT
                       endif
                 end
         'Win32':res=1
         'MacOS':res=1
          ELSE:  begin & if viewer eq ''  then begin
                           spawn,'whereis webspace',str
                           cnt=strpos(str,'/webspace')   &  cnt=where([cnt] ge 0)
                           if cnt[0] gt 0 then viewer='webspace -remote ' $
                           else begin & spawn,'whereis modelviewer',str
                           cnt=strpos(str,'/modelvie')   &  cnt=where([cnt] ge 0)
                           if cnt[0] gt 0 then viewer='modelviewer -remote ' $
                           else begin & spawn,'whereis vrweb',str
                           cnt=strpos(str,'/vrweb')      &  cnt=where([cnt] ge 0)
                           if cnt[0] gt 0 then viewer='vrweb  -remote ' $
                           else begin & spawn,'whereis ivview',str
                           cnt=strpos(str,'/ivview')     &  cnt=where([cnt] ge 0)
                           if cnt[0] gt 0 then viewer='ivview  '
                           endelse & endelse & endelse
                           if viewer eq '' then viewer=getenv('VrmlViewer')
                           if viewer eq '' then begin & viewer='-'
                              print,string(7b)+'(webspace,modelviewer,vrweb,ivview,$VrmlViewer) not found !!!'
                           endif
                       endif
                       res=1
                       if viewer ne '-' then begin
                             ;if n_elements(p1) eq 1 then spawn,viewer+' '+p1+' &'
                              if n_elements(p1) eq 1 then spawn,[strsplit(/EXTRACT,strtrim(viewer,2),' '), p1, '&'] ,/NOSHELL
                       endif
                     end
           ENDCASE
           END

ELSE:
ENDCASE

RETURN,res
END ; sys_dep
