;update for embedded version 8.1  (     runtime build on 14-Dec-2011)
;update for embedded version 6.4  (old  runtime having the key)
;*******************************


;cd /home/cs/richard/lamp81
;idl81
;source /home/cs/richard/itt/idl/idl81/bin/idl_setup
;idl update81.MAK
; or
;cd /home/cs/richard/lamp64
;idl64
;source /home/cs/richard/itt/idl64/bin/idl_setup
;idl update64.MAK

!quiet=1
!path=!path+':lamp_mac/'
!path=!path+':lamp_mac/readers/'

 VV=!version.release
 VV=strmid (VV,0,1)+strmid (VV,2,1)

 print, "Compiling kernel pieces..." & wait,.1
 
.run stime                            ;Replacing !Stime legacy/stime.pro_
.run lamprt.pro_                      ;P_ENVI, P_ILLproposal, sys_dep('AT_ILL'), Tech doc
.run dids                             ;RUN_COMD, W_accu(congrid([mon],...), RDSET,proposal=, UseSigma=1, PickData, Regular
.run dons                             ;help RDSET,proposal="" , keep Z in splitxyz, com_file,'f.xbu'
.run bens                             ;according to sans_settings
.run liv_lamp                         ;curDIST='8.1'  plot _capsize  mp4
.run sys_dep                          ;/NOSHELL , 'AT_ILL' entry
.run customiz                         ;symbol->symbal
.run liv_objet                        ;Ellipsoide , entering in cell
.run livc_lamp.pro                    ;Restore colors
.run suprplot.pro                     ;mpeg button
.run python_stuff.pro                 ;Available after 8.5

 print, "Compiling macros ..." & wait,.1

.run lamp_mac/set_xy_old              ;Replacing set_xy legacy/set_xy_old.pro_
.run lamp_mac/dial_xbu.pro            ;xbuControl UV int->long
.run lamp_mac/magnet_win.pro          ;isoVolume slider
.run lamp_mac/str_fit.pro             ;Sort->Uniq->Int_tabulated, Tabs, 2Dfit, Sans fits, dti=Z
.run lamp_mac/rdid.pro                ;IN10 reform(), D16 temp2, D10 Analyser, TOF D11, cal D33 IN4 FIGARO,D9 D10,in10 in16b
.run lamp_mac/read_mag.pro            ;.G94 OFFS=1, XDATCAR
.run lamp_mac/read_hdf.pro            ;IN6,D22, IN5(Y), PELICAN, D33, D7, bug imm.ge.n idx1
.run lamp_mac/prox_sheet.pro          ;DIALOG ERROR, join e pv, reload
.run lamp_mac/read_column.pro         ;MESSAGE,/RESET
.run lamp_mac/read_org.pro            ;X,Y,E,dQ
.run lamp_mac/inx_in.pro              ;for BS
.run lamp_mac/write_inx.pro           ;for BS
.run lamp_mac/tee.pro                 ;for BS
.run lamp_mac/teepsd.pro              ;for IN5
.run lamp_mac/psd_hkl.pro             ;psd to hkl reciprocal space
.run lamp_mac/write_org.pro           ;# Call is w1=read_column("file")
.run lamp_mac/radial_at.pro           ;Init intensity at -1E-9 , squared sect.
.run lamp_mac/make_volume.pro         ;Call regular
.run lamp_mac/regular.pro             ;Z direction
.run lamp_mac/readers/read_toftof.pro ;Filename leading 0s + modif Stef + NeXus
.run lamp_mac/readers/read_paxy.pro   ;PAXY
.run lamp_mac/readers/event_file      ;Event mode v0
.run lamp_mac/readers/read_adam       ;h5 files
.run lamp_mac/readers/rdedf.pro       ;new "DataType"
.run lamp_mac/PELICAN/rdid_pel_nx.pro ;PELICAN
.run lamp_mac/V1/read_v1.pro          ;V1
.run lamp_mac/rdfilter.pro            ;Prefix , Suffix

.run lamp_mac/SANS/sans_inst_init.pro ;New
.run lamp_mac/SANS/sans_settings.pro  ;BUTONS, DTHETA, Qrange, IQfactor, Fits, D33, squared merge sectors, (bg)
.run lamp_mac/SANS/sans_sheet.pro     ;None
.run lamp_mac/SANS/sans_log.pro       ;None
.run lamp_mac/SANS/sans_directBeam.pro

.run lamp_mac/periodic_table/paths_utilities.pro
.run lamp_mac/periodic_table/web_utilities.pro
.run lamp_mac/periodic_table/gui_utilities.pro
.run lamp_mac/periodic_table/io_utilities.pro
.run lamp_mac/periodic_table/strings_utilities.pro
.run lamp_mac/periodic_table/lamp_elements_database.pro
.run lamp_mac/periodic_table/parse_compound_string.pro
.run lamp_mac/periodic_table/periodic_table_about.pro
.run lamp_mac/periodic_table/periodic_table.pro

.run lamp_mac/ATOMS/rd_dmol_hdos.pro
.run lamp_mac/ATOMS/nmoldyn3_preread.pro
.run lamp_mac/ATOMS/nmoldyn3_read.pro
.run lamp_mac/ATOMS/xdatcar5.pro
.run lamp_mac/ATOMS/ebands.pro
.run lamp_mac/ATOMS/build_q_w.pro
.run lamp_mac/ATOMS/build_disp_d14.pro
.run lamp_mac/ATOMS/build_disp_d14d51.pro
.run lamp_mac/ATOMS/calc_isf.pro
.run lamp_mac/ATOMS/conv_ins.pro

.run test_unit/lamp_fast_unit_test.pro
.run file_which.pro
.run lmfit
.run comfit
.run svdfit

.run h5_parse
.run h5_create
.run h5_browser

.run query_csv
.run read_csv
.run write_csv

 print, ""
 print, "Saving update"+VV+"a.rt ..." & wait,.1

 save,/routines,filename="update"+VV+"a.rt",/compress
 print, "end"
 print, "enter: mv  update64a.rt /home/cs/lambda/"
 print, "enter: cp  update64a.rt /home/cs/richard/Free_Lamp64/lamp/"
 print, "or"
 print, "enter: mv  update81a.rt /home/cs/lambda/update81a.rt"
 print, "enter: cp  update81a.rt /home/cs/richard/Free_Lamp81/lamp/update81a.rt"
 
;REBUILDS
;********
;cp /home/cs/lambda/macros/*/A_List*.prox /home/cs/richard/Free_Lamp81/lamp/lamp_mac/
;ls -ltr /home/cs/richard/Free_Lamp81/lamp/plug_in/

;cp  update81a.rt /home/cs/richard/Free_Lamp81/lamp/
;mv  update81a.rt /home/cs/lambda/

;cd /home/cs/richard/lamp81
;idl MAK_LAMP.rt
;cp  runtime.sav /home/cs/richard/Free_Lamp81/lamp/Idl/lib/hook/

;FROM IN6LNX
;***********
;ssh -X richard@in6lnx
;cat MAKE_EMBED_81
;tar -hczf lamp_runtime_unixs.tar.gz Free_Lamp81    -->Linux (tar -xzf ...)
;mv        lamp_runtime_unixs.tar.gz /home/cs/lambda/

;FTP
;***
;cd lamp_runtimes
;put /home/cs/lambda/lamp_runtime_unixs.tar.gz lamp_runtime_unixs.tar.gz
;cd Misc/Others
;put /home/cs/richard/Free_Lamp81/lamp/update81a.rt update81a.rt
;put /home/cs/richard/Free_Lamp81/lamp/plug_in/tof_bs81a.rt tof_bs81a.rt
;put /disk3/people/richard/lamp.upd lamp.upd

;WINDOWS
;*******
;transfer update81a.rt,plug-ins,A_List*,read_par.*,/home/cs/richard/lamp81/runtime.sav
;->H:\Program FIles\Free_Lamp81
