;update for embedded version 8.5  (runtime was built on 22-Dec-2015)
;*******************************

;cd /home/cs/richard/lamp85
;idl85
;source /home/cs/richard/exelis/idl85/bin/idl_setup
;idl update85.MAK

!quiet=1
!path=!path+':lamp_mac/'
!path=!path+':lamp_mac/readers/'

 VV=!version.release
 VV=strmid (VV,0,1)+strmid (VV,2,1)

 print, "Compiling kernel pieces..." & wait,.1

 .run lamprt.pro_
 .run dids.pro
 .run suprplot.pro
 .run liv_objet.pro
 
 print, "Compiling macros ..."       & wait,.1

.run lamp_mac/read_hdf.pro            ;more permissive(ADAM), IN16B changes
.run lamp_mac/rdid.pro                ;monitor D16
.run lamp_mac/str_fit.pro             ;QENS
.run lamp_mac/inx_in.pro              ;more permissive
.run lamp_mac/inx.pro
.run lamp_mac/read_mag.pro

.run lamp_mac/SANS/sans_settings.pro  ;par18=par12 (titles) + NIST 2D output
.run lamp_mac/SANS/sans_inst_init.pro ;attenuator values for 2018
.run lamp_mac/SANS/sans_sheet.pro     ;NIST 2D output 
.run lamp_mac/SANS/sans_log.pro       ;Modifs

.run lamp_mac/readers/read_adam.pro      ;h5 files
.run lamp_mac/readers/rdedf.pro          ;new "dataType"
.run lamp_mac/readers/event_file_old.pro ;Event mode (old electronics)
.run lamp_mac/readers/event_file.pro     ;Event mode (new electronics, 2018)
.run defroi

.run lamp_mac/ATOMS/rd_dmol_hdos.pro
.run lamp_mac/ATOMS/calc_isf.pro
.run lamp_mac/ATOMS/build_q_w.pro
.run lamp_mac/ATOMS/conv_ins.pro

.run lamp_mac/tee.pro 

 print, ""
 print, "Saving update"+VV+"a.rt ..." & wait,.1

 save,/routines,filename="update"+VV+"a.rt",/compress
 print, "end"
 print, "enter: mv  update85a.rt /home/cs/lambda/update85a.rt"
 print, "enter: cp  update85a.rt /home/cs/richard/Free_Lamp85/lamp/"
 
;REBUILDS
;********
;cp /home/cs/lambda/macros/*/A_List*.prox /home/cs/richard/Free_Lamp85/lamp/lamp_mac/
;ls -ltr /home/cs/richard/Free_Lamp85/lamp/plug_in/

;cp  update85a.rt /home/cs/richard/Free_Lamp85/lamp/
;mv  update85a.rt /home/cs/lambda/

;cd /home/cs/richard/lamp85
;idl MAK_LAMP.rt
;cp  runtime.sav /home/cs/richard/Free_Lamp85/lamp/Idl85/lib/hook/

;FROM IN6LNX
;***********
;ssh -X richard@in6lnx
;cat MAKE_EMBED_85
;tar -hczf lamp_runtime_unixs.tar.gz Free_Lamp85
;mv        lamp_runtime_unixs.tar.gz /home/cs/lambda/

;FTP
;***
;cd lamp_runtimes
;put /home/cs/lambda/lamp_runtime_unixs.tar.gz lamp_runtime_unixs.tar.gz
;cd Misc/Others
;get lamp.upd
;put /home/cs/richard/Free_Lamp85/lamp/update85a.rt update85a.rt
;put /home/cs/richard/Free_Lamp85/lamp/plug_in/tof_bs85a.rt tof_bs85a.rt
;put lamp.upd

;WINDOWS
;*******
;transfer update85a.rt, plug-ins, A_List*, read_par.*, /home/cs/richard/lamp85/runtime.sav
;->D:\Didier\Free_Lamp85
