function ebands, filename, n_kpts, n_levels
;+
;******* ******
;** User callable
;**
;** The call is e.g. w1=ebands('filename', n_kpts, n_levels)
;**
;** the file to be read is typically EIGENVAL from VASP
;-


;initialise arrays and variables
;n_kpts=10 & n_levels=192
data_all=fltarr(n_kpts, n_levels)
data_one=fltarr(2, n_levels)
junk6=strarr(6) & junk2=strarr(2)
openr,f_in,filename,/get_lun
readf,f_in,junk6 ; skip header
for i=0,n_kpts-1 do begin
  readf,f_in,junk2 ; skip blank and k-pt description
  readf,f_in,data_one ; read eigenvalues
  data_all[i,*]=data_one[1,*] ; copy eigenvalues into
endfor

free_lun, f_in

return, data_all

end
