pro d1breg, w,filename,extension,comment=comment,par=par,bad=bad,datp=datp,nolamp=nolamp
;+
;** ******
;** User callable
;** export header and workspace in a 3 column file
;** Started: Oct-2007 by J. Sanchez-Marcos, ILL-Grenoble
;** updated to new D1B numor format 2012 IPO
;**
;** lamp.cbk is missing !
;-

IF N_ELEMENTS(w[0,*]) GT 1 THEN PRINT,'Attention: This macro does not support yet export of 2-dimensional workspaces!'
IF not keyword_set(datp) THEN take_datp,datp

IF N_ELEMENTS(datp.e) LT N_ELEMENTS(w) THEN mod_datp,datp,'e',SQRT(W)
if n_elements(filename) eq 0 then BEGIN
  IF N_ELEMENTS (W_NUMOR) GT 0 AND N_ELEMENTS(alone) GT 0 THEN BEGIN
    filename=W_NUMOR[alone]
  ENDIF ELSE BEGIN
    filename='d1breg'
  ENDELSE
ENDIF
if n_elements(extension) eq 0 then extension='xy'
datname=filename+'.'+extension
OPENW,dat,datname,/get_lun
if extension ne 'dat' then cross='#' ELSE cross='!'
PRINTF,dat,cross+' ',strmid(datp.other_tit ,0,76)
IF STRLEN(datp.other_tit) GT 76 THEN PRINTF,dat,cross+' ...',strmid(datp.other_tit ,76,72)
PRINTF,dat,cross+' ',strmid(datp.w_tit  ,0,76)
IF STRLEN(datp.w_tit) GT 76 THEN PRINTF,dat,cross+' ... ',strmid(datp.w_tit ,76,72)
IF KEYWORD_SET(comment) THEN PRINTF,dat,cross+' ',comment
PRINTF,dat,cross+''
FOR i=1,20 DO BEGIN
    search='w'+strcompress(string(i),/remove)
    flag=0
    IF N_ELEMENTS(alone) EQ 1 THEN IF i NE alone THEN BEGIN
      FOR j=0,STRLEN(his[alone])-STRLEN(search)-1 DO BEGIN
        test=strmid(his[alone],j,STRLEN(search))
        if test EQ search and flag eq 0 THEN  BEGIN
          PRINTF,dat,cross+'   '+strmid(his[i],0,76)
          IF STRLEN(his[i]) GT 76 THEN PRINTF,dat,cross+' ...'+strmid(his[i] ,76,72)
          flag=1
        ENDIF
      ENDFOR
    ENDIF
ENDFOR
IF N_ELEMENTS(alone) NE 1 THEN alone=0
IF N_ELEMENTS(his) GT alone THEN BEGIN
  PRINTF,dat,cross+'   '+strmid(his[alone],0,76)
  IF STRLEN(his[alone]) GT 76 THEN PRINTF,dat,cross+' ...'+strmid(his[alone] ,76,72)
ENDIF
PRINTF,dat,cross+' Created: ',systime()
IF N_ELEMENTS(lamp_host) EQ 1 THEN PRINTF,dat,cross+'      By: ',lamp_host
if extension ne 'dat' then PRINTF,dat,cross+' x-y-dy to be read by xmgr, gnuplot, igor etc.' ELSE PRINTF,dat,cross+' fullprof : INSTR=10'
PRINTF,dat,cross+' Wave lenght '
PRINTF,dat,format='(A2,F5.3)',cross+' ', datp.p[4]
PRINTF,dat,cross+' Monitor/counts   Counting time/sec '
PRINTF,dat,format='(A2,F15.2,A3,F15.2)',cross+' ', datp.n[0] ,' ', datp.n[1]
PRINTF,dat,cross+' Temperature: Sample, Regulation, Requested '
PRINTF,dat,format='(A1,A10,F9.3,A3,F9.3,A3,F9.3)',cross,' ',datp.p[7] ,' ',datp.p[6] ,' ',datp.p[5]
PRINTF,dat,cross+'  angle  counts   sigma (F9.3,F15.7,F9.2)'
PRINT,'Export of ',N_ELEMENTS(w[*,0,0]), ' cells to ',filename,'.',extension
FOR i=0,N_ELEMENTS(w[*,0,0])-1 DO BEGIN
  IF datp.x[i,0,0] GE 0 THEN BEGIN
    PRINTF,dat,FORMAT='(F9.3,F15.7,F15.4)',datp.x[i,0,0],w[i,0,0]<1E19,datp.e[i,0,0]<1E9
  ENDIF
ENDFOR
; PRINTF,dat,cross+' end of data file'
FREE_LUN,dat
END
