pro logD1B,start,stop,logfiles,ws
;+
;** ******
;** User callable
;** read a log file, modify workspace parameters
;**
;** Started: Oct-2007 by J. Sanchez-Marcos, ILL-Grenoble
;-

OPENR,logfile,logfiles,/get_lun

for i=start,stop do begin

line = ''
linev = ''
;READF, logfile, line


WHILE ~ EOF(logfile) DO BEGIN
   READF, logfile, line
   num=strcompress(STRMID(line, 0, 6),/re)

   num2=strcompress(string(i),/re)

   IF (num EQ num2) THEN BEGIN

      ;Print, num,string(linev) , '*****************************************'
      Reqt=STRMID(linev, UINT(STRPOS(linev, 'Reqt'))+5, 9)
      spt=STRMID(linev, UINT(STRPOS(linev, 'S-pt'))+5, 9)
      regu=STRMID(linev, UINT(STRPOS(linev, 'Regu'))+5, 9)
      samp=STRMID(linev, UINT(STRPOS(linev, 'Samp'))+5, 9)
      print,num, 'Reqt:',Reqt, 'Set point:',spt,'Regulator:',regu,'sample:',samp

      take_datp,datp, w=ws

      datp.p[7]=float(samp)

      datp.p[6]=float(regu)

      datp.p[5]=float(Reqt)

      give_datp,datp, w=ws

      BREAK
   ENDIF

   IF (strcompress(STRMID(line, 0, 6),/re) EQ 'dtctrl') THEN BEGIN
      linev=line
   ENDIF

ENDWHILE
endfor
FREE_LUN,logfile
;logarray
;STRSPLIT(log, ',', ESCAPE='\', /EXTRACT)

end
