pro sumnum2wsD1B,start,stop,step,comment=extracomment,logfile=logfile,normal=norma
;+
;** ***********
;** User callable
;** ????
;**
;** Started: Oct-2007 by J. Sanchez-Marcos, ILL-Grenoble
;-

;@lamp.cbk

IF not KEYWORD_SET(extracomment) THEN comment='' ELSE comment=string(extracomment)

    w21=0 & x21=0 & n21=0 & e21=0 & stati=0 & xcat=0

    ws='1'


    sz=(SIZE(w21))[0]  & nruns=0


  IF KEYWORD_SET(norma) THEN BEGIN
     comment=comment+'Norzalize'

  ENDIF


for i=start,stop-step+1 do begin
      print,'w1=rdrun('+string(i)+')'
      xicute,'w1=rdrun('+string(i)+')'
      take_datp,datp, w=1
      time=datp.p[11]
      timet=datp.p[11]
      IF  KEYWORD_SET(logfile) THEN BEGIN
          IF not datp.p[7] THEN BEGIN
              print, 'log,'+strcompress(string(i))+','+strcompress(string(i))+','+"'"+logfile+"',1"
              xicute, 'log,'+strcompress(string(i))+','+strcompress(string(i))+','+"'"+logfile+"',1"
              take_datp,datp, w=1
          ENDIF
      ENDIF

      tempsam=datp.p[7]
      tempreg=datp.p[6]
      tempreq=datp.p[5]
      tempsamm=datp.p[7]
      tempregm=datp.p[6]
      tempreqm=datp.p[5]
      print, tempsamm
      firstnum=i
  for j=1,step-1 do begin
         print,'w2=rdrun('+string(j+i)+')'
         xicute,'w2=rdrun('+string(j+i)+')'
         print,'w1=w1+w2'
         xicute,'w1=w1+w2'
         take_datp,datp, w=2
         IF  KEYWORD_SET(logfile) THEN BEGIN
             IF not datp.p[7] THEN BEGIN
                 print, 'log,'+strcompress(string(j+i),/re)+','+strcompress(string(j+i),/re)+','+"'"+logfile+"',2"
                 xicute, 'log,'+strcompress(string(j+i),/re)+','+strcompress(string(j+i),/re)+','+"'"+logfile+"',2"
                 take_datp,datp, w=2
             ENDIF
         ENDIF
         tempsamm=tempsamm+datp.p[7]
         tempregm=tempregm+datp.p[6]
         tempreqm=tempreqm+datp.p[5]
         timet=timet+datp.p[11]
  endfor
     tempsamm=tempsamm/step
     tempregm=tempregm/step
     tempreqm=tempreqm/step
     take_datp,datp, w=1
     datp.other_tit=datp.other_tit+' >'+strcompress(string(i+step-1),/re)
     datp.p[7]=tempsamm
     print, datp.p[7]
     print, tempsamm
     datp.p[6]=tempregm
     datp.p[5]=tempreqm
     datp.p[11]=timet
     give_datp,datp, w=1
     lastnum=j-1


  IF KEYWORD_SET(norma) THEN BEGIN
     take_datp,datp, w=1

     normalize= float(norma)/float(datp.n[0])
     xicute,'w1=w1*'+strcompress(string(normalize),/re)

     datp.n[0]=norma

     give_datp,datp, w=1
  ENDIF


     xicute,'e1=sqrt(w1)'

      IF (sz EQ 0) THEN BEGIN      ; 0-dimensional data
         print,'w21=w'+ws
         xicute,'w21=w'+ws
         print,'e21=e'+ws
         xicute,'e21=e'+ws
         print,'n21=n'+ws
         xicute,'n21=n'+ws
         print,'pv21=p'+ws
         xicute, 'pv21=p'+ws
         sz=1
         print, sz
      ENDIF ELSE IF (sz EQ 1) THEN BEGIN      ; 1-dimensional data
         print,'w21=[[w21],[w'+ws+']]'
         xicute,'w21=[[w21],[w'+ws+']]'
         print,'e21=[[e21],[e'+ws+']]'
         xicute,'e21=[[e21],[e'+ws+']]'
         print,'n21=[[n21],[n'+ws+']]'
         xicute,'n21=[[n21],[n'+ws+']]'
         print,'pv21=[[pv21], [p'+ws+'] ]'
         xicute, 'pv21=[[pv21], [p'+ws+'] ]'
         sz=2
      ENDIF ELSE IF (sz EQ 2) THEN BEGIN    ; 2-dimensional data
         print,'w21=[[w21],[w'+ws+']]'
         xicute,'w21=[[w21],[w'+ws+']]'
         print,'e21=[[e21],[e'+ws+']]'
         xicute,'e21=[[e21],[e'+ws+']]'
         print,'n21=[[n21],[n'+ws+']]'
         xicute,'n21=[[n21],[n'+ws+']]'
         print,'pv21=[[pv21], [p'+ws+']]'
         xicute, 'pv21=[[pv21], [p'+ws+']]'
       ENDIF

   i=i+step-1
endfor

xicute,'y21=pv21[7,*]'

end
