;***************************
pro myhelp_salsa, TEXT
;+
;** ************
;** associated with the up left button '?' in main lamp window
;-

;This is effective when the string-array TEXT is more than one element.

text=[$
'*****************************************************************************',$
'* THIS IS A HELP FOR SALSA USERS OF LAMP                                        ',$
'* For information on LAMP, please contact Mark JOHNSON (johnson@ill.fr, 7139) ',$
'*                                      or Didier RICHARD (richard@ill.fr, 7307) ',$
'*****************************************************************************',$
'',$
'READING DATA:',$
'	Chose the correct path with the data acces button',$
'   If recent data are still not transfered, On_Line accesses directly salsa.ill.fr through /net/salsa/users/data',$
'',$
'	Select the workspace with the arrows',$
'	Type the correct numor or numor range in the window and press "read"',$
'	A numor range to be merged is specified with a ">" sign (Ex: 51568>51572)',$
'',$
'	PLEASE NOTE',$
'	The data will be automatically calibrated with the file salsa.cal',$
'   Type "calibration" in a formula window and "DO" to show a list of possible calibration files',$
'   and choose the file you want for calibration with "load"',$
'',$
'******************************************************************************',$
'MANIPULATING DATA',$
' Use STR_fit or GK_fit for simple peak fitting',$
' Use SuperPlot for superposing plots',$
' Use UserMacros for an overview of existing macros',$
' Use DataParameters for looking at fixed parameters for a workspace',$
' Use Options... for changing titles, plot options and printer',$
' Use the command "?" to open a help-window on IDL - the original macro-language to LAMP',$
'*******************************************************************************'$
]

end
