;** **************************************************************
function funlg_to_fit,xinput,sf_new2,i_spectrum
;+
;** **************************************************************
;** On construit la fonction et on convolue par la fonction de resolution
;-
common sc_loc
common sc_lorgau
common sc_convs
common sc_fit
common sc_new
;sf_sp_num_min=workspace number min to fit
;sf_sp_num_max=workspace number max to fit ... not for the moment

;print,'On est y ou pas?'
num_lor=n_l & num_gau=n_g
w_resc2_ispe=w_resc2[*,i_spectrum-1]
aamin=aalpha[i_spectrum-1] & aamax=abeta[i_spectrum-1] & ess_conv=reverse(w_resc[aamin:aamax,i_spectrum-1]) ; REDONDANT ??
falpha=0 & fbeta=nb_channels-1
w_resc2_ispe_all=w_resc[*,i_spectrum-1]

w_to_conv=xinput*0. & w_to_convl=w_to_conv & w_to_convg=w_to_conv
w_to_conv_all=sx_in*0. & w_to_convl_all=w_to_conv_all & w_to_convg_all=w_to_conv_all
i=-1
arr_index=fltarr(1)
if num_lor gt 0 then begin
for il=0,num_lor-1 do begin
i=i+1
lor_to_add=qlorentz(xinput,sf_new2[il*3],sf_new2[il*3+1],sf_new2[il*3+2])
lor_to_add_all=qlorentz(sx_in,sf_new2[il*3],sf_new2[il*3+1],sf_new2[il*3+2])
ind_lor_0=where(lor_to_add ge 1e-10,nn)
if (nn le 7) and (sf_new2[il*3+2] ge 1e-10) then begin
lor_to_add=0.
lor_to_add_all=0.
arr_index=[arr_index,il*3]
                print,'**WARNING: Lorentzian #',il,' has less than 7 points ne 0 ... treat it as a delta function'
                print,'Parameter # IL',il,' is an integrated intensity (no more an amplitude)'
                dcenter=sf_new2[il*3]
                dint=sf_new2[il*3+2] & x_interp=sx_in+dcenter
                lll=dint*spline(x_interp,w_resc2_ispe,sx_in)
                ;print,'**WARNING: Lorentzian #',i,' has less than 7 points ne 0 ... treat it as a delta function'
                ;print,'ParAmater # 3 is an integrated intensity (no more an amplitude)'
;               sf_new2_values(ispect,i*3+1)=0.
;                widget_control,sw_tx_param(i*9+3),set_value='0.0'

endif else lll=convol(lor_to_add_all,ess_conv,total(ess_conv),/edge_truncate)
sf_sub_function[i_spectrum-1,*,i]=lll[*]
w_to_convl=w_to_convl+lor_to_add
w_to_convl_all=w_to_convl_all+lor_to_add_all
endfor
endif
igminind=num_lor*3
if num_gau gt 0 then begin
for ig=0,num_gau-1 do begin
i=i+1
gau_to_add=qgauss(xinput,sf_new2[igminind+ig*3],sf_new2[igminind+ig*3+1],sf_new2[igminind+ig*3+2])
gau_to_add_all=qgauss(sx_in,sf_new2[igminind+ig*3],sf_new2[igminind+ig*3+1],sf_new2[igminind+ig*3+2])
ind_gau_0=where(gau_to_add ge 1e-10,nn)
if (nn le 7) and (sf_new2[igminind+ig*3+2] ge 1e-10) then begin
gau_to_add=0.
gau_to_add_all=0.
arr_index=[arr_index,igminind+ig*3]
                print,'**WARNING: Gaussian #',ig,' has less than 7 points ne 0 ... treat it as a delta function'
                print,'Parameter # IG',ig,' is an integrated intensity (no more an amplitude)'
                dcenter=sf_new2[igminind+ig*3]
                dint=sf_new2[igminind+ig*3+2] & x_interp=sx_in+dcenter
                ggg=dint*spline(x_interp,w_resc2_ispe,sx_in)
                ;print,'**WARNING: Lorentzian #',i,' has less than 7 points ne 0 ... treat it as a delta function'
                ;print,'ParAmater # 3 is an integrated intensity (no more an amplitude)'
;               sf_new2_values(ispect,i*3+1)=0.
;                widget_control,sw_tx_param(i*9+3),set_value='0.0'

endif else ggg=convol(gau_to_add_all,ess_conv,total(ess_conv),/edge_truncate)
sf_sub_function[i_spectrum-1,*,i]=ggg[*]
w_to_convg=w_to_convg+gau_to_add
w_to_convg_all=w_to_convg_all+gau_to_add_all
endfor
endif
; ** Now sum the Lorentzian and Gaussian parts
w_to_conv=w_to_convl+w_to_convg
w_to_conv_all=w_to_convl_all+w_to_convg_all

; ** Now do the convolution with the Resolution function (to be done)
;w_2_fit=convs(w_to_conv,num_spectrum,falpha,fbeta,w_resc2) ; convs is the numerical way of performing the convolution
w_2_fit=convol(w_to_conv,ess_conv,total(ess_conv),/edge_truncate)
w_2_fit_all=convol(w_to_conv_all,ess_conv,total(ess_conv),/edge_truncate)
; ** Now deal with the background
;slope=sf_new2_values(ispecc-1,3*num_lor+3*num_gau+2)
slope=sf_new2[3*num_lor+3*num_gau+2]
;const=sf_new2_values(ispecc-1,3*num_lor+3*num_gau+3)
const=sf_new2[3*num_lor+3*num_gau+3]
i=i+1 & sf_sub_function[i_spectrum-1,*,i]=slope*sx_in[*]+const
w_2_fit=w_2_fit+slope*xinput+const
w_2_fit_all=w_2_fit_all+slope*sx_in+const
; ** ... and multiply by the temperature factor in case of symetric data (detailed balance factor)
w_2_fit=w_2_fit*exp(0.5*betatemp*xinput)
w_2_fit_all=w_2_fit_all*exp(0.5*betatemp*sx_in)

if n_elements(arr_index) gt 1 then begin
; ** Now deal with the line too sharp that we change in res. function
for ic=1,n_elements(arr_index)-1 do begin
;dcenter=sf_new2_values(ispecc-1,arr_index(ic)) & dint=sf_new_values(ispecc-1,arr_index(ic)+2) & x_interp=xinput+dcenter
dcenter=sf_new2[arr_index[ic]] & dint=sf_new2[arr_index[ic]+2] & x_interp=xinput+dcenter
w_2_fit=w_2_fit+dint*spline(x_interp,w_resc2_ispe,xinput)
endfor
endif

; ** Now deal with the elastic line
dcenter=sf_new2[3*num_lor+3*num_gau]
x_interp=xinput+dcenter & x_interp_all=sx_in+dcenter
w_resc2_interp=spline(x_interp,w_resc2_ispe,xinput) & w_resc2_interp_all=spline(x_interp_all,w_resc2_ispe_all,sx_in)
dint=sf_new2[3*num_lor+3*num_gau+1]
w_2_fit=w_2_fit+dint*w_resc2_interp
w_2_fit_all=w_2_fit_all+dint*w_resc2_interp_all
i=i+1 & sf_sub_function[i_spectrum-1,*,i]=dint*w_resc2_interp_all[*]
sf_w_fitted[*,i_spectrum-1]=w_2_fit_all
; ** Do the difference abs(exp-th/exp)
sf_w_exp_fit[*,i_spectrum-1]=sw_in[*,i_spectrum-1]-sf_w_fitted[*,i_spectrum-1]
sf_w_exp_fit_rel[*,i_spectrum-1]=100.*abs((sw_in[*,i_spectrum-1]-sf_w_fitted[*,i_spectrum-1])/sw_in[*,i_spectrum-1])
return,w_2_fit

end

;** **************************************************************
pro fit_basegl2
;+
;** **************************************************************
;** create the base of the fitting routine for a Lor-Gau fit
;
;-
@lamp.cbk
common sc_wid
common sc_loc
common sc_flag
common sc_fit
common sc_convs
common sc_new

name_func='LOR_GAU'

; ** Defining the flag for the L and G click box
; ** *******************************************
flag_lfit=0 & flag_gfit=0 & flag_lcfit=0 & flag_gcfit=0 & flag_lwfit=0
flag_gwfit=0 & flag_lifit=0 & flag_gifit=0
flag_dfit=0 & flag_bfit=0 & flag_dcfit=0 & flag_bcfit=0
flag_difit=0 & flag_bifit=0
flag_lgifit=intarr(num_lor+num_gau+2)
flag_pl_fit2=not flag_pl_fit2
flag_reverse=0 & flag_fromlast=0 & flag_fit2D=0 & flag_sym=0

; ** Defining the widgetID vectors
; ** *****************************
num_subf=num_lor+num_gau+2 & dimlongtx=9*(num_lor+num_gau)+12
ilor=0 & igau=0
if num_lor gt 0 then ilor=1
if num_gau gt 0 then igau=1
;dimlongbu=4*(num_lor+num_gau+ilor+igau)+6
dimlongbu=3*(num_lor+num_gau)+4
sw_tx_param=lonarr(dimlongtx)
sw_tx_cstr=lonarr(dimlongbu)
n_param_1D=3*(num_lor+num_gau)+4 & n_param_2D=nb_spe_tot*n_param_1D

; ** Defining the fit variable vectors
; ** *********************************
sf_index=intarr(nb_spe_tot,3*num_lor+3*num_gau+4)+1 ;& sf_index indicates the fix states of the parameters
lowerb=sf_index*0 & upperb=lowerb & lowerbl=fltarr(nb_spe_tot,3*num_lor+3*num_gau+4) & upperbl=lowerbl;& to indicate eventual parameters limits
sf_tie=strarr(nb_spe_tot,3*num_lor+3*num_gau+4) ;to tie parameters
sf_cstr_write=sf_tie+'1' & sf_cstr_write[*,3*indgen(num_lor+num_gau)+1]='>0' & sf_cstr_write[*,3*indgen(num_lor+num_gau)+2]='>0';to record the string value writen by the user into the constrain text box
sf_cstr_write[*,[n_param_1D-1,n_param_1D-3]]='>0'
sf_new_values=fltarr(nb_spe_tot,3*num_lor+3*num_gau+4) & for ii=0,nb_spe_tot-1 do sf_new_values[ii,3*indgen(num_lor+num_gau)]=center_rf[ii]
sf_new_values[0:nb_spe_tot-1,3*indgen(num_lor+num_gau)+1]=0.1 & sf_new_values[0:nb_spe_tot-1,3*indgen(num_lor+num_gau)+2]=1.
sf_new_values[0:nb_spe_tot-1,3*num_lor+3*num_gau:3*num_lor+3*num_gau+3]=0. & sf_new_values[0:nb_spe_tot-1,3*num_lor+3*num_gau+1]=10.
sf_last_values=fltarr(nb_spe_tot,3*num_lor+3*num_gau+4)
sf_e_values=fltarr(nb_spe_tot,3*num_lor+3*num_gau+4)
sf_sub_function=fltarr(nb_spe_tot,nb_channels,num_lor+num_gau+2)
sf_sub_function_name=strarr(num_subf)
sf_functions_labels=strarr(num_lor*3+num_gau*3+2*2) & sf_functions_labels2=sf_functions_labels
sf_errors_labels=strarr(num_lor*3+num_gau*3+2*2) & sf_errors_labels2=sf_errors_labels
chisqr=fltarr(nb_spe_tot)+1.e30

if (xregistered('fit_base') le 0) then begin

; ** Start definition of the widget object
; ** *************************************

; ** Base for the fit
; ** First Base
sw_ba_bot=widget_base(group_leader=sw_ba_leader, /column, $
          Title='Fitted parameters and errors ',$
          resource_name='lamp')

; ** Now do the Lorentzian functions if any

sw_ba_botup1=widget_base(sw_ba_bot,Frame=2,Title='Base botlow left',/column)


if num_lor gt 0 then begin
for il=1,num_lor do begin
sw_ba_botup=widget_base(sw_ba_botup1,/row)
str_il='L'+string(il) & str_il=strcompress(str_il,/remove_all) & sf_sub_function_name[il-1]=str_il
;sw_la_lor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=40,/align_center)
;
str_il='CL'+string(il) & str_il=strcompress(str_il,/remove_all) 
sw_la_clor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[(il-1)*9]=widget_text(sw_ba_botup,font=font_smaller,value=strcompress(string(center_rf[num_spectrum-1]),/remove_all),/editable,xsize=7,/align_center,uvalue=[6,0,0])
sw_tx_param[(il-1)*9+1]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_param[(il-1)*9+2]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_cstr[(il-1)*3]=widget_text(sw_ba_botup,value='1',/editable,xsize=4,/align_center)
;
str_il='WL'+string(il) & str_il=strcompress(str_il,/remove_all)
sw_la_wlor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[(il-1)*9+3]=widget_text(sw_ba_botup,font=font_smaller,value='0.10',/editable,xsize=7,/align_center,uvalue=[6,0,0])
sw_tx_param[(il-1)*9+4]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_param[(il-1)*9+5]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_cstr[(il-1)*3+1]=widget_text(sw_ba_botup,value='>0',/editable,xsize=4,/align_center)
;
str_il='IL'+string(il) & str_il=strcompress(str_il,/remove_all)
sw_la_ilor=widget_label(sw_ba_botup,value=str_il,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[(il-1)*9+6]=widget_text(sw_ba_botup,font=font_smaller,value='1.00',/editable,xsize=7,/align_center,uvalue=[6,0,0])
sw_tx_param[(il-1)*9+7]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_param[(il-1)*9+8]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_cstr[(il-1)*3+2]=widget_text(sw_ba_botup,value='>0',/editable,xsize=4,/align_center)
sf_functions_labels[(il-1)*3]='Center value for Lor#'+strcompress(string(il),/remove_all)
sf_functions_labels[(il-1)*3+1]='Width value for Lor#'+strcompress(string(il),/remove_all)
sf_functions_labels[(il-1)*3+2]='Intensity value for Lor#'+strcompress(string(il),/remove_all)
sf_errors_labels[(il-1)*3]='with error'
sf_errors_labels[(il-1)*3+1]='with error'
sf_errors_labels[(il-1)*3+2]='with error'
sf_functions_labels2[(il-1)*3]='CL'+strcompress(string(il),/remove_all)
sf_functions_labels2[(il-1)*3+1]='WL'+strcompress(string(il),/remove_all)
sf_functions_labels2[(il-1)*3+2]='IL'+strcompress(string(il),/remove_all)
sf_errors_labels2[(il-1)*3]='ECL'+strcompress(string(il),/remove_all)
sf_errors_labels2[(il-1)*3+1]='EWL'+strcompress(string(il),/remove_all)
sf_errors_labels2[(il-1)*3+2]='EIL'+strcompress(string(il),/remove_all)
endfor
endif
igmin=num_lor*3
igmintx=num_lor*9
igminind=num_lor*3
; ** Now do the Gaussian function if any
if num_gau gt 0 then begin

for ig=1,num_gau do begin
;
sw_ba_botup=widget_base(sw_ba_botup1,/row)
;
str_ig='G'+string(ig) & str_ig=strcompress(str_ig,/remove_all) & sf_sub_function_name[num_lor+ig-1]=str_ig
;sw_la_gau=widget_label(sw_ba_botup,value=str_ig,font=font_smaller,xsize=40,/align_center)
;
str_ig='CG'+string(ig) & str_ig=strcompress(str_ig,/remove_all)
sw_la_cgau=widget_label(sw_ba_botup,value=str_ig,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[igmintx+(ig-1)*9]=widget_text(sw_ba_botup,font=font_smaller,value=strcompress(string(center_rf[num_spectrum-1]),/remove_all),/editable,xsize=7,/align_center,uvalue=[6,0,0])
sw_tx_param[igmintx+(ig-1)*9+1]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_param[igmintx+(ig-1)*9+2]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_cstr[igmin+(ig-1)*3]=widget_text(sw_ba_botup,value='1',/editable,xsize=4,/align_center)
;
str_ig='WG'+string(ig) & str_ig=strcompress(str_ig,/remove_all)
sw_la_wlor=widget_label(sw_ba_botup,value=str_ig,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[igmintx+(ig-1)*9+3]=widget_text(sw_ba_botup,font=font_smaller,value='0.10',/editable,xsize=7,/align_center,uvalue=[6,0,0])
sw_tx_param[igmintx+(ig-1)*9+4]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_param[igmintx+(ig-1)*9+5]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_cstr[igmin+(ig-1)*3+1]=widget_text(sw_ba_botup,value='>0',/editable,xsize=4,/align_center)
;
str_ig='IG'+string(ig) & str_ig=strcompress(str_ig,/remove_all)
sw_la_ilor=widget_label(sw_ba_botup,value=str_ig,font=font_smaller,xsize=30,/align_center);'
sw_tx_param[igmintx+(ig-1)*9+6]=widget_text(sw_ba_botup,font=font_smaller,value='1.00',/editable,xsize=7,/align_center,uvalue=[6,0,0])
sw_tx_param[igmintx+(ig-1)*9+7]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_param[igmintx+(ig-1)*9+8]=widget_text(sw_ba_botup,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_cstr[igmin+(ig-1)*3+2]=widget_text(sw_ba_botup,value='>0',/editable,xsize=4,/align_center)

sf_functions_labels[igmin+(ig-1)*3]='Center value for Gau#'+strcompress(string(ig),/remove_all)
sf_functions_labels[igmin+(ig-1)*3+1]='Width value for Gau#'+strcompress(string(ig),/remove_all)
sf_functions_labels[igmin+(ig-1)*3+2]='Intensity value for Gau#'+strcompress(string(ig),/remove_all)
sf_errors_labels[igmin+(ig-1)*3]='with error'
sf_errors_labels[igmin+(ig-1)*3+1]='with error'
sf_errors_labels[igmin+(ig-1)*3+2]='with error'
sf_functions_labels2[igmin+(ig-1)*3]='CG'+strcompress(string(ig),/remove_all)
sf_functions_labels2[igmin+(ig-1)*3+1]='WG'+strcompress(string(ig),/remove_all)
sf_functions_labels2[igmin+(ig-1)*3+2]='IG'+strcompress(string(ig),/remove_all)
sf_errors_labels2[igmin+(ig-1)*3]='ECG'+strcompress(string(ig),/remove_all)
sf_errors_labels2[igmin+(ig-1)*3+1]='EWG'+strcompress(string(ig),/remove_all)
sf_errors_labels2[igmin+(ig-1)*3+2]='EIG'+strcompress(string(ig),/remove_all)
endfor
endif

; ** The Delta function
; ** ********************************
sw_ba_botlow=widget_base(sw_ba_bot,Frame=2,Title='Base bot right',/column)
idmin=igmin+num_gau*3
idmintx=igmintx+num_gau*9
idminind=igminind+num_gau*3

sw_ba_c1=widget_base(sw_ba_botlow,/row)
;
;sw_la_del=widget_label(sw_ba_c1,value='D ',font=font_smaller,/align_center,xsize=40) & sf_sub_function_name(num_lor+num_gau)='D'
;
sw_la_cdel=widget_label(sw_ba_c1,value='CD',font=font_smaller,xsize=30,/align_center)
sw_tx_param[idmintx]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',/editable,xsize=7,/align_center,uvalue=[6,0,0])
sw_tx_param[idmintx+1]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_param[idmintx+2]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_cstr[idmin]=widget_text(sw_ba_c1,value='1',/editable,xsize=4,/align_center)

sw_la_idel=widget_label(sw_ba_c1,value='ID',font=font_smaller,xsize=30,/align_center)
sw_tx_param[idmintx+3]=widget_text(sw_ba_c1,font=font_smaller,value='1.0',/editable,xsize=7,/align_center,uvalue=[6,0,0])
sw_tx_param[idmintx+4]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_param[idmintx+5]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_cstr[idmin+1]=widget_text(sw_ba_c1,value='>0',/editable,xsize=4,/align_center)

sf_functions_labels[idmin]='Center value for Delta'
sf_functions_labels[idmin+1]='Intensity value for Delta'
sf_errors_labels[idmin]='with error'
sf_errors_labels[idmin+1]='with error'
sf_functions_labels2[idmin]='CD'
sf_functions_labels2[idmin+1]='ID'
sf_errors_labels2[idmin]='ECD'
sf_errors_labels2[idmin+1]='EID'

; ** Now the slopping background
; ** *************************************************
ibmin=idmin+2
ibmintx=idmintx+6
ibminind=idminind+2

sw_ba_c1=widget_base(sw_ba_botlow,/row)
;
;sw_la_bac=widget_label(sw_ba_c1,value='B ',font=font_smaller,/align_center,xsize=40) & sf_sub_function_name(num_subf-1)='B'
;
sw_la_sbac=widget_label(sw_ba_c1,value='SB',font=font_smaller,xsize=30,/align_center)
sw_tx_param[ibmintx]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',/editable,xsize=7,/align_center,uvalue=[6,0,0])
sw_tx_param[ibmintx+1]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_param[ibmintx+2]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_cstr[ibmin]=widget_text(sw_ba_c1,value='1',/editable,xsize=4,/align_center)

sw_la_idel=widget_label(sw_ba_c1,value='CB',font=font_smaller,xsize=30,/align_center)
sw_tx_param[ibmintx+3]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',/editable,xsize=7,/align_center,uvalue=[6,0,0])
sw_tx_param[ibmintx+4]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_param[ibmintx+5]=widget_text(sw_ba_c1,font=font_smaller,value='0.00',xsize=7,/align_center)
sw_tx_cstr[ibmin+1]=widget_text(sw_ba_c1,value='>0',/editable,xsize=4,/align_center)

sf_functions_labels[ibmin]='Slope value for Backg'
sf_functions_labels[ibmin+1]='Constant value for Backg'
sf_errors_labels[ibmin]='with error'
sf_errors_labels[ibmin+1]='with error'
sf_functions_labels2[ibmin]='SB'
sf_functions_labels2[ibmin+1]='CB'
sf_errors_labels2[ibmin]='ESB'
sf_errors_labels2[ibmin+1]='ECB'

; ** Insert the "Try without fitting" button and "fitALL" chekbox
; ** *************************************************************
sw_ba_botlow=widget_base(sw_ba_bot,Frame=2,Title='Base bot right',/column)
sw_ba_c1=widget_base(sw_ba_botlow,/row)
sw_bu_try=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Try and enter',uvalue=[6,0,0])
sw_ba_cb1=widget_base(sw_ba_c1,Title='Fit box2',/nonexclusive,/align_center,/row)
sw_bu_fitall=widget_button(sw_ba_cb1,value=' fit all Sp?',uvalue=[6,2,1],/align_center)
sw_bu_reverse=widget_button(sw_ba_cb1,value=' reverse?',uvalue=[6,2,3],/align_center,sensitive=0)
sw_bu_fromlast=widget_button(sw_ba_cb1,value=' from last?',uvalue=[6,2,4],/align_center,sensitive=0)
sw_bu_fit2D=widget_button(sw_ba_cb1,value=' fit 2D?',uvalue=[6,2,6],/align_center)

; ** Insert the "Acquire from Sp#" button and "Sp#" textbox and symetrization possibility
; ** *************************************************************************************
sw_ba_c1=widget_base(sw_ba_botlow,/row)
sw_bu_acquire=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Acquire from Sp#',uvalue=[6,2,2])
sw_tx_acquire=widget_text(sw_ba_c1,font=font_smaller,value=' 1',/editable,xsize=3,/align_center,uvalue=[6,2,2])
sw_bu_giveall=widget_button(sw_ba_c1,Font=ft_b_smaller,Frame=1,value='Give to All',uvalue=[6,2,7],tooltip='All, c or v for all, constr. or values. P1;c for constraint of parameter P1. See help.')
sw_tx_give=widget_text(sw_ba_c1,font=font_smaller,value=' All',/editable,xsize=7,/align_center,uvalue=[6,2,7])
sw_ba_cb1=widget_base(sw_ba_c1,Title='Fit box1',/nonexclusive,/align_center)
sw_bu_symsqw=widget_button(sw_ba_cb1,value='Sym.S(Q,w)?',/align_center,uvalue=[6,2,5])
sw_tx_temp=widget_text(sw_ba_c1,font=font_smaller,value=' 0',/editable,xsize=7,/align_center,sensitive=0)
sw_la_temp=widget_label(sw_ba_c1,value='K',font=font_smaller,xsize=10,/align_center)
;
;
; ** Realization of the Base
widget_control, sw_ba_bot, /Realize; & put_logo
xmanager,'qens_fit',sw_ba_bot,/just_reg

; ** Set the FIT and DONE button sensitive:
widget_control,sw_bu_fit, sensitive=1
widget_control,sw_bu_done, sensitive=1

endif

end

;** **************************************************************
pro fit_basegl
;+
;** **************************************************************
;** create the base of the fitting routine
;
;-
@lamp.cbk
common sc_wid
common sc_loc
common sc_flag
common sc_fit
common sc_new

if (xregistered('fit_base') le 0) then begin

; ** Start definition of the widget object
; ** *************************************

; ** Base for the fit
sw_ba_bot=widget_base(group_leader=sw_ba_leader, /row, $
          Title='Choose the number of functions to use',$
          resource_name='lamp')
;sw_ba_bot=widget_base(sw_ba_leader,Title='Base row bottom',/row)

; ** First up : button, labels and text boxes
sw_bu_start=widget_button(sw_ba_bot,Font=ft_b_smaller,Frame=2,value='Start',uvalue=[4,0,1])
sw_bu_cancel=widget_button(sw_ba_bot,Font=ft_b_smaller,Frame=2,value='Cancel',uvalue=[4,0,2])
sw_la_nlor=widget_label(sw_ba_bot,Font=ft_b_smaller,value='Number of Lorentzian ?')
sw_tx_nlor=widget_text(sw_ba_bot,Font=ft_b_smaller,/editable,value='1',uvalue=[4,0,1],xsize=2)
sw_la_ngau=widget_label(sw_ba_bot,Font=ft_b_smaller,value='Number of Gaussian ?')
sw_tx_ngau=widget_text(sw_ba_bot,Font=ft_b_smaller,/editable,value='0',uvalue=[4,0,1],xsize=2)

; ** Realization of the Base
widget_control, sw_ba_bot, /Realize; & put_logo
xmanager,'qens_fit',sw_ba_bot,/just_reg

endif

end

