;TEMPORARY ROUTINE WHICH UPDATES THAT ONE CONTAINED IN BENS.PRO
;**************************************************************

function NUMtSTR,x,y
;+
;******* *******
;** TEMPORARY ROUTINE WHICH UPDATES THAT ONE CONTAINED IN BENS.PRO
;** This function converts any number to a string, with `y' digits after
;** the dot. `y' is always less than 7.
;-
   temp=size(y)
   if ((temp[0] eq 0) and (temp[1] eq 1)) then y=4 $
   else y=max([0,min([y,6])])
   temp=size(x)
   res='0'
   if  (temp[0] eq 0) then $
   if ((temp[1] ge 2) and (temp[1] le 5)) then begin & xx=long(x)
      
      if ((temp[1] eq 4) or (temp[1] eq 5)) then begin
         temp=abs(round(10^y*(x-xx)))
         xx  =xx+ float(temp)/10^y
         xl  =long(xx)
         temp=abs(round(10^y*(xx-xl)))
         res =string(xl)
         str =strcompress(('000000'+string(temp)),/remove_all)
         leng=strlen(str)
         str =strmid(str,leng-y,y)
         if ((temp ge 1) and (str ne '')) then res=res+'.'+str
      endif else res=string(xx)
   endif
   return,strcompress(res,/remove_all)
end

pro rgp_groupNum,varAccess,n,disp
;+
;** ************
;** TEMPORARY ROUTINE WHICH UPDATES THAT ONE CONTAINED IN BENS.PRO
;** This procedure calculates the groupings.
;** The range of unmasked angles is searched, and then the list of
;** the sinus of the half-angles is divided into `n' parts, which
;** are of the same width. If a part is empty, ie it does not include
;** any spectrum, it is removed. In a part, the `average' angle is
;** set to the mean value of its limits, and not to the mean of
;** the angles corresponding to the spectra. The 'grouped' spectrum
;** is the average of all the included spectra.
;-

   widget_control,get_uvalue=set,varAccess.settings
   if (n lt 0) then n=set.ngroups $
   else if (set.ngroups eq n) then return $
   else set.ngroups=n
   widget_control,get_uvalue=mask,varAccess.mask
   widget_control,get_uvalue=IDs,varAccess.IDs
   widget_control,get_uvalue=data,varAccess.datAccess.w
   widget_control,get_uvalue=daty,varAccess.datAccess.y
   msk=reform(mask.cur[0,*])
   temp=where(msk ne 0,usedCount)
   if (usedCount le 0) then return
   widget_control,set_uvalue=set,varAccess.settings
   sinList=1000*sin(!pi*msk*daty/360.0)
   temp=where((daty eq 0) and (msk ne 0),count)
   if (count gt 0) then begin
      minSub=min(temp)
      infVal=0
   end else begin
      minSub=min(where(sinList gt 0))
      infVal=sinList[minSub]
   end
   aver=(max(sinList,maxSub)-infVal)/n
   index=intarr(n+1)
   sinAver=(360.0/!pi)*asin(aver/1000*(findgen(n)+0.5))
   index[0]=minSub
   for i=1,n-1 do begin
      infVal=infVal + aver
      temp=where(sinList gt infVal,count)
      if (count ne 0) then index[i]=min(temp) $
      else index[i]=index[i-1]
   end
   index[n]=maxSub+1
   ind=0
   ;;;;; The empty parts are now removed.
   for i=1,n do $
      if (index[i] ne index[ind]) then begin
         ind=ind+1
         index[ind]=index[i]
         sinAver[ind-1]=sinAver[i-1]
      end
   if (ind eq 0) then return
   index=index[0:ind]
   sinAver=sinAver[0:ind-1] + min(daty) ;DID!
   ;;;;; The info label is updated.
   if (ind eq 1) then res='One group.' $
   else res=(NUMtSTR(ind,0) + ' groups.')
   temp=n-ind
   if (temp ne 0) then begin
      if (temp eq 1) then temp='(-1)' $
      else temp=('(-'+NUMtSTR(temp,0) + ')')
      res=(res + temp)
   end
   widget_control,set_value=res,IDs.info[2]
   widget_control,set_uvalue={index:index,sinAver:sinAver},varAccess.groups
   ;;;;; The display is updated if `disp' is set to 1.
   if disp then rgp_drawGroups,varAccess
end
