FUNCTION scant,inum,nbre,nlarg
;+
;** *********************************************************
;** User callable
;** S. Rols 11/01 srols@anl.gov
;** The call is w6=scant(inum,nbre,nlarg)
;** Created on 16/06/03
;**
;** *********************************************************
;-

COMMON c_lamp_access, inst
COMMON printing, iprint, outstring
forward_function rdrun , normalise

temp=fltarr(nbre) & iel=temp & iint=iel & err=iel

for ilect=0,nbre-1 do begin
in=long(inum+ilect*10)
w1=rdrun(in)
w1=normalise(w1)
take_datp,datp
par=datp.p
temp[ilect]=par[11]
iint[ilect]=total(w1)
w_buf=total(w1,2)
if nlarg lt 0 then iel[ilect]=iint[ilect] $
else iel[ilect]=total(w_buf[fix(par[9])-nlarg:fix(par[9])+nlarg],1)
err[ilect]=sqrt(iel[ilect])
endfor

print,'End of program SCANT **'
print,'From run #,',inum,'to #',long(inum+10*nbre-10)

output:mod_datp, datp, "e", err
mod_datp, datp, "x", temp
mod_datp, datp, "y", iint
give_datp, datp
return, iel
end
