pro write_org, FileName , Data , XC=x, YC=y , ZC=z , E=e  , N=n   $
                               , PR=p, PV=pv, P_TXT=p_txt         $
                               , W_tit=wt   , X_tit=xt , Y_TIT=yt $
                               , Z_tit=zt   , OTHER_TIT=ot, SRC=src, HIST=hist $
			                         , PAR_TXT_ALL=pa_txt, LIM=lim, MACH=mach $
                               , DOE=doe, SNAP=snap, DATE=date, FIFI=fifi
;+
;** *********
;**
;**	Call for data-write ascii-column (called by LAMP).
;-
forward_function regular

sz=size(reform(Data)) & sx=size(reform(x)) & if sz[0] ge 2 then sy=size(reform(y)) else sy=size(y)

if (sz[0] eq 0) or (sz[0] gt 3) then begin &    print,"Data size incompatible with this format!!!"   & return & endif

wout=reform(Data) & xout=reform(x) & if sz[0] ge 2 then yout=reform(y) else yout=y
                                     if sz[0] eq 3 then zout=z         else zout=z
if n_elements(E) eq n_elements(wout) then begin & Eout=reform(E) & Eok=1 & endif else begin & Eout=0 & Eok=0 & endelse

if n_elements(Z) eq n_elements(X)    then begin &                  Zok=1 & endif else begin &          Zok=0 & endelse

if (sx[0] ge 2) or (sy[0] ge 2) then begin & datp={X:xout,Y:yout,E:Eout} & newsz=regular(wout,DATP=datp,/GetNewSize)
                                           if newsz[1]*newsz[2] gt 2.*sz[1]*sz[2] then begin
                                              print,"X or Y size incompatible with this format!!!" & return & endif
                                           wout=regular(wout,DATP=datp) & xout=datp.X & yout=datp.Y & Eout=datp.E
                                     endif
sz=size(wout)
                    if n_elements(xout) ne sz[1]   then xout=findgen(sz[1])+1 else xout=float(xout)
if sz[0] ge 2 then  if n_elements(yout) ne sz[2]   then yout=findgen(sz[2])+1 else yout=float(yout)
if sz[0] eq 3 then  if n_elements(zout) ne sz[3]   then zout=findgen(sz[3])+1 else zout=float(zout)

if n_elements(N)  ne 1 then N =0
if n_elements(wt) ne 1 then wt=' ' & if n_elements(xt) ne 1 then xt=' '
if n_elements(yt) ne 1 then yt=' ' & if n_elements(zt) ne 1 then zt=' '

;Seems ok
;********
 if sz[0] ge 2 then if sz[1] ge sz[2]*2. then begin & if sz[0] eq 2 then P=[1,0] else P=[1,0,2]
                                              wout=transpose(wout,P) & tmp=xout  & xout=yout & yout=tmp
                                              tmp=xt & xt=yt & yt=tmp
                                              if Eok then Eout=transpose(Eout,P) & endif
 sz =size(wout) & if sz[0] ge 2 then yy=sz[2] else yy=1
                  if sz[0] eq 3 then zz=sz[3] else zz=1

 wtl=strcompress(wt) & if strpos(wtl,'#') ne 0 then wtl='#' +wtl
 swt='Size:'+strtrim(sz[1],2)+' '+strtrim(yy,2)+' '+strtrim(zz,2) & swt=wtl+' ->'+swt

 if  Eok                   then swt=swt+' Sigma:1' else swt=swt+' Sigma:0' 
 if (Zok) and (sz[0] eq 1) then swt=swt+' Z:1'     else swt=swt+' Z:0'
                                swt=swt+' Moni:'+strtrim(long(N),2)
 if xt gt ' '              then swt=swt+' Xtit:'+strcompress(xt)
 if yt gt ' '              then swt=swt+' Ytit:'+strcompress(yt)
 if zt gt ' '              then swt=swt+' Ztit:'+strcompress(zt)

 ON_IOERROR,mis & u=-1
 if strpos(FileName,'.') le 0 then ext='.txt' else ext=''
 openw,u,FileName+ext,/get_lun

 if sz[0] eq 1 then begin ; *** Vector ***
                        printf,u,swt+' y:'+strtrim(yout[0],2)
                        printf,u,"# Call is w1=read_column('"+FileName+"', header=2)"
  if not Zok then $
  if n_elements(e) eq sz[1] then for i=0,sz[1]-1 do printf,u,xout[i],wout[i],e[i],format='(3(G,X))' $
                            else for i=0,sz[1]-1 do printf,u,xout[i],wout[i]     ,format='(2(G,X))'
  if     Zok then $
  if n_elements(e) eq sz[1] then for i=0,sz[1]-1 do printf,u,xout[i],wout[i],e[i],z[i],format='(4(G,X))' $
                            else for i=0,sz[1]-1 do printf,u,xout[i],wout[i]     ,z[i],format='(3(G,X))'


 endif else begin         ; *** Images ***
  for k=0,zz-1 do begin & printf,u,swt+" z:"+strtrim(zout[k],2) + " Call:w1=read_column('"+FileName+"')"
                        printf,u,'       NaN  ',xout  ,format='(A,' +strtrim(sz[1]  ,2)+'(G,X))'
    for j=0,yy-1  do    printf,u,yout[j]  ,wout[*,j,k],format='('   +strtrim(sz[1]+1,2)+'(G,X))'
    if Eok  then  begin & printf,u,' '
                        printf,u,'       NaN  ',xout  ,format='(A,' +strtrim(sz[1]  ,2)+'(G,X))'
    for j=0,yy-1  do    printf,u,yout[j]  ,Eout[*,j,k],format='('   +strtrim(sz[1]+1,2)+'(G,X))'
    endif
    printf,u,' '
  endfor
 endelse

 free_lun,u
 return
 mis:print,!error_state.msg
 if u gt 0 then free_lun,u
end
