#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

/************************/
int sl_x_parse (argc,argv)
/************/
void	*argv[];
{
static long    *h,*l,*m,*p;
static char    *st1;
static int     *st2;

static int      r;

static Display		*d;
static Window		t;
static XEvent		e;
static XKeyEvent	ke;
static KeySym 		key;
static XComposeStatus	cs;
static char     strang[1] ;
static int      s,n;
static int	ini=0, grab=GrabNotViewable;

p   = (long *) argv[0];  
 
switch (*p)  {

/*getkb*/    case 0 :if (XCheckMaskEvent (d,  KeyReleaseMask, &e)) {
			n=XLookupString(&ke,&strang[0],10,&key,&cs);
			st1 = (char *) argv[1];  
			st2 = (int  *) argv[2];  
			if (n == 1)  {
	   		   *st1 = strang[0];
	   		   *st2 = 0;
	     		     }
			else {
	   		*st1 = 0;
	   		*st2 = key;
			}
    		     }
		     return(1);

/*focusin */ case 1 :r = 1;
		     if (grab != GrabSuccess) {
			 grab  = XGrabKeyboard (d,t,True,GrabModeAsync,GrabModeAsync,CurrentTime);
				 XSync (d,0); 
			 if (grab != GrabSuccess) r=-1;
		     }
		     return(r);

/*focusout*/ case 2 :if (grab == GrabSuccess) {
			XUngrabKeyboard (d,CurrentTime);
			XSync (d,0); 
			grab =  GrabNotViewable;
			}
		     return(1);

/*open    */ case 3 :h  = (long *) argv[1];  
		     l  = (long *) argv[2];  
		     m  = (long *) argv[3];  
		     if (ini != 0) {
		     	     XCloseDisplay (d);
		             ini=0;
			     }
		     r  = 0;
		     if (d = XOpenDisplay (NULL)) {
		    	 s = DefaultScreen (d)  ;
		   	*h = DisplayHeight (d,s);
		   	*l = DisplayWidth  (d,s);
		   	*m = DisplayCells  (d,s);
		    	 t = RootWindow    (d,s);
		             XSelectInput  (d,t,KeyReleaseMask);
			     XFlush (d);
			 r = 1;
		         ini=1;
		         }
		     return(r);

/*close   */ case 4 :if (ini != 0) XCloseDisplay (d);
                     ini = 0;
                     return(1); 

/*kb_check*/ case 5 :r = 0;
		     if (XCheckMaskEvent (d,  KeyReleaseMask, &e)) {
			 XPutBackEvent   (d, &e);
			 XFlush (d);
			 r = 1;
		     }
		     return(r);
		     
/*?????   */ default:return(0);

	     }
}
