$ !
$ ! Script to build the sl_sx on VMS
$ !
$ ! Assumes that sl_sx.c file is in
$ ! the current build directory
$ !
$ 
$ vax = "False"
$ if f$getsyi("HW_MODEL") .le. 1023 then vax = "True"
$
$ decc = "False"
$ if (.not. vax .or. f$search("sys$system:vaxc.exe") .eqs. "")
$ then
$   if f$search("sys$system:decc$compiler.exe") .nes. ""
$   then
$     decc = "True"
$   else
$     write sys$output "C compiler is not available."
$     write sys$output "sl_sx build aborted."
$     exit
$   endif
$ endif
$
$ if decc
$ then
$   define/nolog c$include decw$examples,decw$include,sys$library
$   define/nolog vaxc$include c$include
$   if f$search("sys$library:vaxcdef.tlb") .nes. "" then -
	define/nolog c$library sys$library:vaxcdef.tlb
$   cc = "cc/standard=vaxc"
$ else
$   define/nolog c$include decw$examples,decw$include,sys$library
$   define/nolog vaxc$include c$include
$   if f$search("sys$library:vaxcdef.tlb") .nes. "" then -
	define/nolog c$library sys$library:vaxcdef.tlb
$   cc = "cc"
$ endif
$
$ cc /FLOAT=D_FLOAT sl_sx.c
$ link /share sl_sx,sys$input/opt/exe=sl_sx_AXP.so
symbol_vector=(sl_x_parse=PROCEDURE)
sys$share:decw$mrmlibshr12/share
sys$share:decw$dxmlibshr12/share
sys$share:decw$xmlibshr12/share
sys$share:decw$xtlibshrr5/share
sys$share:decw$xlibshr/share
$
$ exit
