# idl2xref

## R&eacute;f&eacute;rences crois&eacute;es sur un ensemble de fichiers IDL

### Fabrication

`idl2xref` est un outil "ligne de commande", mis au point
avec l'environnement XCode 4.0.2 fourni par Apple, sur un syst&egrave;me OS X 10.6.8.

Les outils autoconf et automake ont permis de produire une archive installable sur 
d'autres syst&egrave;mes, dont les distributions linux.

### Installation

Apres d&eacute;sarchivage de la distribution :

    cd ~/idl2xref-x.x
    ./configure
    make
    
    
Le fichier idl2xref obtenu doit se trouver dans le PATH courant.

Par exemple, vous pouvez le placer dans dans un r&eacute;pertoire `~/bin` (moyennant l'ajout de la ligne
`export PATH=~/bin:$PATH`  dans le fichier `~/.profile` ou `~/.bashrc`...).

Sinon, la commande

    sudo make install
    
mettra l'outil &agrave; disposition de tous les utilisateurs.


## Utilisation 


    idl2xref -o <fichier-destination> <liste de fichiers idl>

L'outil attend une liste de fichier idl en entr&eacute;e (suffixe .pro, par exemple).
L'option `-o` permet de d&eacute;terminer un fichier de destination.

Il va construire la liste des routines d&eacute;finies dans ces fichiers, ainsi que la liste 
des r&eacute;f&eacute;rences sur ces routines. Les r&eacute;f&eacute;rences externes sont ignor&eacute;es.

Par exemple, les commandes suivantes permet d'obtenir le fichier de reference crois&eacute;e du
projet L.A.M.P

    cd ~/lamp
    idl2xref -o ../lampxref.txt `find . -name "*.pro"`  

Si besoin, l'option `-p` permet de suivre le travail effectu&eacute; :

    idl2xref -p -o ../lamponly-xref.txt *.pro


## Cr&eacute;dits

Remerciements au projet idl2matlab, pour la grammaire IDL exprim&eacute;e en LEX/YACC.  
(Azizi Mourier Karim, Benzeghioua Abdeslam, Gardon Lucien, Sylvestre Nadege, Bourtembourg Reynald)


## Contact

[Computing for science, ILL](http://www.ill.eu/instruments-support/computing-for-science/home/)

### Cr&eacute;ateurs

[Didier Richard](mailto:richard@ill.eu)
[Yannick Raoul](mailto:raoul@ill.eu)
